'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _stringFormat;

function _load_stringFormat() {
  return _stringFormat = _interopRequireDefault(require('string-format'));
}

var _lodash;

function _load_lodash() {
  return _lodash = _interopRequireDefault(require('lodash.assignwith'));
}

var _lodash2;

function _load_lodash2() {
  return _lodash2 = _interopRequireDefault(require('lodash.groupby'));
}

var _lodash3;

function _load_lodash3() {
  return _lodash3 = _interopRequireDefault(require('lodash.unionby'));
}

var _lodash4;

function _load_lodash4() {
  return _lodash4 = _interopRequireDefault(require('lodash.find'));
}

var _ignore;

function _load_ignore() {
  return _ignore = _interopRequireDefault(require('ignore'));
}

var _arrayDifference;

function _load_arrayDifference() {
  return _arrayDifference = _interopRequireDefault(require('array-difference'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _bitMap;

function _load_bitMap() {
  return _bitMap = _interopRequireDefault(require('../../../consumer/bit-map'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../../logger/logger'));
}

var _pathNotExists;

function _load_pathNotExists() {
  return _pathNotExists = _interopRequireDefault(require('./exceptions/path-not-exists'));
}

var _missingIdImportedComponent;

function _load_missingIdImportedComponent() {
  return _missingIdImportedComponent = _interopRequireDefault(require('./exceptions/missing-id-imported-component'));
}

var _incorrectIdImportedComponent;

function _load_incorrectIdImportedComponent() {
  return _incorrectIdImportedComponent = _interopRequireDefault(require('./exceptions/incorrect-id-imported-component'));
}

var _noFiles;

function _load_noFiles() {
  return _noFiles = _interopRequireDefault(require('./exceptions/no-files'));
}

var _duplicateIds;

function _load_duplicateIds() {
  return _duplicateIds = _interopRequireDefault(require('./exceptions/duplicate-ids'));
}

var _emptyDirectory;

function _load_emptyDirectory() {
  return _emptyDirectory = _interopRequireDefault(require('./exceptions/empty-directory'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee8(componentPaths, id, main, namespace, tests, exclude, override) {

    // update test files according to dsl
    var getFiles = function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(files, testFiles) {
        var _this = this;

        var fileList, fileListRes, uniq;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                fileList = testFiles.map(function () {
                  var _ref5 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(dsl) {
                    var fileList;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            fileList = files.map(function () {
                              var _ref6 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(file) {
                                var fileInfo, generatedFile, matches;
                                return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
                                  while (1) {
                                    switch (_context.prev = _context.next) {
                                      case 0:
                                        fileInfo = (0, (_utils || _load_utils()).calculateFileInfo)(file);
                                        generatedFile = (0, (_stringFormat || _load_stringFormat()).default)(dsl, fileInfo);
                                        _context.next = 4;
                                        return (0, (_utils || _load_utils()).glob)(generatedFile, { ignore: ignoreList });

                                      case 4:
                                        matches = _context.sent;
                                        return _context.abrupt('return', matches.filter(function (match) {
                                          return (_fsExtra || _load_fsExtra()).default.existsSync(match);
                                        }));

                                      case 6:
                                      case 'end':
                                        return _context.stop();
                                    }
                                  }
                                }, _callee, _this);
                              }));

                              return function (_x11) {
                                return _ref6.apply(this, arguments);
                              };
                            }());
                            return _context2.abrupt('return', Promise.all(fileList));

                          case 2:
                          case 'end':
                            return _context2.stop();
                        }
                      }
                    }, _callee2, _this);
                  }));

                  return function (_x10) {
                    return _ref5.apply(this, arguments);
                  };
                }());
                _context3.t0 = (_ramda || _load_ramda()).default;
                _context3.next = 4;
                return Promise.all(fileList);

              case 4:
                _context3.t1 = _context3.sent;
                fileListRes = _context3.t0.flatten.call(_context3.t0, _context3.t1);
                uniq = (_ramda || _load_ramda()).default.uniq(fileListRes);
                return _context3.abrupt('return', uniq.map(function (testFile) {
                  var relativeToConsumer = getPathRelativeToProjectRoot(testFile, consumer.getPath());
                  return (0, (_utils || _load_utils()).pathNormalizeToLinux)(relativeToConsumer);
                }));

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getFiles(_x8, _x9) {
        return _ref4.apply(this, arguments);
      };
    }();

    var addOneComponent = function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7(componentPathsStats, consumer, gitIgnoreFiles) {
        var _this2 = this;

        // remove excluded files from file list
        var removeExcludedFiles = function () {
          var _ref8 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(mapValues, excludedList) {
            var files, resolvedExcludedFiles;
            return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    files = (_ramda || _load_ramda()).default.flatten(mapValues.map(function (x) {
                      return x.files.map(function (i) {
                        return i.relativePath;
                      });
                    }));
                    _context4.next = 3;
                    return getFiles(files, excludedList);

                  case 3:
                    resolvedExcludedFiles = _context4.sent;

                    mapValues.forEach(function (mapVal) {
                      var mainFile = (0, (_utils || _load_utils()).pathNormalizeToLinux)(mapVal.mainFile);
                      if (resolvedExcludedFiles.includes(mainFile)) {
                        mapVal.files = [];
                      } else mapVal.files = mapVal.files.filter(function (key) {
                        return !resolvedExcludedFiles.includes(key.relativePath);
                      }); // if mainFile is excluded, exclude all files
                    });

                  case 5:
                  case 'end':
                    return _context4.stop();
                }
              }
            }, _callee4, this);
          }));

          return function removeExcludedFiles(_x15, _x16) {
            return _ref8.apply(this, arguments);
          };
        }();

        // used for updating main file if exists or doesn't exists


        var mergeTestFilesWithFiles = function () {
          var _ref9 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(files) {
            var testFilesArr, resolvedTestFiles;
            return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    if ((_ramda || _load_ramda()).default.isEmpty(tests)) {
                      _context5.next = 6;
                      break;
                    }

                    _context5.next = 3;
                    return getFiles(files.map(function (file) {
                      return file.relativePath;
                    }), tests);

                  case 3:
                    _context5.t0 = _context5.sent;
                    _context5.next = 7;
                    break;

                  case 6:
                    _context5.t0 = [];

                  case 7:
                    testFilesArr = _context5.t0;
                    resolvedTestFiles = testFilesArr.map(function (testFile) {
                      return {
                        relativePath: testFile,
                        test: true,
                        name: (_path || _load_path()).default.basename(testFile)
                      };
                    });
                    return _context5.abrupt('return', (0, (_lodash3 || _load_lodash3()).default)(resolvedTestFiles, files, 'relativePath'));

                  case 10:
                  case 'end':
                    return _context5.stop();
                }
              }
            }, _callee5, this);
          }));

          return function mergeTestFilesWithFiles(_x17) {
            return _ref9.apply(this, arguments);
          };
        }();

        var bitMap, addMainFileToFiles, componentExists, parsedId, foundId, updateIdAccordingToExistingComponent, idOrFoundID, mapValuesP, mapValues, componentId, files, groupedComponents, uniqComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                addMainFileToFiles = function addMainFileToFiles(files, mainFile) {
                  if (mainFile && mainFile.match((_constants || _load_constants()).REGEX_PATTERN)) {
                    files.forEach(function (file) {
                      var fileInfo = (0, (_utils || _load_utils()).calculateFileInfo)(file.relativePath);
                      var generatedFile = (0, (_stringFormat || _load_stringFormat()).default)(mainFile, fileInfo);
                      var foundFile = (_ramda || _load_ramda()).default.find((_ramda || _load_ramda()).default.propEq('relativePath', generatedFile))(files);
                      if (foundFile) {
                        mainFile = foundFile.relativePath;
                      }
                      if ((_fsExtra || _load_fsExtra()).default.existsSync(generatedFile) && !foundFile) {
                        files.push({ relativePath: generatedFile, test: false, name: (_path || _load_path()).default.basename(generatedFile) });
                        mainFile = generatedFile;
                      }
                    });
                  }
                  var resolvedMainFile = void 0;
                  if (mainFile) {
                    var mainPath = (_path || _load_path()).default.join(consumer.getPath(), consumer.getPathRelativeToConsumer(mainFile));
                    if ((_fsExtra || _load_fsExtra()).default.existsSync(mainPath)) {
                      resolvedMainFile = consumer.getPathRelativeToConsumer(mainPath);
                    } else {
                      resolvedMainFile = mainFile;
                    }
                  }
                  mainFile = resolvedMainFile;
                  return resolvedMainFile;
                };

                bitMap = consumer.bitMap;
                componentExists = false;
                parsedId = void 0;
                foundId = void 0;

                updateIdAccordingToExistingComponent = function updateIdAccordingToExistingComponent(currentId) {
                  var existingComponentId = bitMap.getExistingComponentId(currentId);
                  componentExists = !!existingComponentId;
                  if (componentExists && bitMap.getComponent(existingComponentId).origin === (_constants || _load_constants()).COMPONENT_ORIGINS.NESTED) {
                    throw new Error(`One of your dependencies (${existingComponentId}) has already the same namespace and name. 
      If you're trying to add a new component, please choose a new namespace or name.
      If you're trying to update a dependency component, please re-import it individually`);
                  }

                  if (componentExists) foundId = existingComponentId;
                  parsedId = existingComponentId ? (_bitId || _load_bitId()).BitId.parse(existingComponentId) : (_bitId || _load_bitId()).BitId.parse(currentId);
                };

                idOrFoundID = foundId || id;


                if (idOrFoundID) {
                  updateIdAccordingToExistingComponent(idOrFoundID);
                }

                _context7.next = 10;
                return Object.keys(componentPathsStats).map(function () {
                  var _ref10 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(componentPath) {
                    var relativeComponentPath, absoluteComponentPath, splitPath, lastDir, nameSpaceOrDir, matches, _files, _resolvedMainFile, resolvedPath, pathParsed, relativeFilePath, dirName, absPath, nameSpaceOrLastDir, files, resolvedMainFile;

                    return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
                      while (1) {
                        switch (_context6.prev = _context6.next) {
                          case 0:
                            if (!componentPathsStats[componentPath].isDir) {
                              _context6.next = 18;
                              break;
                            }

                            relativeComponentPath = getPathRelativeToProjectRoot(componentPath, consumer.getPath());
                            absoluteComponentPath = (_path || _load_path()).default.resolve(componentPath);
                            splitPath = absoluteComponentPath.split((_path || _load_path()).default.sep);
                            lastDir = splitPath[splitPath.length - 1];
                            nameSpaceOrDir = namespace || splitPath[splitPath.length - 2];
                            _context6.next = 8;
                            return (0, (_utils || _load_utils()).glob)((_path || _load_path()).default.join(relativeComponentPath, '**'), {
                              cwd: consumer.getPath(),
                              nodir: true,
                              ignore: gitIgnoreFiles
                            });

                          case 8:
                            matches = _context6.sent;

                            if (matches.length) {
                              _context6.next = 11;
                              break;
                            }

                            throw new (_emptyDirectory || _load_emptyDirectory()).default();

                          case 11:
                            _files = matches.map(function (match) {
                              return { relativePath: (0, (_utils || _load_utils()).pathNormalizeToLinux)(match), test: false, name: (_path || _load_path()).default.basename(match) };
                            });

                            // merge test files with files

                            _context6.next = 14;
                            return mergeTestFilesWithFiles(_files);

                          case 14:
                            _files = _context6.sent;
                            _resolvedMainFile = addMainFileToFiles(_files, (0, (_utils || _load_utils()).pathNormalizeToLinux)(main));
                            // matches.forEach((match) => {
                            //   if (keepDirectoryName) {
                            //     files[match] = match;
                            //   } else {
                            //     const stripMainDir = match.replace(`${relativeComponentPath}${path.sep}`, '');
                            //     files[stripMainDir] = match;
                            //   }
                            // });

                            if (!parsedId) {
                              parsedId = (_bitId || _load_bitId()).BitId.getValidBitId(nameSpaceOrDir, lastDir);
                            }

                            return _context6.abrupt('return', { componentId: parsedId, files: _files, mainFile: _resolvedMainFile });

                          case 18:
                            // is file
                            resolvedPath = (_path || _load_path()).default.resolve(componentPath);
                            pathParsed = (_path || _load_path()).default.parse(resolvedPath);
                            relativeFilePath = getPathRelativeToProjectRoot(componentPath, consumer.getPath());

                            if (!parsedId) {
                              dirName = pathParsed.dir;

                              if (!dirName) {
                                absPath = (_path || _load_path()).default.resolve(componentPath);

                                dirName = (_path || _load_path()).default.dirname(absPath);
                              }
                              nameSpaceOrLastDir = namespace || (_ramda || _load_ramda()).default.last(dirName.split((_path || _load_path()).default.sep));

                              parsedId = (_bitId || _load_bitId()).BitId.getValidBitId(nameSpaceOrLastDir, pathParsed.name);

                              updateIdAccordingToExistingComponent(parsedId.toString());
                            }

                            files = [{ relativePath: (0, (_utils || _load_utils()).pathNormalizeToLinux)(relativeFilePath), test: false, name: (_path || _load_path()).default.basename(relativeFilePath) }];
                            _context6.next = 25;
                            return mergeTestFilesWithFiles(files);

                          case 25:
                            files = _context6.sent;
                            resolvedMainFile = addMainFileToFiles(files, main);
                            // const mainFile = componentExists ? resolvedMainFile : relativeFilePath;

                            return _context6.abrupt('return', { componentId: parsedId, files, mainFile: resolvedMainFile });

                          case 28:
                          case 'end':
                            return _context6.stop();
                        }
                      }
                    }, _callee6, _this2);
                  }));

                  return function (_x18) {
                    return _ref10.apply(this, arguments);
                  };
                }());

              case 10:
                mapValuesP = _context7.sent;
                _context7.next = 13;
                return Promise.all(mapValuesP);

              case 13:
                mapValues = _context7.sent;

                if (!exclude) {
                  _context7.next = 17;
                  break;
                }

                _context7.next = 17;
                return removeExcludedFiles(mapValues, exclude);

              case 17:
                componentId = mapValues[0].componentId;

                mapValues = mapValues.filter(function (mapVal) {
                  return !(Object.keys(mapVal.files).length === 0);
                });

                if (!(mapValues.length === 0)) {
                  _context7.next = 21;
                  break;
                }

                return _context7.abrupt('return', { componentId, files: [] });

              case 21:
                if (!(mapValues.length === 1)) {
                  _context7.next = 23;
                  break;
                }

                return _context7.abrupt('return', mapValues[0]);

              case 23:
                files = mapValues.reduce(function (a, b) {
                  return a.concat(b.files);
                }, []);
                groupedComponents = (0, (_lodash2 || _load_lodash2()).default)(files, 'relativePath');
                uniqComponents = Object.keys(groupedComponents).map(function (key) {
                  return (_lodash || _load_lodash()).default.apply(undefined, [{}].concat(_toConsumableArray(groupedComponents[key]), [function (val1, val2) {
                    return val1 || val2;
                  }]));
                });
                return _context7.abrupt('return', { componentId, files: uniqComponents, mainFile: (_ramda || _load_ramda()).default.head(mapValues).mainFile });

              case 27:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      return function addOneComponent(_x12, _x13, _x14) {
        return _ref7.apply(this, arguments);
      };
    }();

    var warnings, validatePaths, groupFilesByComponentId, addOrUpdateExistingComponentsInBitMap, validateNoDuplicateIds, addToBitMap, getPathRelativeToProjectRoot, consumer, bitMap, bitJson, ignoreList, importedComponents, distDirsOfImportedComponents, gitIgnore, missingFiles, componentPathsStats, resolvedComponentPathsWithGitIgnore, resolvedComponentPathsWithoutGitIgnore, diff, resolvedTestFiles, isMultipleComponents, added, testToRemove, addedP, addedComponents, addedOne, addedResult;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            getPathRelativeToProjectRoot = function getPathRelativeToProjectRoot(componentPath, projectRoot) {
              if (!componentPath) return componentPath;
              var absPath = (_path || _load_path()).default.resolve(componentPath);
              return (_path || _load_path()).default.relative(projectRoot, absPath);
            };

            groupFilesByComponentId = function groupFilesByComponentId(componentId, files, bitMap) {
              var filesWithId = files.map(function (file) {
                var foundComponentFromBitMap = bitMap.getComponentObjectOfFileByPath(file.relativePath);
                var bitMapComponentId = !(_ramda || _load_ramda()).default.isEmpty(foundComponentFromBitMap) ? Object.keys(foundComponentFromBitMap)[0] : undefined;
                return { componentId: bitMapComponentId || componentId, file };
              });
              var groudComponentIdsFile = (_ramda || _load_ramda()).default.groupBy(function (componentFromMap) {
                return componentFromMap.componentId;
              });
              return groudComponentIdsFile(filesWithId);
            };

            validatePaths = function validatePaths(fileArray) {
              var componentPathsStats = {};
              fileArray.forEach(function (componentPath) {
                if (!(0, (_utils || _load_utils()).existsSync)(componentPath)) {
                  throw new (_pathNotExists || _load_pathNotExists()).default(componentPath);
                }
                componentPathsStats[componentPath] = {
                  isDir: (0, (_utils || _load_utils()).isDir)(componentPath)
                };
              });
              return componentPathsStats;
            };

            warnings = {};

            /**
             * validatePaths - validate if paths entered by user exist and if not throw error
             *
             * @param {string[]} fileArray - array of paths
             * @returns {Object} componentPathsStats
             */

            /**
             * Group files by componentId
             *
             * @param {BitId} componentId - consumer path
             * @param {Object[]} files consumer bitMap
             * @returns {ComponentMap[]} componentMap
             */

            /**
             * Add or update existing(imported and new) components according to bitmap
             *
             * @param {string} consumerPath - consumer path
             * @param {BitMap} bitmap consumer bitMap
             * @param {Object} component - component to add
             * @returns {ComponentMap[]} componentMap
             */
            addOrUpdateExistingComponentsInBitMap = function addOrUpdateExistingComponentsInBitMap(consumerPath, bitmap, component) {
              var groupedById = groupFilesByComponentId(component.componentId, component.files, bitmap);
              var addedComponents = Object.keys(groupedById).map(function (bitMapComponentId) {
                var parsedBitId = (_bitId || _load_bitId()).BitId.parse(bitMapComponentId);
                var files = groupedById[bitMapComponentId].map(function (_ref2) {
                  var file = _ref2.file;
                  return file;
                });
                var foundComponentFromBitMap = bitmap.getComponent(bitMapComponentId);
                if (foundComponentFromBitMap) {
                  component.files = files.map(function (file) {
                    if (!(0, (_utils || _load_utils()).isAutoGeneratedFile)((_path || _load_path()).default.join(consumerPath, file.relativePath))) {
                      if (bitMapComponentId && foundComponentFromBitMap.rootDir) {
                        // throw error in case user didnt add id to imported component or the id is incorrect
                        if (!id) throw new (_missingIdImportedComponent || _load_missingIdImportedComponent()).default(parsedBitId.toStringWithoutVersion());
                        if (parsedBitId.toStringWithoutScopeAndVersion() !== id && parsedBitId.toStringWithoutVersion() !== id) {
                          throw new (_incorrectIdImportedComponent || _load_incorrectIdImportedComponent()).default(parsedBitId.toStringWithoutVersion(), id);
                        }

                        var tempFile = (_path || _load_path()).default.relative(foundComponentFromBitMap.rootDir, file.relativePath);
                        var foundFile = (0, (_lodash4 || _load_lodash4()).default)(foundComponentFromBitMap.files, function (file) {
                          return file.relativePath === tempFile;
                        });

                        if (foundFile) {
                          foundFile.relativePath = (_path || _load_path()).default.join(foundComponentFromBitMap.rootDir, foundFile.relativePath);
                          return foundFile;
                        }
                      }
                      // not imported component file but exists in bitmap
                      if (bitmap.getComponentIdByPath(file.relativePath) !== parsedBitId.toString()) {
                        if (warnings[bitMapComponentId]) warnings[bitMapComponentId].push(file.relativePath);else warnings[bitMapComponentId] = [file.relativePath];
                      }
                      return file;
                    }
                  }).filter(function (file) {
                    return !(_ramda || _load_ramda()).default.isNil(file);
                  });
                  component.componentId = (_bitId || _load_bitId()).BitId.parse(bitMapComponentId);
                  return addToBitMap(bitMap, component);
                }
                // if id is not in bitmap check that files are not tracked by another component
                component.files = files.map(function (file) {
                  var bitMapid = bitmap.getComponentIdByPath(file.relativePath);
                  if (bitMapid) {
                    if (warnings[bitMapComponentId]) warnings[bitMapid].push(file.relativePath);else warnings[bitMapid] = [file.relativePath];
                  } else {
                    return file;
                  }
                }).filter(function (x) {
                  return x;
                });
                if (!(_ramda || _load_ramda()).default.isEmpty(component.files)) return addToBitMap(bitMap, component);
              }).filter(function (x) {
                return x;
              });
              return addedComponents;
            };

            // used to validate that no two files where added with the same id in the same bit add command


            validateNoDuplicateIds = function validateNoDuplicateIds(addComponents) {
              var duplicateIds = {};
              var newGroupedComponents = (0, (_lodash2 || _load_lodash2()).default)(addComponents, 'componentId');
              Object.keys(newGroupedComponents).forEach(function (key) {
                return newGroupedComponents[key].length > 1 ? duplicateIds[key] = newGroupedComponents[key] : '';
              });
              if (!(_ramda || _load_ramda()).default.isEmpty(duplicateIds) && !(_ramda || _load_ramda()).default.isNil(duplicateIds)) throw new (_duplicateIds || _load_duplicateIds()).default(duplicateIds);
            };

            addToBitMap = function addToBitMap(bitmap, _ref3) {
              var componentId = _ref3.componentId,
                  files = _ref3.files,
                  mainFile = _ref3.mainFile;

              bitMap.addComponent({
                componentId,
                files,
                mainFile,
                origin: (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED,
                override
              });
              return { id: componentId.toString(), files: bitMap.getComponent(componentId).files };
            };

            _context8.next = 9;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 9:
            consumer = _context8.sent;
            bitMap = consumer.bitMap;
            _context8.next = 13;
            return consumer.bitJson;

          case 13:
            bitJson = _context8.sent;
            ignoreList = (0, (_utils || _load_utils()).retrieveIgnoreList)(consumer.getPath());

            if (!bitJson.distTarget) {
              importedComponents = bitMap.getAllComponents((_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED);
              distDirsOfImportedComponents = Object.keys(importedComponents).map(function (key) {
                return (_path || _load_path()).default.join(importedComponents[key].rootDir, (_constants || _load_constants()).DEFAULT_DIST_DIRNAME, '**');
              });

              ignoreList = ignoreList.concat(distDirsOfImportedComponents);
            }

            // add ignore list
            gitIgnore = (0, (_ignore || _load_ignore()).default)().add(ignoreList);
            // check unknown test files

            missingFiles = (0, (_utils || _load_utils()).getMissingTestFiles)(tests);

            if ((_ramda || _load_ramda()).default.isEmpty(missingFiles)) {
              _context8.next = 20;
              break;
            }

            throw new (_pathNotExists || _load_pathNotExists()).default(missingFiles);

          case 20:
            componentPathsStats = {};
            _context8.t0 = (_ramda || _load_ramda()).default;
            _context8.next = 24;
            return Promise.all(componentPaths.map(function (componentPath) {
              return (0, (_utils || _load_utils()).glob)(componentPath);
            }));

          case 24:
            _context8.t1 = _context8.sent;
            resolvedComponentPathsWithGitIgnore = _context8.t0.flatten.call(_context8.t0, _context8.t1);

            resolvedComponentPathsWithGitIgnore = gitIgnore.filter(resolvedComponentPathsWithGitIgnore);

            _context8.t2 = (_ramda || _load_ramda()).default;
            _context8.next = 30;
            return Promise.all(componentPaths.map(function (componentPath) {
              return (0, (_utils || _load_utils()).glob)(componentPath);
            }));

          case 30:
            _context8.t3 = _context8.sent;
            resolvedComponentPathsWithoutGitIgnore = _context8.t2.flatten.call(_context8.t2, _context8.t3);


            // Run diff on both arrays to see what was filtered out because of the gitignore file
            diff = (0, (_arrayDifference || _load_arrayDifference()).default)(resolvedComponentPathsWithGitIgnore, resolvedComponentPathsWithoutGitIgnore);

            if (!(!(_ramda || _load_ramda()).default.isEmpty(tests) && id && (_ramda || _load_ramda()).default.isEmpty(resolvedComponentPathsWithoutGitIgnore))) {
              _context8.next = 42;
              break;
            }

            _context8.t4 = (_ramda || _load_ramda()).default;
            _context8.next = 37;
            return Promise.all(tests.map(function (componentPath) {
              return (0, (_utils || _load_utils()).glob)(componentPath);
            }));

          case 37:
            _context8.t5 = _context8.sent;
            resolvedTestFiles = _context8.t4.flatten.call(_context8.t4, _context8.t5);

            componentPathsStats = validatePaths(resolvedTestFiles);
            _context8.next = 49;
            break;

          case 42:
            if (!(_ramda || _load_ramda()).default.isEmpty(resolvedComponentPathsWithoutGitIgnore)) {
              _context8.next = 44;
              break;
            }

            throw new (_pathNotExists || _load_pathNotExists()).default(componentPaths);

          case 44:
            if ((_ramda || _load_ramda()).default.isEmpty(resolvedComponentPathsWithGitIgnore)) {
              _context8.next = 48;
              break;
            }

            componentPathsStats = validatePaths(resolvedComponentPathsWithGitIgnore);
            _context8.next = 49;
            break;

          case 48:
            throw new (_noFiles || _load_noFiles()).default(diff);

          case 49:
            // if a user entered multiple paths and entered an id, he wants all these paths to be one component
            isMultipleComponents = Object.keys(componentPathsStats).length > 1 && !id;
            added = [];

            if (!isMultipleComponents) {
              _context8.next = 70;
              break;
            }

            (_logger || _load_logger()).default.debug('bit add - multiple components');

            if ((_ramda || _load_ramda()).default.isEmpty(tests)) {
              _context8.next = 59;
              break;
            }

            _context8.next = 56;
            return getFiles(Object.keys(componentPathsStats), tests);

          case 56:
            _context8.t6 = _context8.sent;
            _context8.next = 60;
            break;

          case 59:
            _context8.t6 = [];

          case 60:
            testToRemove = _context8.t6;

            testToRemove.forEach(function (test) {
              return delete componentPathsStats[(_path || _load_path()).default.normalize(test)];
            });
            addedP = Object.keys(componentPathsStats).map(function (onePath) {
              return addOneComponent({
                [onePath]: componentPathsStats[onePath]
              }, consumer, ignoreList);
            });
            _context8.next = 65;
            return Promise.all(addedP);

          case 65:
            addedComponents = _context8.sent;

            validateNoDuplicateIds(addedComponents);
            addedComponents.forEach(function (component) {
              if (!(_ramda || _load_ramda()).default.isEmpty(component.files)) {
                var addedComponent = addOrUpdateExistingComponentsInBitMap(consumer.projectPath, bitMap, component);
                added.push(addedComponent); // addOrUpdateExistingComponentsInBitMap(consumer.projectPath, bitMap, component);
              }
            });
            _context8.next = 75;
            break;

          case 70:
            (_logger || _load_logger()).default.debug('bit add - one component');
            // when a user enters more than one directory, he would like to keep the directories names
            // so then when a component is imported, it will write the files into the original directories

            _context8.next = 73;
            return addOneComponent(componentPathsStats, consumer, ignoreList);

          case 73:
            addedOne = _context8.sent;

            if (!(_ramda || _load_ramda()).default.isEmpty(addedOne.files)) {
              addedResult = addOrUpdateExistingComponentsInBitMap(consumer.projectPath, bitMap, addedOne);

              added.push(addedResult);
            }

          case 75:
            _context8.next = 77;
            return bitMap.write();

          case 77:
            return _context8.abrupt('return', { addedComponents: (_ramda || _load_ramda()).default.flatten(added.filter(function (component) {
                return !(_ramda || _load_ramda()).default.isEmpty(component.files);
              })), warnings });

          case 78:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));

  function addAction(_x, _x2, _x3, _x4, _x5, _x6, _x7) {
    return _ref.apply(this, arguments);
  }

  return addAction;
}();