'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/**
 * Creates a new component, writes it to the file system and adds to bit.map
 */
exports.default = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(idRaw) {
    var withSpecs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var writeBitJson = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var force = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    var consumer, id, bitPath, defaultImpl, files, mainFile, component;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 2:
            consumer = _context.sent;
            id = (_bitId || _load_bitId()).BitId.parse(idRaw);
            bitPath = consumer.composeRelativeBitPath(id);
            defaultImpl = consumer.bitJson.getImplBasename();
            files = { [defaultImpl]: defaultImpl };
            mainFile = defaultImpl;
            component = (_component || _load_component()).default.create({
              name: id.name,
              box: id.box,
              withSpecs,
              files,
              mainFile,
              consumerBitJson: consumer.bitJson,
              bitPath,
              consumer
            }, consumer.scope);
            _context.next = 11;
            return component.write({ writeBitJson, force, driver: consumer.driver, origin: (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED });

          case 11:
            _context.next = 13;
            return consumer.bitMap.write();

          case 13:
            return _context.abrupt('return', component);

          case 14:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function create(_x4) {
    return _ref.apply(this, arguments);
  }

  return create;
}();
//# sourceMappingURL=create.js.map