'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var getComponentsToExport = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(ids, consumer, remote) {
    var componentsList, exportPendingComponents, componentsFromBitMap, idsFromBitMap, idsFromObjects, idsToExport;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            componentsList = new (_componentsList || _load_componentsList()).default(consumer);

            if (!(!ids || !ids.length)) {
              _context.next = 7;
              break;
            }

            _context.next = 4;
            return componentsList.listExportPendingComponents();

          case 4:
            exportPendingComponents = _context.sent;

            exportPendingComponents.length > 1 ? (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_EXPORTS) : (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_EXPORT);
            return _context.abrupt('return', exportPendingComponents);

          case 7:
            _context.next = 9;
            return componentsList.getFromBitMap();

          case 9:
            componentsFromBitMap = _context.sent;
            idsFromBitMap = Object.keys(componentsFromBitMap);
            _context.next = 13;
            return componentsList.idsFromObjects();

          case 13:
            idsFromObjects = _context.sent;

            // the ids received from the CLI may be missing the scope-name, try to get the complete ids from bit.map
            idsToExport = ids.map(function (id) {
              var parsedId = (_bitId || _load_bitId()).BitId.parse(id);
              if (parsedId.scope) return id;
              var match = idsFromBitMap.find(function (idStr) {
                return parsedId.toString() === (_bitId || _load_bitId()).BitId.parse(idStr).toStringWithoutScopeAndVersion();
              });
              if (match) {
                var matchParsed = (_bitId || _load_bitId()).BitId.parse(match);
                // The match received from bit.map has a version number and if this version is the same as the component from the
                // objects, it means that this version was already exported. Otherwise, the version from bit.map would be lower
                // than the one from the objects, because we update bit.map after the export is completed.
                // It is fine though to re-export a component to another scope.
                if (idsFromObjects.includes(match) && matchParsed.scope === remote) {
                  throw new (_idExportedAlready || _load_idExportedAlready()).default(match, remote);
                }
                return (_bitId || _load_bitId()).BitId.parse(match).toStringWithoutVersion();
              }
              return id;
            });

            (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_EXPORT); // show single export
            return _context.abrupt('return', idsToExport);

          case 17:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getComponentsToExport(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var addToBitJson = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(ids, consumer) {
    var _this = this;

    var bitJsonDependencies, componentsIdsP;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            bitJsonDependencies = consumer.bitJson.getDependencies();
            componentsIdsP = ids.map(function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(componentId) {
                return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        if (!bitJsonDependencies.find(function (bitJsonDependency) {
                          return bitJsonDependency.toStringWithoutVersion() === componentId.toStringWithoutVersion();
                        })) {
                          _context2.next = 3;
                          break;
                        }

                        _context2.next = 3;
                        return consumer.bitJson.addDependency(componentId).write({ bitDir: consumer.getPath() });

                      case 3:
                        return _context2.abrupt('return', componentId);

                      case 4:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, _this);
              }));

              return function (_x6) {
                return _ref3.apply(this, arguments);
              };
            }());
            return _context3.abrupt('return', Promise.all(componentsIdsP));

          case 3:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function addToBitJson(_x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

var linkComponents = function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(ids, consumer) {
    var _ref5, components;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return consumer.loadComponents(ids);

          case 2:
            _ref5 = _context4.sent;
            components = _ref5.components;

            (0, (_links || _load_links()).linkComponentsToNodeModules)(components, consumer);

          case 5:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function linkComponents(_x7, _x8) {
    return _ref4.apply(this, arguments);
  };
}();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _consumerComponent;

function _load_consumerComponent() {
  return _consumerComponent = _interopRequireDefault(require('../../../consumer/component/consumer-component'));
}

var _componentsList;

function _load_componentsList() {
  return _componentsList = _interopRequireDefault(require('../../../consumer/component/components-list'));
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../../../cli/loader'));
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../../../cli/loader/loader-messages');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _idExportedAlready;

function _load_idExportedAlready() {
  return _idExportedAlready = _interopRequireDefault(require('./exceptions/id-exported-already'));
}

var _links;

function _load_links() {
  return _links = require('../../../links');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var _ref6 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(ids, remote, save, eject) {
    var consumer, idsToExport, componentsIds;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 2:
            consumer = _context5.sent;
            _context5.next = 5;
            return getComponentsToExport(ids, consumer, remote);

          case 5:
            idsToExport = _context5.sent;

            if (!(_ramda || _load_ramda()).default.isEmpty(idsToExport)) {
              _context5.next = 8;
              break;
            }

            return _context5.abrupt('return', []);

          case 8:
            _context5.next = 10;
            return consumer.scope.exportMany(idsToExport, remote, undefined, eject);

          case 10:
            componentsIds = _context5.sent;

            if (!eject) {
              _context5.next = 13;
              break;
            }

            return _context5.abrupt('return', consumer.eject(componentsIds));

          case 13:
            if (!save) {
              _context5.next = 16;
              break;
            }

            _context5.next = 16;
            return addToBitJson(componentsIds, consumer);

          case 16:
            componentsIds.map(function (componentsId) {
              return consumer.bitMap.updateComponentId(componentsId);
            });
            _context5.next = 19;
            return consumer.bitMap.write();

          case 19:
            _context5.next = 21;
            return linkComponents(componentsIds, consumer);

          case 21:
            return _context5.abrupt('return', componentsIds);

          case 22:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  function exportAction(_x9, _x10, _x11, _x12) {
    return _ref6.apply(this, arguments);
  }

  return exportAction;
}();