'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = list;

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('../../../consumer/exceptions');
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../../../cli/loader'));
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../../../cli/loader/loader-messages');
}

var _remotes;

function _load_remotes() {
  return _remotes = _interopRequireDefault(require('../../../remotes/remotes'));
}

var _remote;

function _load_remote() {
  return _remote = _interopRequireDefault(require('../../../remotes/remote'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function list(_ref) {
  var scopeName = _ref.scopeName,
      cache = _ref.cache,
      showRemoteVersion = _ref.showRemoteVersion;

  var remoteList = function remoteList(remote) {
    (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_REMOTE_LIST);
    return remote.list();
  };
  var scopeList = function scopeList(scope) {
    return cache ? scope.list(showRemoteVersion) : scope.listStage();
  };

  return (0, (_consumer || _load_consumer()).loadConsumer)().then(function (consumer) {
    var scope = consumer.scope;

    if (scopeName) {
      return scope.remotes().then(function (remotes) {
        return remotes.resolve(scopeName, scope.name).then(remoteList);
      });
    }

    return scopeList(scope);
  }).catch(function (err) {
    if (!(err instanceof (_exceptions || _load_exceptions()).ConsumerNotFound)) throw err;

    if (scopeName) {
      return (_remotes || _load_remotes()).default.getScopeRemote(scopeName).then(remoteList);
    }

    return (0, (_scope || _load_scope()).loadScope)(process.cwd()).catch(function () {
      return Promise.reject(err);
    }).then(scopeList).catch(function (e) {
      return Promise.reject(e);
    });
  });
}