'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = reset;

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../../../cli/loader'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../../../cli/loader/loader-messages');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function reset(_ref) {
  var id = _ref.id;

  return (0, (_consumer || _load_consumer()).loadConsumer)().then(function (consumer) {
    var bitId = (_bitId || _load_bitId()).BitId.parse(id);
    (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_RESET_ACTION);
    return consumer.scope.reset({ bitId, consumer }).then(function (c) {
      // const inlineId = new InlineId({ box: bitId.box, name: bitId.name });
      // const inlineBitPath = inlineId.composeComponentPath(consumer.getPath());
      // return c.component.write(inlineBitPath, true);
    });
  });
}