'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../../../cli/loader'));
}

var _componentsList;

function _load_componentsList() {
  return _componentsList = _interopRequireDefault(require('../../../consumer/component/components-list'));
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../../../cli/loader/loader-messages');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(id, verbose) {
    var _this = this;

    var consumer, getComponents, components;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 2:
            consumer = _context2.sent;

            getComponents = function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
                var idParsed, component, componentsList, components;
                return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        if (!id) {
                          _context.next = 6;
                          break;
                        }

                        idParsed = (_bitId || _load_bitId()).BitId.parse(id);
                        _context.next = 4;
                        return consumer.loadComponent(idParsed);

                      case 4:
                        component = _context.sent;
                        return _context.abrupt('return', [component]);

                      case 6:
                        componentsList = new (_componentsList || _load_componentsList()).default(consumer);

                        (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_LOADING_COMPONENTS);
                        _context.next = 10;
                        return componentsList.newAndModifiedComponents();

                      case 10:
                        components = _context.sent;
                        _context.next = 13;
                        return consumer.scope.buildMultiple(components, consumer, verbose);

                      case 13:
                        return _context.abrupt('return', components);

                      case 14:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function getComponents() {
                return _ref2.apply(this, arguments);
              };
            }();

            _context2.next = 6;
            return getComponents();

          case 6:
            components = _context2.sent;
            return _context2.abrupt('return', consumer.scope.testMultiple(components, consumer, verbose));

          case 8:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  function test(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return test;
}();
//# sourceMappingURL=test.js.map