'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../../api/scope');
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../../logger/logger'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Delete = function (_Command) {
  _inherits(Delete, _Command);

  function Delete() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Delete);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Delete.__proto__ || Object.getPrototypeOf(Delete)).call.apply(_ref, [this].concat(args))), _this), _this.name = '_delete <path> <args>', _this.private = true, _this.description = 'remove a component from a scope', _this.alias = '', _this.opts = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Delete, [{
    key: 'action',
    value: function action(_ref2) {
      var _ref3 = _slicedToArray(_ref2, 2),
          path = _ref3[0],
          args = _ref3[1];

      var _unpackCommand = (0, (_utils || _load_utils()).unpackCommand)(args),
          payload = _unpackCommand.payload,
          headers = _unpackCommand.headers;

      (_logger || _load_logger()).default.info('Checking if a migration is needed');
      var scopePath = (0, (_utils || _load_utils()).fromBase64)(path);
      return (0, (_consumer || _load_consumer()).migrate)(scopePath, false).then(function () {
        return (0, (_scope || _load_scope()).remove)({ path: scopePath, ids: payload.bitIds, force: payload.force }, headers);
      });
    }
  }, {
    key: 'report',
    value: function report(str) {
      return (0, (_utils || _load_utils()).packCommand)((0, (_utils || _load_utils()).buildCommandMessage)(str));
    }
  }]);

  return Delete;
}((_command || _load_command()).default);

exports.default = Delete;