'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ttyTable;

function _load_ttyTable() {
  return _ttyTable = _interopRequireDefault(require('tty-table'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../../api/scope');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../scope/models/component'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CatScope = function (_Command) {
  _inherits(CatScope, _Command);

  function CatScope() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, CatScope);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CatScope.__proto__ || Object.getPrototypeOf(CatScope)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'cat-scope [scopePath]', _this.description = 'cat a scope and show all the contents', _this.private = true, _this.alias = '', _this.opts = [['f', 'full', 'show all of the objects in the scope'], ['j', 'json', 'print the results as a json object']], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(CatScope, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 1),
          scopePath = _ref4[0];

      var full = _ref3.full,
          json = _ref3.json;

      return (0, (_scope || _load_scope()).catScope)(scopePath || process.cwd(), full).then(function (payload) {
        return { payload, full, json };
      });
    }
  }, {
    key: 'report',
    value: function report(_ref5) {
      var payload = _ref5.payload,
          full = _ref5.full,
          json = _ref5.json;

      if (json) {
        return JSON.stringify(payload);
      }
      if (!full) {
        var header = [{ value: 'Id', width: 70, headerColor: 'cyan' }, { value: 'Object', width: 50, headerColor: 'cyan' }];
        var opts = {
          align: 'left'
        };

        var table = new (_ttyTable || _load_ttyTable()).default(header, [], opts);
        payload.forEach(function (co) {
          return table.push([co.id(), `obj: ${co.hash().toString()}`]);
        });
        return table.render();
      }

      return payload.map(function (co) {
        return `> ${co.hash().toString()}\n\n${co.id()}\n`;
      }).join('\n');
    }
  }]);

  return CatScope;
}((_command || _load_command()).default);

exports.default = CatScope;