'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

var _scope;

function _load_scope() {
  return _scope = require('../../../api/scope');
}

var _chalkBox;

function _load_chalkBox() {
  return _chalkBox = require('../../chalk-box');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CiUpdate = function (_Command) {
  _inherits(CiUpdate, _Command);

  function CiUpdate() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, CiUpdate);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CiUpdate.__proto__ || Object.getPrototypeOf(CiUpdate)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'ci-update <id> [scopePath]', _this.description = 'run an update for build and test of a certain bit-component', _this.alias = '', _this.opts = [['v', 'verbose [boolean]', 'showing npm verbose output for inspection'], ['d', 'directory [file]', 'directory to run ci-update'], ['k', 'keep', 'keep test environment after run (default false)'], ['o', 'output [file]', 'save ci results to file system']], _this.private = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(CiUpdate, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 2),
          id = _ref4[0],
          scopePath = _ref4[1];

      var _ref3$verbose = _ref3.verbose,
          verbose = _ref3$verbose === undefined ? false : _ref3$verbose,
          directory = _ref3.directory,
          output = _ref3.output,
          _ref3$keep = _ref3.keep,
          keep = _ref3$keep === undefined ? false : _ref3$keep;

      verbose = true; // During ci-update we always want to see verbose outputs
      return (0, (_scope || _load_scope()).ciUpdateAction)(id, scopePath || process.cwd(), verbose, directory, keep).then(function (_ref5) {
        var specsResults = _ref5.specsResults,
            dists = _ref5.dists,
            mainFile = _ref5.mainFile;
        return { specsResults, dists, mainFile, output, directory };
      });
    }
  }, {
    key: 'report',
    value: function report(_ref6) {
      var specsResults = _ref6.specsResults,
          dists = _ref6.dists,
          mainFile = _ref6.mainFile,
          output = _ref6.output,
          directory = _ref6.directory;

      if (!specsResults && !dists) {
        return 'no results found';
      }

      if (specsResults instanceof Error) {
        return specsResults.message;
      }
      if (dists instanceof Error) {
        return dists.message;
      }
      // check if there is build results
      if (output && dists) {
        var ci = {};
        ci.specResults = specsResults;
        ci.mainDistFile = mainFile;
        ci.cwd = directory || process.cwd;
        ci.buildResults = dists;
        (0, (_utils || _load_utils()).outputJsonFile)(output, ci);
      }

      return (0, (_chalkBox || _load_chalkBox()).paintCiResults)({ specsResults, dists });
    }
  }]);

  return CiUpdate;
}((_command || _load_command()).default);

exports.default = CiUpdate;