'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../../api/scope');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ResolverSet = function (_Command) {
  _inherits(ResolverSet, _Command);

  function ResolverSet() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ResolverSet);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ResolverSet.__proto__ || Object.getPrototypeOf(ResolverSet)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'set <resolverPath>', _this.description = 'set remote resolver to scope (use from scope directory)', _this.alias = 's', _this.private = true, _this.opts = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ResolverSet, [{
    key: 'action',
    value: function action(_ref2) {
      var _ref3 = _slicedToArray(_ref2, 1),
          resolverPath = _ref3[0];

      if (!resolverPath) {
        // @TODO mandatory arguments do not work for sub commands - please fix !
        throw new Error('resolverPath is mandatory');
      }

      return (0, (_scope || _load_scope()).setResolver)(process.cwd(), resolverPath).then(function () {
        return resolverPath;
      });
    }
  }, {
    key: 'report',
    value: function report(resolverPath) {
      return `resovler path has changed successfully to - ${(_chalk || _load_chalk()).default.yellow(resolverPath)}`;
    }
  }]);

  return ResolverSet;
}((_command || _load_command()).default);

var ResolverReset = function (_Command2) {
  _inherits(ResolverReset, _Command2);

  function ResolverReset() {
    var _ref4;

    var _temp2, _this2, _ret2;

    _classCallCheck(this, ResolverReset);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, (_ref4 = ResolverReset.__proto__ || Object.getPrototypeOf(ResolverReset)).call.apply(_ref4, [this].concat(args))), _this2), _this2.name = 'reset', _this2.description = 'reset remote resolver to default resolver', _this2.alias = 'r', _this2.opts = [], _temp2), _possibleConstructorReturn(_this2, _ret2);
  }

  _createClass(ResolverReset, [{
    key: 'action',
    value: function action() {
      return (0, (_scope || _load_scope()).resetResolver)(process.cwd());
    }
  }, {
    key: 'report',
    value: function report() {
      return 'resovler path has successfully reset to default';
    }
  }]);

  return ResolverReset;
}((_command || _load_command()).default);

var Resolver = function (_Command3) {
  _inherits(Resolver, _Command3);

  function Resolver() {
    var _ref5;

    var _temp3, _this3, _ret3;

    _classCallCheck(this, Resolver);

    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return _ret3 = (_temp3 = (_this3 = _possibleConstructorReturn(this, (_ref5 = Resolver.__proto__ || Object.getPrototypeOf(Resolver)).call.apply(_ref5, [this].concat(args))), _this3), _this3.name = 'resolver', _this3.description = 'get or set remote resolver to scope', _this3.alias = '', _this3.opts = [], _this3.commands = [new ResolverSet(), new ResolverReset()], _this3.private = true, _temp3), _possibleConstructorReturn(_this3, _ret3);
  }

  _createClass(Resolver, [{
    key: 'action',
    value: function action() {
      return (0, (_scope || _load_scope()).getResolver)(process.cwd());
    }
  }, {
    key: 'report',
    value: function report(resovlerPath) {
      if (!resovlerPath) {
        return 'there is no resolver path, bit uses the default resolver';
      }

      return (_chalk || _load_chalk()).default.yellow(resovlerPath);
    }
  }]);

  return Resolver;
}((_command || _load_command()).default);

exports.default = Resolver;