'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var chalk = require('chalk');

var Build = function (_Command) {
  _inherits(Build, _Command);

  function Build() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Build);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Build.__proto__ || Object.getPrototypeOf(Build)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'build [id]', _this.description = 'build any set of components with configured compiler (component compiler or as defined in bit.json)', _this.alias = '', _this.opts = [['v', 'verbose [boolean]', 'showing npm verbose output for inspection']], _this.loader = true, _this.migration = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Build, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 1),
          id = _ref4[0];

      var _ref3$verbose = _ref3.verbose,
          verbose = _ref3$verbose === undefined ? false : _ref3$verbose;

      if (!id) return (0, (_consumer || _load_consumer()).buildAll)(verbose);
      return (0, (_consumer || _load_consumer()).build)(id, verbose);
    }
  }, {
    key: 'report',
    value: function report(res) {
      var noCompilerSpecifiedError = chalk.red('compiler is not defined, please define a compiler in bit.json');
      if (!res) return noCompilerSpecifiedError;
      if (Array.isArray(res)) {
        return chalk.cyan(res.join('\n'));
      }
      if (typeof res === 'object') {
        // got from build-all
        // $FlowFixMe - res is an object
        if ((0, (_utils || _load_utils()).empty)(res)) return chalk.yellow('nothing to build');
        return Object.keys(res).map(function (component) {
          var title = chalk.bold(component);
          // $FlowFixMe - res is an object
          var content = Array.isArray(res[component]) ? chalk.cyan(res[component].join('\n')) : noCompilerSpecifiedError;
          return `${title}\n${content}\n`;
        }).join('\n');
      }
      // $FlowFixMe - res is a string
      return res;
    }
  }]);

  return Build;
}((_command || _load_command()).default);

exports.default = Build;