'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Deprecate = function (_Command) {
  _inherits(Deprecate, _Command);

  function Deprecate() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Deprecate);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Deprecate.__proto__ || Object.getPrototypeOf(Deprecate)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'deprecate <ids...>', _this.description = 'deprecate a component (local/remote)', _this.alias = 'd', _this.opts = [['r', 'remote [boolean]', 'deprecate a component from a remote scope']], _this.loader = true, _this.migration = true, _this.paintMissingComponents = function (missingComponents) {
      return !(_ramda || _load_ramda()).default.isEmpty(missingComponents) ? (_chalk || _load_chalk()).default.underline('missing components:') + (0, (_chalk || _load_chalk()).default)(` ${missingComponents}\n`) : '';
    }, _this.paintRemoved = function (bitIds) {
      return !(_ramda || _load_ramda()).default.isEmpty(bitIds) && !(_ramda || _load_ramda()).default.isNil(bitIds) ? (_chalk || _load_chalk()).default.underline('deprecated components:') + (0, (_chalk || _load_chalk()).default)(` ${bitIds}\n`) : '';
    }, _this.paintSingle = function (bitObj) {
      return _this.paintRemoved(bitObj.bitIds) + _this.paintMissingComponents(bitObj.missingComponents);
    }, _this.paintMany = function (bitObjs) {
      return bitObjs.map(function (obj) {
        return _this.paintSingle(obj);
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Deprecate, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 1),
          ids = _ref4[0];

      var _ref3$remote = _ref3.remote,
          remote = _ref3$remote === undefined ? false : _ref3$remote;

      return (0, (_consumer || _load_consumer()).deprecate)({ ids, remote });
    }
  }, {
    key: 'report',
    value: function report(bitObj) {
      return Array.isArray(bitObj) ? this.paintMany(bitObj) : this.paintSingle(bitObj);
    }
  }]);

  return Deprecate;
}((_command || _load_command()).default);

exports.default = Deprecate;