'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

var _chalkBox;

function _load_chalkBox() {
  return _chalkBox = require('../../chalk-box');
}

var _listTemplate;

function _load_listTemplate() {
  return _listTemplate = _interopRequireDefault(require('../../templates/list-template'));
}

var _bareListTemplate;

function _load_bareListTemplate() {
  return _bareListTemplate = _interopRequireDefault(require('../../templates/bare-list-template'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var List = function (_Command) {
  _inherits(List, _Command);

  function List() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, List);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = List.__proto__ || Object.getPrototypeOf(List)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'list [scope]', _this.description = 'list components on a local or a remote scope.', _this.alias = 'ls', _this.opts = [['ids', 'ids', 'components ids to list'], ['b', 'bare', 'show bare output (more details, less pretty)'], ['o', 'outdated', 'show latest versions from remotes'], ['j', 'json', 'show the output in JSON format']], _this.loader = true, _this.migration = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(List, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 1),
          scopeName = _ref4[0];

      var ids = _ref3.ids,
          bare = _ref3.bare,
          json = _ref3.json,
          outdated = _ref3.outdated;

      return (0, (_consumer || _load_consumer()).listScope)({ scopeName, cache: true, showRemoteVersion: outdated }).then(function (components) {
        return {
          components,
          scope: scopeName,
          ids,
          bare,
          json,
          outdated
        };
      });
    }
  }, {
    key: 'report',
    value: function report(_ref5) {
      var components = _ref5.components,
          scope = _ref5.scope,
          ids = _ref5.ids,
          bare = _ref5.bare,
          json = _ref5.json,
          outdated = _ref5.outdated;

      function decideHeaderSentence() {
        if (json) return '';
        if (!scope) return `found ${components.length} components in local scope\n`;
        return (_chalk || _load_chalk()).default.white(`found ${components.length} components in ${(_chalk || _load_chalk()).default.bold(scope)}\n`);
      }

      if ((_ramda || _load_ramda()).default.isEmpty(components)) {
        return (_chalk || _load_chalk()).default.white(`${decideHeaderSentence()}`);
      }

      if (ids) return JSON.stringify(components.map(function (c) {
        return c.id.toString();
      }));
      // TODO - use a cheaper list for ids flag (do not fetch versions at all) @!IMPORTANT
      return decideHeaderSentence() + (bare ? (0, (_bareListTemplate || _load_bareListTemplate()).default)(components) : (0, (_listTemplate || _load_listTemplate()).default)(components, json, outdated));
    }
  }]);

  return List;
}((_command || _load_command()).default);

exports.default = List;