'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _ttyTable;

function _load_ttyTable() {
  return _ttyTable = _interopRequireDefault(require('tty-table'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _utils;

function _load_utils() {
  return _utils = require('../../../utils');
}

var _remoteUndefined;

function _load_remoteUndefined() {
  return _remoteUndefined = _interopRequireDefault(require('../exceptions/remote-undefined'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Remote = function (_Command) {
  _inherits(Remote, _Command);

  function Remote() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Remote);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Remote.__proto__ || Object.getPrototypeOf(Remote)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'remote', _this.description = 'manage set of tracked bit scope(s)', _this.alias = '', _this.opts = [['g', 'global', 'see globally configured remotes']], _this.migration = true, _this.commands = [new RemoteAdd(), new RemoteRm()], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Remote, [{
    key: 'action',


    // $FlowFixMe
    value: function action(args, _ref2) {
      var global = _ref2.global;

      return (0, (_consumer || _load_consumer()).remoteList)(global);
    }
  }, {
    key: 'report',
    value: function report(remotes) {
      if ((0, (_utils || _load_utils()).empty)(remotes)) return (_chalk || _load_chalk()).default.red('no configured remotes found in scope');

      var header = [{ value: 'scope name', width: 30, headerColor: 'cyan' }, { value: 'host', width: 100, headerColor: 'cyan' }];
      var opts = {
        align: 'left'
      };

      var table = new (_ttyTable || _load_ttyTable()).default(header, [], opts);

      (0, (_utils || _load_utils()).forEach)(remotes, function (host, name) {
        table.push([name, host]);
      });

      return table.render();
    }
  }]);

  return Remote;
}((_command || _load_command()).default);

exports.default = Remote;

var RemoteAdd = function (_Command2) {
  _inherits(RemoteAdd, _Command2);

  function RemoteAdd() {
    var _ref3;

    var _temp2, _this2, _ret2;

    _classCallCheck(this, RemoteAdd);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, (_ref3 = RemoteAdd.__proto__ || Object.getPrototypeOf(RemoteAdd)).call.apply(_ref3, [this].concat(args))), _this2), _this2.name = 'add <url>', _this2.description = 'add a tracked bit remote', _this2.alias = '', _this2.opts = [['g', 'global', 'configure a remote bit scope']], _temp2), _possibleConstructorReturn(_this2, _ret2);
  }

  _createClass(RemoteAdd, [{
    key: 'action',
    value: function action(_ref4, _ref5) {
      var _ref6 = _slicedToArray(_ref4, 1),
          url = _ref6[0];

      var global = _ref5.global;

      try {
        if (!url) return Promise.reject(new (_remoteUndefined || _load_remoteUndefined()).default());
        return (0, (_consumer || _load_consumer()).remoteAdd)(url, global);
      } catch (err) {
        return Promise.reject(err);
      }
    }
  }, {
    key: 'report',
    value: function report(_ref7) {
      var name = _ref7.name,
          host = _ref7.host;

      return (_chalk || _load_chalk()).default.green(`added remote scope '${(_chalk || _load_chalk()).default.bold(name)}' with host '${(_chalk || _load_chalk()).default.bold(host)}'`);
    }
  }]);

  return RemoteAdd;
}((_command || _load_command()).default);

var RemoteRm = function (_Command3) {
  _inherits(RemoteRm, _Command3);

  function RemoteRm() {
    var _ref8;

    var _temp3, _this3, _ret3;

    _classCallCheck(this, RemoteRm);

    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return _ret3 = (_temp3 = (_this3 = _possibleConstructorReturn(this, (_ref8 = RemoteRm.__proto__ || Object.getPrototypeOf(RemoteRm)).call.apply(_ref8, [this].concat(args))), _this3), _this3.name = 'del <name>', _this3.description = 'remove a tracked bit remote', _this3.alias = '', _this3.opts = [['g', 'global', 'remove a global configured remote scope']], _temp3), _possibleConstructorReturn(_this3, _ret3);
  }

  _createClass(RemoteRm, [{
    key: 'action',
    value: function action(_ref9, _ref10) {
      var _ref11 = _slicedToArray(_ref9, 1),
          name = _ref11[0];

      var global = _ref10.global;

      return (0, (_consumer || _load_consumer()).remoteRm)(name, global);
    }
  }, {
    key: 'report',
    value: function report(name) {
      return (_chalk || _load_chalk()).default.green(`successfully removed remote ${(_chalk || _load_chalk()).default.bold(name)}`);
    }
  }]);

  return RemoteRm;
}((_command || _load_command()).default);