'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _requestify;

function _load_requestify() {
  return _requestify = _interopRequireDefault(require('requestify'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _search;

function _load_search() {
  return _search = require('../../../search');
}

var _searcher;

function _load_searcher() {
  return _searcher = require('../../../search/searcher');
}

var _indexer;

function _load_indexer() {
  return _indexer = require('../../../search/indexer');
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../../../cli/loader'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../../../cli/loader/loader-messages');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Search = function (_Command) {
  _inherits(Search, _Command);

  function Search() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Search);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Search.__proto__ || Object.getPrototypeOf(Search)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'search <query...>', _this.description = 'search for components by desired functionality.', _this.alias = '', _this.opts = [['s', 'scope <scopename>', 'search in scope'], ['r', 'reindex', 're-index all components']], _this.loader = true, _this.migration = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Search, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 1),
          query = _ref4[0];

      var scope = _ref3.scope,
          reindex = _ref3.reindex;

      var queryStr = query.join(' ');
      if (scope) {
        (_loader || _load_loader()).default.start((0, (_loaderMessages || _load_loaderMessages()).BEFORE_REMOTE_SEARCH)({ scope, queryStr }));
        return (_search || _load_search()).searchAdapter.searchRemotely(queryStr, scope, reindex).catch(function () {
          // web search
          var url = `https://${(_constants || _load_constants()).SEARCH_DOMAIN}/search/?q=${queryStr}`;
          return (_requestify || _load_requestify()).default.get(url).then(function (response) {
            var body = response.getBody();
            return Promise.resolve(body.payload.hits);
          });
        });
      }

      return Promise.reject((_chalk || _load_chalk()).default.red('Local search is disabled for now'));
      // return searchAdapter.searchLocally(queryStr, reindex);
    }
  }, {
    key: 'report',
    value: function report(searchResults) {
      if (!searchResults.length) {
        return (_chalk || _load_chalk()).default.yellow('no results found');
      }
      return (_chalk || _load_chalk()).default.green(searchResults.map((_searcher || _load_searcher()).formatter).join('\n'));
    }
  }]);

  return Search;
}((_command || _load_command()).default);

exports.default = Search;