'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var chalk = require('chalk');

var Untag = function (_Command) {
  _inherits(Untag, _Command);

  function Untag() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Untag);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Untag.__proto__ || Object.getPrototypeOf(Untag)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'untag [id] [version]', _this.description = 'revert version(s) tagged for component(s)', _this.alias = '', _this.opts = [['a', 'all', 'revert tag for all tagged components'], ['f', 'force', 'revert tag although the tag is used as a dependency']], _this.loader = true, _this.migration = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Untag, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 2),
          id = _ref4[0],
          version = _ref4[1];

      var all = _ref3.all,
          force = _ref3.force;

      if (!id && !all) {
        throw new Error('please specify a component ID or use --all flag');
      }

      if (all) {
        version = id;
        return (0, (_consumer || _load_consumer()).unTagAllAction)(version, force);
      }
      return (0, (_consumer || _load_consumer()).unTagAction)(id, version, force);
    }
  }, {
    key: 'report',
    value: function report(results) {
      var title = chalk.green(`${results.length} component(s) were untagged:\n`);
      var components = results.map(function (result) {
        return `\t${chalk.cyan(result.id.toStringWithoutVersion())}. version(s): ${result.versions.join(', ')}`;
      });
      return title + components.join('\n');
    }
  }]);

  return Untag;
}((_command || _load_command()).default);

exports.default = Untag;
//# sourceMappingURL=untag-cmd.js.map