'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Untrack = function (_Command) {
  _inherits(Untrack, _Command);

  function Untrack() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Untrack);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Untrack.__proto__ || Object.getPrototypeOf(Untrack)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'untrack [ids...]', _this.description = 'untrack a new component(s)', _this.alias = 'u', _this.opts = [], _this.loader = true, _this.migration = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Untrack, [{
    key: 'action',
    value: function action(_ref2) {
      var _ref3 = _slicedToArray(_ref2, 1),
          components = _ref3[0];

      return (0, (_consumer || _load_consumer()).untrack)(components || []);
    }
  }, {
    key: 'report',
    value: function report(_ref4) {
      var untrackedComponents = _ref4.untrackedComponents,
          unRemovableComponents = _ref4.unRemovableComponents,
          missingComponents = _ref4.missingComponents;

      var msg = [];
      if ((_ramda || _load_ramda()).default.isEmpty(untrackedComponents) && (_ramda || _load_ramda()).default.isEmpty(unRemovableComponents) && (_ramda || _load_ramda()).default.isEmpty(missingComponents)) {
        return (_chalk || _load_chalk()).default.underline.red('no components untracked');
      }
      if (!(_ramda || _load_ramda()).default.isEmpty(untrackedComponents)) {
        var title = (_chalk || _load_chalk()).default.underline('untracked components:\n');
        msg.push(title + untrackedComponents.map(function (result) {
          return (_chalk || _load_chalk()).default.green(result);
        }).join('\n'));
      }
      if (!(_ramda || _load_ramda()).default.isEmpty(unRemovableComponents)) {
        msg.push((_chalk || _load_chalk()).default.red(`error: unable to untrack ${unRemovableComponents.join(', ')}, please use the bit remove command.\n`));
      }
      if (!(_ramda || _load_ramda()).default.isEmpty(missingComponents)) {
        msg.push((_chalk || _load_chalk()).default.red(`fatal: component ${missingComponents.join(', ')} did not match any component.`));
      }
      return msg.join('\n');
    }
  }]);

  return Untrack;
}((_command || _load_command()).default);

exports.default = Untrack;