'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
// all errors that the command does not handle comes to this switch statement
// if you handle the error, then return true


var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('../bit-id/exceptions');
}

var _bitAlreadyExistExternaly;

function _load_bitAlreadyExistExternaly() {
  return _bitAlreadyExistExternaly = _interopRequireDefault(require('../consumer/component/exceptions/bit-already-exist-externaly'));
}

var _exceptions2;

function _load_exceptions2() {
  return _exceptions2 = require('../consumer/exceptions');
}

var _driver;

function _load_driver() {
  return _driver = require('../driver');
}

var _componentNotFoundInPath;

function _load_componentNotFoundInPath() {
  return _componentNotFoundInPath = _interopRequireDefault(require('../consumer/component/exceptions/component-not-found-in-path'));
}

var _buildException;

function _load_buildException() {
  return _buildException = _interopRequireDefault(require('../consumer/component/exceptions/build-exception'));
}

var _missingFilesFromComponent;

function _load_missingFilesFromComponent() {
  return _missingFilesFromComponent = _interopRequireDefault(require('../consumer/component/exceptions/missing-files-from-component'));
}

var _pluginNotFound;

function _load_pluginNotFound() {
  return _pluginNotFound = _interopRequireDefault(require('../consumer/component/exceptions/plugin-not-found'));
}

var _permissionDenied;

function _load_permissionDenied() {
  return _permissionDenied = _interopRequireDefault(require('../scope/network/exceptions/permission-denied'));
}

var _exceptions3;

function _load_exceptions3() {
  return _exceptions3 = require('../scope/network/exceptions');
}

var _remoteNotFound;

function _load_remoteNotFound() {
  return _remoteNotFound = _interopRequireDefault(require('../remotes/exceptions/remote-not-found'));
}

var _exceptions4;

function _load_exceptions4() {
  return _exceptions4 = require('../scope/exceptions');
}

var _invalidBitJson;

function _load_invalidBitJson() {
  return _invalidBitJson = _interopRequireDefault(require('../consumer/bit-json/exceptions/invalid-bit-json'));
}

var _invalidIdOnCommit;

function _load_invalidIdOnCommit() {
  return _invalidIdOnCommit = _interopRequireDefault(require('../api/consumer/lib/exceptions/invalid-id-on-commit'));
}

var _invalidVersion;

function _load_invalidVersion() {
  return _invalidVersion = _interopRequireDefault(require('../api/consumer/lib/exceptions/invalid-version'));
}

var _nothingToCompareTo;

function _load_nothingToCompareTo() {
  return _nothingToCompareTo = _interopRequireDefault(require('../api/consumer/lib/exceptions/nothing-to-compare-to'));
}

var _promptCanceled;

function _load_promptCanceled() {
  return _promptCanceled = _interopRequireDefault(require('../prompts/exceptions/prompt-canceled'));
}

var _idExportedAlready;

function _load_idExportedAlready() {
  return _idExportedAlready = _interopRequireDefault(require('../api/consumer/lib/exceptions/id-exported-already'));
}

var _pathNotExists;

function _load_pathNotExists() {
  return _pathNotExists = _interopRequireDefault(require('../api/consumer/lib/exceptions/path-not-exists'));
}

var _missingIdImportedComponent;

function _load_missingIdImportedComponent() {
  return _missingIdImportedComponent = _interopRequireDefault(require('../api/consumer/lib/exceptions/missing-id-imported-component'));
}

var _incorrectIdImportedComponent;

function _load_incorrectIdImportedComponent() {
  return _incorrectIdImportedComponent = _interopRequireDefault(require('../api/consumer/lib/exceptions/incorrect-id-imported-component'));
}

var _noFiles;

function _load_noFiles() {
  return _noFiles = _interopRequireDefault(require('../api/consumer/lib/exceptions/no-files'));
}

var _duplicateIds;

function _load_duplicateIds() {
  return _duplicateIds = _interopRequireDefault(require('../api/consumer/lib/exceptions/duplicate-ids'));
}

var _fileSourceNotFound;

function _load_fileSourceNotFound() {
  return _fileSourceNotFound = _interopRequireDefault(require('../consumer/component/exceptions/file-source-not-found'));
}

var _exceptions5;

function _load_exceptions5() {
  return _exceptions5 = require('../consumer/bit-map/exceptions');
}

var _emptyDirectory;

function _load_emptyDirectory() {
  return _emptyDirectory = _interopRequireDefault(require('../api/consumer/lib/exceptions/empty-directory'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

var _remoteUndefined;

function _load_remoteUndefined() {
  return _remoteUndefined = _interopRequireDefault(require('./commands/exceptions/remote-undefined'));
}

var _addTestsWithoutId;

function _load_addTestsWithoutId() {
  return _addTestsWithoutId = _interopRequireDefault(require('./commands/exceptions/add-tests-without-id'));
}

var _missingDependenciesTemplate;

function _load_missingDependenciesTemplate() {
  return _missingDependenciesTemplate = _interopRequireDefault(require('./templates/missing-dependencies-template'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var errorsMap = [[(_remoteUndefined || _load_remoteUndefined()).default, function () {
  return (_chalk || _load_chalk()).default.red('fatal: remote url must be defined. please use: `ssh://`, `file://` or `bit://` protocols to define remote access');
}], [(_addTestsWithoutId || _load_addTestsWithoutId()).default, function () {
  return "you can't add test files without specifying the component ID";
}], [(_exceptions2 || _load_exceptions2()).ConsumerAlreadyExists, function () {
  return "there's already a scope";
}], [(_exceptions4 || _load_exceptions4()).VersionAlreadyExists, function (err) {
  return `the version ${err.version} already exists for ${err.componentId}`;
}], [(_exceptions2 || _load_exceptions2()).ConsumerNotFound, function () {
  return 'fatal: scope not found. to create a new scope, please use `bit init`';
}], [(_bitAlreadyExistExternaly || _load_bitAlreadyExistExternaly()).default, function (err) {
  return `fatal: component "${err.bitName}" already exists in the external library try "bit modify ${err.bitName}" to modify the current component or "bit create -f ${err.bitName}"!`;
}], [(_pluginNotFound || _load_pluginNotFound()).default, function (err) {
  return `fatal: The compiler "${err.plugin}" is not installed, please use "bit install ${err.plugin}" to install it.`;
}], [(_fileSourceNotFound || _load_fileSourceNotFound()).default, function (err) {
  return `fatal: the file "${err.path}" was not found!`;
}], [(_exceptions3 || _load_exceptions3()).ProtocolNotSupported, function () {
  return 'fatal: remote scope protocol is not supported, please use: `ssh://`, `file://` or `bit://`';
}], [(_exceptions3 || _load_exceptions3()).RemoteScopeNotFound, function (err) {
  return `fatal: remote scope "${(_chalk || _load_chalk()).default.bold(err.name)}" not found.`;
}], [(_exceptions || _load_exceptions()).InvalidBitId, function () {
  return 'fatal: component ID is invalid, please use the following format: [scope]/[box]/<name>';
}], [(_exceptions4 || _load_exceptions4()).ComponentNotFound, function (err) {
  return `fatal: component with id "${(_chalk || _load_chalk()).default.bold(err.id)}" was not found`;
}], [(_exceptions4 || _load_exceptions4()).CorruptedComponent, function (err) {
  return `fatal: the model representation of "${(_chalk || _load_chalk()).default.bold(err.id)}" is corrupted, the object of version ${err.version} is missing`;
}], [(_exceptions4 || _load_exceptions4()).DependencyNotFound, function (err) {
  return `error: Dependency "${(_chalk || _load_chalk()).default.bold(err.id)}" not found.`;
}], [(_emptyDirectory || _load_emptyDirectory()).default, function () {
  return (_chalk || _load_chalk()).default.yellow('directory is empty, no files to add');
}], [(_componentNotFoundInPath || _load_componentNotFoundInPath()).default, function (err) {
  return `fatal: component in path "${(_chalk || _load_chalk()).default.bold(err.path)}" was not found`;
}], [(_permissionDenied || _load_permissionDenied()).default, function (err) {
  return `fatal: permission to scope ${err.scope} was denied\ntroubleshoot it using https://docs.bitsrc.io/docs/authentication-issues.html`;
}], [(_remoteNotFound || _load_remoteNotFound()).default, function (err) {
  return `fatal: remote "${(_chalk || _load_chalk()).default.bold(err.name)}" was not found`;
}], [(_exceptions3 || _load_exceptions3()).NetworkError, function (err) {
  return `fatal: remote failed with error: "${(_chalk || _load_chalk()).default.bold(err.remoteErr)}"`;
}], [(_exceptions4 || _load_exceptions4()).MergeConflict, function (err) {
  return `error: Merge conflict occurred when exporting the component ${err.id}.\nTo resolve it, please import the latest version of the remote component, and only then export your changes.`;
}], [(_exceptions4 || _load_exceptions4()).CyclicDependencies, function (err) {
  return `${err.msg.toString().toLocaleLowerCase()}`;
}], [(_exceptions3 || _load_exceptions3()).UnexpectedNetworkError, function () {
  return 'fatal: unexpected network error has occurred';
}], [(_exceptions3 || _load_exceptions3()).SSHInvalidResponse, function () {
  return 'fatal: received an invalid response from the remote SSH server';
}], [(_exceptions4 || _load_exceptions4()).ScopeNotFound, function () {
  return 'fatal: scope not found. to create a new scope, please use `bit init --bare`';
}], [(_exceptions2 || _load_exceptions2()).ComponentSpecsFailed, function () {
  return "component's specs does not pass, fix them and tag";
}], [(_buildException || _load_buildException()).default, function (err) {
  return `error - bit failed to build ${err.id} with the following exception:\n ${err.message} \n ${err.stack || ''}`;
}], [(_exceptions2 || _load_exceptions2()).MissingDependencies, function (err) {
  var missingDepsColored = (0, (_missingDependenciesTemplate || _load_missingDependenciesTemplate()).default)(err.components);
  return `fatal: issues found with the following component dependencies\n${missingDepsColored}`;
}], [(_exceptions2 || _load_exceptions2()).NothingToImport, function () {
  return (_chalk || _load_chalk()).default.yellow('nothing to import. please use `bit import [componentId]` or configure components in bit.json');
}], [(_exceptions || _load_exceptions()).InvalidIdChunk, function (err) {
  return `invalid id part in "${(_chalk || _load_chalk()).default.bold(err.id)}", id part can have only alphanumeric, lowercase characters, and the following ["-", "_", "$", "!"]`;
}], [(_invalidBitJson || _load_invalidBitJson()).default, function (err) {
  return `error: invalid bit.json: ${(_chalk || _load_chalk()).default.bold(err.path)} is not a valid JSON file.`;
}], [(_exceptions4 || _load_exceptions4()).ResolutionException, function (e) {
  return e.message;
}], [(_driver || _load_driver()).DriverNotFound, function (err) {
  return `fatal: a client-driver ${(_chalk || _load_chalk()).default.bold(err.driver)} is missing for the language ${(_chalk || _load_chalk()).default.bold(err.lang)} set in your bit.json file.`;
}], [(_exceptions5 || _load_exceptions5()).MissingMainFile, function (err) {
  return `fatal: the main file ${(_chalk || _load_chalk()).default.bold(err.mainFile)} was not found in the files list ${(_chalk || _load_chalk()).default.bold(err.files.join(', '))}`;
}], [(_missingFilesFromComponent || _load_missingFilesFromComponent()).default, function (err) {
  return `invalid component ${err.id}, all files were deleted, please remove the component using bit remove command`;
}], [(_exceptions5 || _load_exceptions5()).MissingBitMapComponent, function (err) {
  return `fatal: the component ${(_chalk || _load_chalk()).default.bold(err.id)} was not found in the .bitmap file`;
}], [(_pathNotExists || _load_pathNotExists()).default, function (err) {
  return `fatal: the file "${(_chalk || _load_chalk()).default.bold(err.path)}" was not found`;
}], [(_missingIdImportedComponent || _load_missingIdImportedComponent()).default, function (err) {
  return `error - unable to add new files to the imported component "${(_chalk || _load_chalk()).default.bold(err.id)}" without specifying '--id`;
}], [(_incorrectIdImportedComponent || _load_incorrectIdImportedComponent()).default, function (err) {
  return `error - unable to add new files from the root directory of the imported component  "${(_chalk || _load_chalk()).default.bold(err.importedId)}" to "${(_chalk || _load_chalk()).default.bold(err.newId)}"`;
}], [(_noFiles || _load_noFiles()).default, function (err) {
  return (_chalk || _load_chalk()).default.yellow('warning: no files to add') + (_chalk || _load_chalk()).default.yellow(err.ignoredFiles ? `,the following files were ignored: ${(_chalk || _load_chalk()).default.bold(err.ignoredFiles)}` : '');
}], [(_duplicateIds || _load_duplicateIds()).default, function (err) {
  return Object.keys(err.componentObject).map(function (key) {
    return `unable to add ${Object.keys(err.componentObject[key]).length} components with the same id ${(_chalk || _load_chalk()).default.bold(key)} : ${err.componentObject[key]}\n`;
  }).join(' ');
}], [(_idExportedAlready || _load_idExportedAlready()).default, function (err) {
  return `error - the component ${(_chalk || _load_chalk()).default.bold(err.id)} has been already exported to ${(_chalk || _load_chalk()).default.bold(err.remote)}`;
}], [(_invalidVersion || _load_invalidVersion()).default, function (err) {
  return `error - The version ${(_chalk || _load_chalk()).default.bold(err.version)} is not a valid semantic version.`;
}], [(_invalidIdOnCommit || _load_invalidIdOnCommit()).default, function (err) {
  return `error - Unable to tag. ${(_chalk || _load_chalk()).default.bold(err.id)} not found.
Run \`bit status\` command to list all components available for tag.`;
}], [(_nothingToCompareTo || _load_nothingToCompareTo()).default, function (err) {
  return 'error - nothing to compare no previous versions found';
}], [(_promptCanceled || _load_promptCanceled()).default, function (err) {
  return (_chalk || _load_chalk()).default.yellow('operation was aborted');
}], [(_exceptions3 || _load_exceptions3()).AuthenticationFailed, function (err) {
  return 'authentication failed';
}]];

function formatUnhandled(err) {
  return (_chalk || _load_chalk()).default.red(err.message || err);
}

exports.default = function (err) {
  var error = errorsMap.find(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 1),
        ErrorType = _ref2[0];

    return err instanceof ErrorType;
  });

  if (!error) return formatUnhandled(err);

  var _error = _slicedToArray(error, 2),
      func = _error[1];

  (_logger || _load_logger()).default.error(`User gets the following error: ${func(err)}`);
  return (_chalk || _load_chalk()).default.red(func(err));
};
//# sourceMappingURL=default-error-handler.js.map