'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.missingDependenciesLabels = undefined;
exports.default = missingDepsTemplate;

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _consumerComponent;

function _load_consumerComponent() {
  return _consumerComponent = _interopRequireDefault(require('../../consumer/component/consumer-component'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var missingDependenciesLabels = exports.missingDependenciesLabels = {
  untrackedDependencies: 'untracked file dependencies',
  missingPackagesDependenciesOnFs: 'missing packages dependencies',
  missingLinks: 'missing bind links',
  relativeComponents: 'relative components (should be absolute)',
  missingDependenciesOnFs: 'non-existing dependency files',
  missingComponents: 'missing components'
};

function missingDepsTemplate(components) {
  function format(missingComponent) {
    return `${(_chalk || _load_chalk()).default.underline((_chalk || _load_chalk()).default.cyan(missingComponent.id.toString()))}\n${formatMissing(missingComponent)}`;
  }

  var result = `\n${components.map(format).join('\n')}`;
  return result;
}

function formatMissing(missingComponent) {
  function formatMissingStr(array, label) {
    if (!array || array.length === 0) return '';
    return (_chalk || _load_chalk()).default.yellow(`${label}: `) + (_chalk || _load_chalk()).default.white(array.join(', '));
  }

  var missingStr = Object.keys(missingDependenciesLabels).map(function (key) {
    return formatMissingStr(missingComponent.missingDependencies[key], missingDependenciesLabels[key]);
  }).join('');

  return `${missingStr}\n`;
}