'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../bit-id');
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AbstractBitJson = function () {
  /** @deprecated * */
  function AbstractBitJson(_ref) {
    var impl = _ref.impl,
        spec = _ref.spec,
        compiler = _ref.compiler,
        tester = _ref.tester,
        dependencies = _ref.dependencies,
        devDependencies = _ref.devDependencies,
        lang = _ref.lang,
        bindingPrefix = _ref.bindingPrefix,
        extensions = _ref.extensions;

    _classCallCheck(this, AbstractBitJson);

    this.impl = impl || (_constants || _load_constants()).DEFAULT_IMPL_NAME;
    this.spec = spec || (_constants || _load_constants()).DEFAULT_SPECS_NAME;
    this.compiler = compiler || (_constants || _load_constants()).DEFAULT_COMPILER_ID;
    this.tester = tester || (_constants || _load_constants()).DEFAULT_TESTER_ID;
    this.dependencies = dependencies || (_constants || _load_constants()).DEFAULT_DEPENDENCIES;
    this.devDependencies = devDependencies || (_constants || _load_constants()).DEFAULT_DEPENDENCIES;
    this.lang = lang || (_constants || _load_constants()).DEFAULT_LANGUAGE;
    this.bindingPrefix = bindingPrefix || (_constants || _load_constants()).DEFAULT_BINDINGS_PREFIX;
    this.extensions = extensions || (_constants || _load_constants()).DEFAULT_EXTENSIONS;
  }
  /** @deprecated * */


  _createClass(AbstractBitJson, [{
    key: 'addDependencies',
    value: function addDependencies(bitIds) {
      var idObjects = (_ramda || _load_ramda()).default.mergeAll(bitIds.map(function (bitId) {
        return bitId.toObject();
      }));
      this.dependencies = (_ramda || _load_ramda()).default.merge(this.dependencies, idObjects);
      return this;
    }
  }, {
    key: 'addDependency',
    value: function addDependency(bitId) {
      this.dependencies = (_ramda || _load_ramda()).default.merge(this.dependencies, bitId.toObject());
      return this;
    }
  }, {
    key: 'getImplBasename',
    value: function getImplBasename() {
      return this.impl;
    }
  }, {
    key: 'setImplBasename',
    value: function setImplBasename(name) {
      this.impl = name;
      return this;
    }
  }, {
    key: 'getSpecBasename',
    value: function getSpecBasename() {
      return this.spec;
    }
  }, {
    key: 'setSpecBasename',
    value: function setSpecBasename(name) {
      this.spec = name;
      return this;
    }
  }, {
    key: 'hasCompiler',
    value: function hasCompiler() {
      return !!this.compiler && this.compiler !== (_constants || _load_constants()).NO_PLUGIN_TYPE;
    }
  }, {
    key: 'hasTester',
    value: function hasTester() {
      return !!this.tester && this.tester !== (_constants || _load_constants()).NO_PLUGIN_TYPE;
    }
  }, {
    key: 'getDependencies',
    value: function getDependencies() {
      return (_bitId || _load_bitId()).BitIds.fromObject(this.dependencies);
    }
  }, {
    key: 'toPlainObject',
    value: function toPlainObject() {
      var isPropDefaultOrNull = function isPropDefaultOrNull(val, key) {
        if (!val) return false;
        if (key === 'lang') return val !== (_constants || _load_constants()).DEFAULT_LANGUAGE;
        if (key === 'bindingPrefix') return val !== (_constants || _load_constants()).DEFAULT_BINDINGS_PREFIX;
        if (key === 'extensions') return !(_ramda || _load_ramda()).default.equals(val, (_constants || _load_constants()).DEFAULT_EXTENSIONS);
        return true;
      };

      return (0, (_utils || _load_utils()).filterObject)({
        lang: this.lang,
        bindingPrefix: this.bindingPrefix,
        env: {
          compiler: this.compilerId,
          tester: this.testerId
        },
        dependencies: this.dependencies,
        extensions: this.extensions
      }, isPropDefaultOrNull);
    }
  }, {
    key: 'toJson',
    value: function toJson() {
      var readable = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      if (!readable) return JSON.stringify(this.toPlainObject());
      return JSON.stringify(this.toPlainObject(), null, 4);
    }
  }, {
    key: 'compilerId',
    get: function get() {
      return this.compiler;
    },
    set: function set(compilerId) {
      this.compiler = compilerId;
    }
  }, {
    key: 'testerId',
    get: function get() {
      return this.tester;
    },
    set: function set(testerId) {
      this.tester = testerId;
    }
  }]);

  return AbstractBitJson;
}();

exports.default = AbstractBitJson;