'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.composePath = composePath;
exports.hasExisting = hasExisting;

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fs;

function _load_fs() {
  return _fs = _interopRequireDefault(require('fs'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('./exceptions');
}

var _abstractBitJson;

function _load_abstractBitJson() {
  return _abstractBitJson = _interopRequireDefault(require('./abstract-bit-json'));
}

var _consumerBitJson;

function _load_consumerBitJson() {
  return _consumerBitJson = _interopRequireDefault(require('./consumer-bit-json'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function composePath(bitPath) {
  return (_path || _load_path()).default.join(bitPath, (_constants || _load_constants()).BIT_JSON);
}

function hasExisting(bitPath) {
  return (_fs || _load_fs()).default.existsSync(composePath(bitPath));
}

/**
 * Component's bit.json
 */
var BitJson = function (_AbstractBitJson) {
  _inherits(BitJson, _AbstractBitJson);

  function BitJson(_ref) {
    var impl = _ref.impl,
        spec = _ref.spec,
        compiler = _ref.compiler,
        tester = _ref.tester,
        dependencies = _ref.dependencies,
        devDependencies = _ref.devDependencies,
        packageDependencies = _ref.packageDependencies,
        devPackageDependencies = _ref.devPackageDependencies,
        lang = _ref.lang,
        bindingPrefix = _ref.bindingPrefix,
        extensions = _ref.extensions;

    _classCallCheck(this, BitJson);

    var _this = _possibleConstructorReturn(this, (BitJson.__proto__ || Object.getPrototypeOf(BitJson)).call(this, { impl, spec, compiler, tester, dependencies, devDependencies, lang, bindingPrefix, extensions }));

    _this.packageDependencies = packageDependencies || {};
    _this.devPackageDependencies = devPackageDependencies || {};
    return _this;
  }

  _createClass(BitJson, [{
    key: 'toPlainObject',
    value: function toPlainObject() {
      var superObject = _get(BitJson.prototype.__proto__ || Object.getPrototypeOf(BitJson.prototype), 'toPlainObject', this).call(this);
      return (_ramda || _load_ramda()).default.merge(superObject, {
        packageDependencies: this.getPackageDependencies()
      });
    }
  }, {
    key: 'getPackageDependencies',
    value: function getPackageDependencies() {
      return this.packageDependencies;
    }
  }, {
    key: 'toJson',
    value: function toJson() {
      var readable = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      if (!readable) return JSON.stringify(this.toPlainObject());
      return JSON.stringify(this.toPlainObject(), null, 4);
    }
  }, {
    key: 'write',
    value: function write(_ref2) {
      var _this2 = this;

      var bitDir = _ref2.bitDir,
          _ref2$override = _ref2.override,
          override = _ref2$override === undefined ? true : _ref2$override;

      return new Promise(function (resolve, reject) {
        if (!override && hasExisting(bitDir)) {
          return resolve(false);
        }

        var repspond = function repspond(err, res) {
          if (err) return reject(err);
          return resolve(res);
        };

        (_fs || _load_fs()).default.writeFile(composePath(bitDir), _this2.toJson(), repspond);
      });
    }
  }, {
    key: 'validate',
    value: function validate(bitJsonPath) {
      if (typeof this.getImplBasename() !== 'string' || typeof this.compilerId !== 'string' || typeof this.testerId !== 'string' || this.lang && typeof this.testerId !== 'string' || this.getDependencies() && typeof this.getDependencies() !== 'object' || this.extensions() && typeof this.extensions() !== 'object') {
        throw new (_exceptions || _load_exceptions()).InvalidBitJson(bitJsonPath);
      }
    }
  }, {
    key: 'mergeWithComponentData',
    value: function mergeWithComponentData(component) {
      this.compiler = component.compilerId ? component.compilerId.toString() : null;
      this.tester = component.testerId ? component.testerId.toString() : null;
      this.bindingPrefix = component.bindingPrefix;
      this.lang = component.lang;
    }

    /**
     * Use the consumerBitJson as a base. Override values if exist in componentBitJson
     */

  }], [{
    key: 'fromPlainObject',
    value: function fromPlainObject(object) {
      var _object$sources = object.sources,
          sources = _object$sources === undefined ? {} : _object$sources,
          env = object.env,
          dependencies = object.dependencies,
          packageDependencies = object.packageDependencies,
          lang = object.lang,
          bindingPrefix = object.bindingPrefix,
          extensions = object.extensions;


      return new BitJson({
        impl: (_ramda || _load_ramda()).default.prop('impl', sources),
        spec: (_ramda || _load_ramda()).default.prop('spec', sources),
        compiler: (_ramda || _load_ramda()).default.prop('compiler', env),
        tester: (_ramda || _load_ramda()).default.prop('tester', env),
        dependencies,
        extensions,
        lang,
        bindingPrefix,
        packageDependencies
      });
    }
  }, {
    key: 'mergeWithProto',
    value: function mergeWithProto(json, protoBJ) {
      var plainProtoBJ = protoBJ ? protoBJ.toPlainObject() : {};
      delete plainProtoBJ.dependencies;
      return BitJson.fromPlainObject((_ramda || _load_ramda()).default.merge(plainProtoBJ, json));
    }
  }, {
    key: 'create',
    value: function create() {
      var json = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var protoBJ = arguments[1];

      return this.mergeWithProto(json, protoBJ);
    }
  }, {
    key: 'load',
    value: function load(dirPath, protoBJ) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        try {
          var result = _this3.loadSync(dirPath, protoBJ);
          return resolve(result);
        } catch (e) {
          return reject(dirPath);
        }
      });
    }
  }, {
    key: 'loadSync',
    value: function loadSync(dirPath, protoBJ) {
      var thisBJ = {};
      if (dirPath) {
        var bitJsonPath = composePath(dirPath);
        if ((_fs || _load_fs()).default.existsSync(bitJsonPath)) {
          try {
            thisBJ = JSON.parse((_fs || _load_fs()).default.readFileSync(bitJsonPath).toString('utf8'));
          } catch (e) {
            throw new (_exceptions || _load_exceptions()).InvalidBitJson(bitJsonPath);
          }
        }
      }

      return this.mergeWithProto(thisBJ, protoBJ);
    }
  }]);

  return BitJson;
}((_abstractBitJson || _load_abstractBitJson()).default);

exports.default = BitJson;