'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _fs;

function _load_fs() {
  return _fs = _interopRequireDefault(require('fs'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _abstractBitJson;

function _load_abstractBitJson() {
  return _abstractBitJson = _interopRequireDefault(require('./abstract-bit-json'));
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('./exceptions');
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _filterObject;

function _load_filterObject() {
  return _filterObject = _interopRequireDefault(require('../../utils/filter-object'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function composePath(bitPath) {
  return (_path || _load_path()).default.join(bitPath, (_constants || _load_constants()).BIT_JSON);
}

function hasExisting(bitPath) {
  return (_fs || _load_fs()).default.existsSync(composePath(bitPath));
}

var DEFAULT_USE_WORKSPACES = false;
var DEFAULT_MANAGE_WORKSPACES = true;
var DEFAULT_SAVE_DEPENDENCIES_AS_COMPONENTS = false;

var ConsumerBitJson = function (_AbstractBitJson) {
  _inherits(ConsumerBitJson, _AbstractBitJson);

  // manage workspaces with yarn

  // package manager process options
  // package manager client to use
  function ConsumerBitJson(_ref) {
    var impl = _ref.impl,
        spec = _ref.spec,
        compiler = _ref.compiler,
        tester = _ref.tester,
        dependencies = _ref.dependencies,
        _ref$saveDependencies = _ref.saveDependenciesAsComponents,
        saveDependenciesAsComponents = _ref$saveDependencies === undefined ? DEFAULT_SAVE_DEPENDENCIES_AS_COMPONENTS : _ref$saveDependencies,
        lang = _ref.lang,
        distTarget = _ref.distTarget,
        distEntry = _ref.distEntry,
        _ref$componentsDefaul = _ref.componentsDefaultDirectory,
        componentsDefaultDirectory = _ref$componentsDefaul === undefined ? (_constants || _load_constants()).DEFAULT_COMPONENTES_DIR_PATH : _ref$componentsDefaul,
        _ref$dependenciesDire = _ref.dependenciesDirectory,
        dependenciesDirectory = _ref$dependenciesDire === undefined ? (_constants || _load_constants()).DEFAULT_DEPENDENCIES_DIR_PATH : _ref$dependenciesDire,
        bindingPrefix = _ref.bindingPrefix,
        extensions = _ref.extensions,
        _ref$packageManager = _ref.packageManager,
        packageManager = _ref$packageManager === undefined ? (_constants || _load_constants()).DEFAULT_PACKAGE_MANAGER : _ref$packageManager,
        packageManagerArgs = _ref.packageManagerArgs,
        packageManagerProcessOptions = _ref.packageManagerProcessOptions,
        _ref$useWorkspaces = _ref.useWorkspaces,
        useWorkspaces = _ref$useWorkspaces === undefined ? DEFAULT_USE_WORKSPACES : _ref$useWorkspaces,
        _ref$manageWorkspaces = _ref.manageWorkspaces,
        manageWorkspaces = _ref$manageWorkspaces === undefined ? DEFAULT_MANAGE_WORKSPACES : _ref$manageWorkspaces;

    _classCallCheck(this, ConsumerBitJson);

    var _this = _possibleConstructorReturn(this, (ConsumerBitJson.__proto__ || Object.getPrototypeOf(ConsumerBitJson)).call(this, { impl, spec, compiler, tester, dependencies, lang, bindingPrefix, extensions }));

    _this.distTarget = distTarget;
    _this.distEntry = distEntry;
    _this.componentsDefaultDirectory = componentsDefaultDirectory;
    _this.dependenciesDirectory = dependenciesDirectory;
    _this.saveDependenciesAsComponents = saveDependenciesAsComponents;
    _this.packageManager = packageManager;
    _this.packageManagerArgs = packageManagerArgs;
    _this.packageManagerProcessOptions = packageManagerProcessOptions;
    _this.useWorkspaces = useWorkspaces;
    _this.manageWorkspaces = manageWorkspaces;
    return _this;
  } // Enables integration with Yarn Workspaces
  // package manager client to use
  // save hub dependencies as bit components rather than npm packages
  // path where to store build artifacts
  // path to remove while storing build artifacts. If, for example the code is in 'src' directory, and the component
  // is-string is in src/components/is-string, the dists files will be in dists/component/is-string (without the 'src')


  _createClass(ConsumerBitJson, [{
    key: 'toPlainObject',
    value: function toPlainObject() {
      var superObject = _get(ConsumerBitJson.prototype.__proto__ || Object.getPrototypeOf(ConsumerBitJson.prototype), 'toPlainObject', this).call(this);
      var consumerObject = (_ramda || _load_ramda()).default.merge(superObject, {
        componentsDefaultDirectory: this.componentsDefaultDirectory,
        dependenciesDirectory: this.dependenciesDirectory,
        saveDependenciesAsComponents: this.saveDependenciesAsComponents,
        packageManager: this.packageManager,
        packageManagerArgs: this.packageManagerArgs,
        packageManagerProcessOptions: this.packageManagerProcessOptions,
        useWorkspaces: this.useWorkspaces,
        manageWorkspaces: this.manageWorkspaces
      });
      if (this.distEntry || this.distTarget) {
        var dist = {};
        if (this.distEntry) dist.entry = this.distEntry;
        if (this.distTarget) dist.target = this.distTarget;
        consumerObject = (_ramda || _load_ramda()).default.merge(consumerObject, { dist });
      }

      var isPropDefault = function isPropDefault(val, key) {
        if (key === 'dependenciesDirectory') return val !== (_constants || _load_constants()).DEFAULT_DEPENDENCIES_DIR_PATH;
        if (key === 'useWorkspaces') return val !== DEFAULT_USE_WORKSPACES;
        if (key === 'manageWorkspaces') return val !== DEFAULT_MANAGE_WORKSPACES;
        if (key === 'saveDependenciesAsComponents') return val !== DEFAULT_SAVE_DEPENDENCIES_AS_COMPONENTS;
        return true;
      };

      return (0, (_filterObject || _load_filterObject()).default)(consumerObject, isPropDefault);
    }
  }, {
    key: 'write',
    value: function write(_ref2) {
      var _this2 = this;

      var bitDir = _ref2.bitDir,
          _ref2$override = _ref2.override,
          override = _ref2$override === undefined ? true : _ref2$override;

      return new Promise(function (resolve, reject) {
        if (!override && hasExisting(bitDir)) {
          throw new (_exceptions || _load_exceptions()).BitJsonAlreadyExists();
        }

        var respond = function respond(err, res) {
          if (err) return reject(err);
          return resolve(res);
        };

        (_fs || _load_fs()).default.writeFile(composePath(bitDir), _this2.toJson(), respond);
      });
    }
  }], [{
    key: 'create',
    value: function create() {
      return new ConsumerBitJson({});
    }
  }, {
    key: 'ensure',
    value: function ensure(dirPath) {
      var _this3 = this;

      return new Promise(function (resolve) {
        return _this3.load(dirPath).then(resolve).catch(function () {
          return resolve(_this3.create());
        });
      });
    }
  }, {
    key: 'fromPlainObject',
    value: function fromPlainObject(object) {
      var sources = object.sources,
          env = object.env,
          dependencies = object.dependencies,
          lang = object.lang,
          componentsDefaultDirectory = object.componentsDefaultDirectory,
          dependenciesDirectory = object.dependenciesDirectory,
          dist = object.dist,
          bindingPrefix = object.bindingPrefix,
          extensions = object.extensions,
          saveDependenciesAsComponents = object.saveDependenciesAsComponents,
          packageManager = object.packageManager,
          packageManagerArgs = object.packageManagerArgs,
          packageManagerProcessOptions = object.packageManagerProcessOptions,
          useWorkspaces = object.useWorkspaces,
          manageWorkspaces = object.manageWorkspaces;


      return new ConsumerBitJson({
        impl: (_ramda || _load_ramda()).default.propOr(undefined, 'impl', sources),
        spec: (_ramda || _load_ramda()).default.propOr(undefined, 'spec', sources),
        compiler: (_ramda || _load_ramda()).default.propOr(undefined, 'compiler', env),
        tester: (_ramda || _load_ramda()).default.propOr(undefined, 'tester', env),
        lang,
        bindingPrefix,
        extensions,
        dependencies,
        saveDependenciesAsComponents,
        componentsDefaultDirectory,
        dependenciesDirectory,
        packageManager,
        packageManagerArgs,
        packageManagerProcessOptions,
        useWorkspaces,
        manageWorkspaces,
        distTarget: (_ramda || _load_ramda()).default.propOr(undefined, 'target', dist),
        distEntry: (_ramda || _load_ramda()).default.propOr(undefined, 'entry', dist)
      });
    }
  }, {
    key: 'load',
    value: function load(dirPath) {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        if (!hasExisting(dirPath)) return reject(new (_exceptions || _load_exceptions()).BitJsonNotFound());
        return (_fs || _load_fs()).default.readFile(composePath(dirPath), function (err, data) {
          if (err) return reject(err);
          try {
            var file = JSON.parse(data.toString('utf8'));
            return resolve(_this4.fromPlainObject(file));
          } catch (e) {
            return reject(new (_exceptions || _load_exceptions()).InvalidBitJson(e));
          }
        });
      });
    }
  }]);

  return ConsumerBitJson;
}((_abstractBitJson || _load_abstractBitJson()).default);

exports.default = ConsumerBitJson;