'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('../exceptions');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../bit-id');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../component'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../consumer');
}

var _scope;

function _load_scope() {
  return _scope = require('../../scope');
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../../cli/loader'));
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../../cli/loader/loader-messages');
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../logger/logger'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ImportComponents = function () {
  function ImportComponents(consumer, options) {
    _classCallCheck(this, ImportComponents);

    this.consumer = consumer;
    this.options = options;
  }

  _createClass(ImportComponents, [{
    key: 'importComponents',
    value: function importComponents() {
      (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_IMPORT_ACTION);
      this.options.saveDependenciesAsComponents = this.consumer.bitJson.saveDependenciesAsComponents;
      if (!this.options.writePackageJson) {
        // if package.json is not written, it's impossible to install the packages and dependencies as npm packages
        this.options.installNpmPackages = false;
        this.options.saveDependenciesAsComponents = true;
      }
      if (!this.options.ids || (_ramda || _load_ramda()).default.isEmpty(this.options.ids)) {
        return this.importAccordingToBitJsonAndBitMap();
      }
      return this.importSpecificComponents();
    }
  }, {
    key: 'importSpecificComponents',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        var bitIds, componentsWithDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // $FlowFixMe - we make sure the ids are populated before.
                (_logger || _load_logger()).default.debug(`importSpecificComponents, Ids: ${this.options.ids.join(', ')}`);
                // $FlowFixMe - we check if there are bitIds before we call this function
                bitIds = this.options.ids.map(function (raw) {
                  return (_bitId || _load_bitId()).BitId.parse(raw);
                });
                _context.next = 4;
                return this._warnForModifiedOrNewComponents(bitIds);

              case 4:
                _context.next = 6;
                return this.consumer.scope.getManyWithAllVersions(bitIds, false);

              case 6:
                componentsWithDependencies = _context.sent;
                _context.next = 9;
                return this._writeToFileSystem(componentsWithDependencies);

              case 9:
                return _context.abrupt('return', { dependencies: componentsWithDependencies });

              case 10:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function importSpecificComponents() {
        return _ref.apply(this, arguments);
      }

      return importSpecificComponents;
    }()
  }, {
    key: 'importAccordingToBitJsonAndBitMap',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2() {
        var dependenciesFromBitJson, componentsFromBitMap, componentsAndDependenciesBitJson, componentsAndDependenciesBitMap, componentsAndDependencies, envComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.options.objectsOnly = !this.options.writeToFs;

                dependenciesFromBitJson = (_bitId || _load_bitId()).BitIds.fromObject(this.consumer.bitJson.dependencies);
                componentsFromBitMap = this.consumer.bitMap.getAuthoredExportedComponents();

                if (!(((_ramda || _load_ramda()).default.isNil(dependenciesFromBitJson) || (_ramda || _load_ramda()).default.isEmpty(dependenciesFromBitJson)) && (_ramda || _load_ramda()).default.isEmpty(componentsFromBitMap))) {
                  _context2.next = 10;
                  break;
                }

                if (this.options.withEnvironments) {
                  _context2.next = 8;
                  break;
                }

                return _context2.abrupt('return', Promise.reject(new (_exceptions || _load_exceptions()).NothingToImport()));

              case 8:
                if (!((_ramda || _load_ramda()).default.isNil(this.consumer.testerId) && (_ramda || _load_ramda()).default.isNil(this.consumer.compilerId))) {
                  _context2.next = 10;
                  break;
                }

                return _context2.abrupt('return', Promise.reject(new (_exceptions || _load_exceptions()).NothingToImport()));

              case 10:
                _context2.next = 12;
                return this._warnForModifiedOrNewComponents(dependenciesFromBitJson.concat(componentsFromBitMap));

              case 12:
                componentsAndDependenciesBitJson = [];
                componentsAndDependenciesBitMap = [];

                if (!dependenciesFromBitJson) {
                  _context2.next = 20;
                  break;
                }

                _context2.next = 17;
                return this.consumer.scope.getManyWithAllVersions(dependenciesFromBitJson, false);

              case 17:
                componentsAndDependenciesBitJson = _context2.sent;
                _context2.next = 20;
                return this._writeToFileSystem(componentsAndDependenciesBitJson);

              case 20:
                if (!componentsFromBitMap.length) {
                  _context2.next = 28;
                  break;
                }

                _context2.next = 23;
                return this.consumer.scope.getManyWithAllVersions(componentsFromBitMap, false);

              case 23:
                componentsAndDependenciesBitMap = _context2.sent;

                // don't write the package.json for an authored component, because its dependencies probably managed by the root
                // package.json. Also, don't install npm packages for the same reason.
                this.options.writePackageJson = false;
                this.options.installNpmPackages = false;
                // don't force the writing to the filesystem because as an author I may have some modified files
                _context2.next = 28;
                return this._writeToFileSystem(componentsAndDependenciesBitMap, false);

              case 28:
                componentsAndDependencies = [].concat(_toConsumableArray(componentsAndDependenciesBitJson), _toConsumableArray(componentsAndDependenciesBitMap));

                if (!this.options.withEnvironments) {
                  _context2.next = 34;
                  break;
                }

                _context2.next = 32;
                return this.consumer.scope.installEnvironment({
                  ids: [this.consumer.testerId, this.consumer.compilerId],
                  verbose: this.options.verbose
                });

              case 32:
                envComponents = _context2.sent;
                return _context2.abrupt('return', {
                  dependencies: componentsAndDependencies,
                  envDependencies: envComponents
                });

              case 34:
                return _context2.abrupt('return', { dependencies: componentsAndDependencies });

              case 35:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function importAccordingToBitJsonAndBitMap() {
        return _ref2.apply(this, arguments);
      }

      return importAccordingToBitJsonAndBitMap;
    }()
  }, {
    key: '_warnForModifiedOrNewComponents',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(ids) {
        var _this = this;

        var modifiedComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(this.options.force || this.options.objectsOnly)) {
                  _context3.next = 2;
                  break;
                }

                return _context3.abrupt('return', Promise.resolve());

              case 2:
                _context3.next = 4;
                return (0, (_utils || _load_utils()).filterAsync)(ids, function (id) {
                  return _this.consumer.getComponentStatusById(id).then(function (status) {
                    return status.modified || status.newlyCreated;
                  });
                });

              case 4:
                modifiedComponents = _context3.sent;

                if (!modifiedComponents.length) {
                  _context3.next = 7;
                  break;
                }

                return _context3.abrupt('return', Promise.reject((_chalk || _load_chalk()).default.yellow(`unable to import the following components due to local changes, use --force flag to override your local changes\n${modifiedComponents.join('\n')} `)));

              case 7:
                return _context3.abrupt('return', Promise.resolve());

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _warnForModifiedOrNewComponents(_x) {
        return _ref3.apply(this, arguments);
      }

      return _warnForModifiedOrNewComponents;
    }()
  }, {
    key: '_writeToFileSystem',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(componentsWithDependencies) {
        var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!this.options.objectsOnly) {
                  _context4.next = 2;
                  break;
                }

                return _context4.abrupt('return');

              case 2:
                _context4.next = 4;
                return this.consumer.writeToComponentsDir({
                  componentsWithDependencies,
                  writeToPath: this.options.writeToPath,
                  writePackageJson: this.options.writePackageJson,
                  writeBitJson: this.options.writeBitJson,
                  writeDists: this.options.writeDists,
                  installNpmPackages: this.options.installNpmPackages,
                  saveDependenciesAsComponents: this.options.saveDependenciesAsComponents,
                  verbose: this.options.verbose,
                  force
                });

              case 4:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function _writeToFileSystem(_x3) {
        return _ref4.apply(this, arguments);
      }

      return _writeToFileSystem;
    }()
  }]);

  return ImportComponents;
}();

exports.default = ImportComponents;
//# sourceMappingURL=import-components.js.map