'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _vinyl;

function _load_vinyl() {
  return _vinyl = _interopRequireDefault(require('vinyl'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../../logger/logger'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AbstractVinyl = function (_Vinyl) {
  _inherits(AbstractVinyl, _Vinyl);

  function AbstractVinyl() {
    _classCallCheck(this, AbstractVinyl);

    return _possibleConstructorReturn(this, (AbstractVinyl.__proto__ || Object.getPrototypeOf(AbstractVinyl)).apply(this, arguments));
  }

  _createClass(AbstractVinyl, [{
    key: 'updatePaths',


    // Update the base path and keep the relative value to be the same
    value: function updatePaths(_ref) {
      var newBase = _ref.newBase,
          newRelative = _ref.newRelative,
          newCwd = _ref.newCwd;

      var relative = newRelative || this.relative;
      if (newCwd) this.cwd = newCwd;
      this.base = newBase;
      this.path = (_path || _load_path()).default.join(this.base, relative);
    }
  }, {
    key: 'write',
    value: function write(writePath) {
      var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      var filePath = writePath || this.path;
      (_logger || _load_logger()).default.debug(`writing a file to the file-system at ${filePath}`);
      if (!force && (_fsExtra || _load_fsExtra()).default.existsSync(filePath)) return Promise.resolve();
      return (_fsExtra || _load_fsExtra()).default.outputFile(filePath, this.contents).then(function () {
        return filePath;
      });
    }
  }, {
    key: 'toReadableString',
    value: function toReadableString() {
      return {
        relativePath: this.relative,
        content: this.contents.toString()
      };
    }
  }], [{
    key: 'loadFromParsedString',
    value: function loadFromParsedString(parsedString) {
      if (!parsedString) return undefined;
      var contents = Buffer.isBuffer(parsedString._contents) ? parsedString._contents : new Buffer(parsedString._contents);
      return {
        cwd: parsedString._cwd,
        path: parsedString.history[parsedString.history.length - 1],
        base: parsedString._base,
        contents
      };
    }
  }, {
    key: 'loadFromParsedStringArray',
    value: function loadFromParsedStringArray(arr) {
      if (!arr) return undefined;
      return arr.map(this.loadFromParsedString);
    }
  }]);

  return AbstractVinyl;
}((_vinyl || _load_vinyl()).default);

exports.default = AbstractVinyl;