'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs;

function _load_fs() {
  return _fs = _interopRequireWildcard(require('fs'));
}

var _path;

function _load_path() {
  return _path = _interopRequireWildcard(require('path'));
}

var _source;

function _load_source() {
  return _source = _interopRequireDefault(require('./source'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var License = function (_Source) {
  _inherits(License, _Source);

  function License() {
    _classCallCheck(this, License);

    return _possibleConstructorReturn(this, (License.__proto__ || Object.getPrototypeOf(License)).apply(this, arguments));
  }

  _createClass(License, [{
    key: 'write',
    value: function write(bitPath) {
      var _this2 = this;

      var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      var filePath = (_path || _load_path()).join(bitPath, (_constants || _load_constants()).LICENSE_FILENAME);
      if (!force && (_fs || _load_fs()).existsSync(filePath)) return Promise.resolve();
      return new Promise(function (resolve, reject) {
        return (_fs || _load_fs()).writeFile(filePath, _this2.src, function (err, res) {
          if (err) return reject(err);
          return resolve(res);
        });
      });
    }
  }, {
    key: 'serialize',
    value: function serialize() {
      return this.src;
    }
  }], [{
    key: 'deserialize',
    value: function deserialize(str) {
      return new License(str);
    }
  }]);

  return License;
}((_source || _load_source()).default);

exports.default = License;