'use strict';

var _chai;

function _load_chai() {
  return _chai = require('chai');
}

var _sinon;

function _load_sinon() {
  return _sinon = _interopRequireDefault(require('sinon'));
}

var _environment;

function _load_environment() {
  return _environment = _interopRequireDefault(require('../../src/environment'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../src/scope');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Environment', function () {
  var sandbox = void 0;
  beforeEach(function () {
    sandbox = (_sinon || _load_sinon()).default.sandbox.create();
  });
  afterEach(function () {
    sandbox.restore();
  });

  describe('constructor', function () {
    it.skip('should generate a unique path for every instance', function () {
      sandbox.stub((_scope || _load_scope()).Scope, 'load').returns({ getPath: function getPath() {
          return '';
        } });
      var scope = (_scope || _load_scope()).Scope.load();
      var environment1 = new (_environment || _load_environment()).default(scope);
      var environment2 = new (_environment || _load_environment()).default(scope);
      (0, (_chai || _load_chai()).expect)(environment1.path).not.to.be.equal(environment2.path);
    });
  });
});