'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fs;

function _load_fs() {
  return _fs = _interopRequireDefault(require('fs'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _utils;

function _load_utils() {
  return _utils = require('../utils');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _extendableBuiltin(cls) {
  function ExtendableBuiltin() {
    var instance = Reflect.construct(cls, Array.from(arguments));
    Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
    return instance;
  }

  ExtendableBuiltin.prototype = Object.create(cls.prototype, {
    constructor: {
      value: cls,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });

  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(ExtendableBuiltin, cls);
  } else {
    ExtendableBuiltin.__proto__ = cls;
  }

  return ExtendableBuiltin;
}

function getPath() {
  return (_path || _load_path()).default.join((_constants || _load_constants()).GLOBAL_CONFIG, (_constants || _load_constants()).GLOBAL_CONFIG_FILE);
}

var Config = function (_extendableBuiltin2) {
  _inherits(Config, _extendableBuiltin2);

  function Config() {
    _classCallCheck(this, Config);

    return _possibleConstructorReturn(this, (Config.__proto__ || Object.getPrototypeOf(Config)).apply(this, arguments));
  }

  _createClass(Config, [{
    key: 'toPlainObject',
    value: function toPlainObject() {
      return (0, (_utils || _load_utils()).mapToObject)(this);
    }
  }, {
    key: 'toJson',
    value: function toJson() {
      return JSON.stringify(this.toPlainObject());
    }
  }, {
    key: 'write',
    value: function write() {
      return (0, (_utils || _load_utils()).writeFile)(getPath(), this.toJson());
    }
  }, {
    key: 'writeSync',
    value: function writeSync() {
      return (_fs || _load_fs()).default.writeFileSync(getPath(), this.toJson());
    }
  }], [{
    key: 'loadSync',
    value: function loadSync() {
      try {
        var contents = (_fs || _load_fs()).default.readFileSync(getPath());
        return new Config((0, (_utils || _load_utils()).objectToTupleArray)(JSON.parse(contents.toString())));
      } catch (err) {
        if (err.code !== 'ENOENT') return err;
        var config = new Config([]);
        config.writeSync();
        return config;
      }
    }
  }, {
    key: 'load',
    value: function load() {
      return (0, (_utils || _load_utils()).readFile)(getPath()).then(function (contents) {
        return new Config((0, (_utils || _load_utils()).objectToTupleArray)(JSON.parse(contents.toString())));
      }).catch(function (err) {
        if (err.code !== 'ENOENT') return err;
        var config = new Config([]);
        return config.write().then(function () {
          return config;
        });
      });
    }
  }]);

  return Config;
}(_extendableBuiltin(Map));

exports.default = Config;