'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemovedLocalObjects = exports.RemovedObjects = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RemovedObjects = exports.RemovedObjects = function () {
  function RemovedObjects(_ref) {
    var _ref$removedComponent = _ref.removedComponentIds,
        removedComponentIds = _ref$removedComponent === undefined ? [] : _ref$removedComponent,
        _ref$missingComponent = _ref.missingComponents,
        missingComponents = _ref$missingComponent === undefined ? [] : _ref$missingComponent,
        _ref$removedDependenc = _ref.removedDependencies,
        removedDependencies = _ref$removedDependenc === undefined ? [] : _ref$removedDependenc,
        _ref$dependentBits = _ref.dependentBits,
        dependentBits = _ref$dependentBits === undefined ? {} : _ref$dependentBits;

    _classCallCheck(this, RemovedObjects);

    this.removedComponentIds = removedComponentIds;
    this.missingComponents = missingComponents;
    this.dependentBits = dependentBits;
    this.removedDependencies = removedDependencies;
  }

  _createClass(RemovedObjects, null, [{
    key: 'fromObjects',
    value: function fromObjects(payload) {
      var missingComponents = payload.missingComponents,
          removedComponentIds = payload.removedComponentIds,
          removedDependencies = payload.removedDependencies,
          dependentBits = payload.dependentBits;

      missingComponents = missingComponents.map(function (id) {
        return new (_bitId || _load_bitId()).BitId(id);
      });
      removedComponentIds = removedComponentIds.map(function (id) {
        return new (_bitId || _load_bitId()).BitId(id);
      });
      removedDependencies = removedDependencies.map(function (id) {
        return new (_bitId || _load_bitId()).BitId(id);
      });
      return new RemovedObjects({ missingComponents, removedComponentIds, removedDependencies, dependentBits });
    }
  }]);

  return RemovedObjects;
}();

var RemovedLocalObjects = exports.RemovedLocalObjects = function (_RemovedObjects) {
  _inherits(RemovedLocalObjects, _RemovedObjects);

  function RemovedLocalObjects(bitIds, missingComponents) {
    var modifiedComponents = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    var dependentBits = arguments[3];
    var removedDependencies = arguments[4];

    _classCallCheck(this, RemovedLocalObjects);

    var _this = _possibleConstructorReturn(this, (RemovedLocalObjects.__proto__ || Object.getPrototypeOf(RemovedLocalObjects)).call(this, bitIds, missingComponents, removedDependencies, dependentBits));

    _this.modifiedComponents = modifiedComponents;
    return _this;
  }

  return RemovedLocalObjects;
}(RemovedObjects);