'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DependencyMap = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.getPath = getPath;

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../bit-id');
}

var _repository;

function _load_repository() {
  return _repository = _interopRequireDefault(require('../repository'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../consumer/component'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _extendableBuiltin(cls) {
  function ExtendableBuiltin() {
    var instance = Reflect.construct(cls, Array.from(arguments));
    Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
    return instance;
  }

  ExtendableBuiltin.prototype = Object.create(cls.prototype, {
    constructor: {
      value: cls,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });

  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(ExtendableBuiltin, cls);
  } else {
    ExtendableBuiltin.__proto__ = cls;
  }

  return ExtendableBuiltin;
}

function getPath(repositoryPath) {
  return (_path || _load_path()).default.join(repositoryPath, (_constants || _load_constants()).DEPENDENCY_MAP_FILENAME);
}

var DependencyMap = exports.DependencyMap = function (_extendableBuiltin2) {
  _inherits(DependencyMap, _extendableBuiltin2);

  function DependencyMap(repository) {
    var dependencyTuples = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

    _classCallCheck(this, DependencyMap);

    var _this = _possibleConstructorReturn(this, (DependencyMap.__proto__ || Object.getPrototypeOf(DependencyMap)).call(this, dependencyTuples));

    _this.repository = repository;
    return _this;
  }

  _createClass(DependencyMap, [{
    key: 'get',
    value: function get(bitId) {
      return _get(DependencyMap.prototype.__proto__ || Object.getPrototypeOf(DependencyMap.prototype), 'get', this).call(this, bitId.toString());
    }
  }, {
    key: 'toObject',
    value: function toObject() {
      var obj = {};
      this.forEach(function (bitIds, bitId) {
        obj[bitId.toString()] = bitIds.map(function (dependency) {
          return dependency.toString();
        });
      });
      return obj;
    }
  }, {
    key: 'getPath',
    value: function getPath() {
      return (_path || _load_path()).default.join(this.repository.getPath(), (_constants || _load_constants()).DEPENDENCY_MAP_FILENAME);
    }
  }, {
    key: 'write',
    value: function write() {
      return (0, (_utils || _load_utils()).writeFile)(this.getPath(), JSON.stringify(this.toObject()));
    }
  }, {
    key: 'setBit',
    value: function setBit(id, bits) {
      _get(DependencyMap.prototype.__proto__ || Object.getPrototypeOf(DependencyMap.prototype), 'set', this).call(this, id.toString(), new (Function.prototype.bind.apply((_bitId || _load_bitId()).BitIds, [null].concat(_toConsumableArray(bits.map(function (bit) {
        return bit.getId();
      })))))());
      return this;
    }
  }], [{
    key: 'load',
    value: function load(json, repository) {
      var matrix = [];
      (0, (_utils || _load_utils()).forEach)(json, function (val, key) {
        matrix.push([key, val.map(function (bitDep) {
          return (_bitId || _load_bitId()).BitId.parse(bitDep.id);
        })]);
      });

      return new DependencyMap(repository, matrix);
    }
  }]);

  return DependencyMap;
}(_extendableBuiltin(Map));