'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var addMigrationVersionKeyGenerator = function addMigrationVersionKeyGenerator(version) {
  var addMigrationVersionKey = function addMigrationVersionKey(model) {
    if (!model.migrationVersion) {
      model.migrationVersion = [version];
    } else {
      model.migrationVersion.push(version);
    }
    return model;
  };

  var addMigrationVersionKeyDeclartaion = {
    name: 'add Migration Version Key',
    migrate: addMigrationVersionKey
  };
  return addMigrationVersionKeyDeclartaion;
};

exports.default = {
  '0.10.9': {
    Component: [addMigrationVersionKeyGenerator('0.10.9')],
    Version: [addMigrationVersionKeyGenerator('0.10.9'), addMigrationVersionKeyGenerator('0.10.9(2)')]
  },
  '0.10.10': {
    Component: [addMigrationVersionKeyGenerator('0.10.10'), addMigrationVersionKeyGenerator('0.10.10(2)')],
    Version: [addMigrationVersionKeyGenerator('0.10.10')]
  }
};