'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SSHInvalidResponse = exports.SSHConnectionError = exports.RemoteScopeNotFound = exports.FsScopeNotLoaded = exports.PermissionDenied = exports.UnexpectedNetworkError = exports.NetworkError = exports.ProtocolNotSupported = exports.AuthenticationFailed = undefined;

var _protocolNotSupported;

function _load_protocolNotSupported() {
  return _protocolNotSupported = _interopRequireDefault(require('./protocol-not-supported'));
}

var _fsScopeNotLoaded;

function _load_fsScopeNotLoaded() {
  return _fsScopeNotLoaded = _interopRequireDefault(require('./fs-scope-not-loaded'));
}

var _remoteScopeNotFound;

function _load_remoteScopeNotFound() {
  return _remoteScopeNotFound = _interopRequireDefault(require('./remote-scope-not-found'));
}

var _sshConnectionError;

function _load_sshConnectionError() {
  return _sshConnectionError = _interopRequireDefault(require('./ssh-connection-error'));
}

var _permissionDenied;

function _load_permissionDenied() {
  return _permissionDenied = _interopRequireDefault(require('./permission-denied'));
}

var _networkError;

function _load_networkError() {
  return _networkError = _interopRequireDefault(require('./network-error'));
}

var _unexpectedNetworkError;

function _load_unexpectedNetworkError() {
  return _unexpectedNetworkError = _interopRequireDefault(require('./unexpected-network-error'));
}

var _sshInvalidResponse;

function _load_sshInvalidResponse() {
  return _sshInvalidResponse = _interopRequireDefault(require('./ssh-invalid-response'));
}

var _authenticationFailed;

function _load_authenticationFailed() {
  return _authenticationFailed = _interopRequireDefault(require('./authentication-failed'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.AuthenticationFailed = (_authenticationFailed || _load_authenticationFailed()).default;
exports.ProtocolNotSupported = (_protocolNotSupported || _load_protocolNotSupported()).default;
exports.NetworkError = (_networkError || _load_networkError()).default;
exports.UnexpectedNetworkError = (_unexpectedNetworkError || _load_unexpectedNetworkError()).default;
exports.PermissionDenied = (_permissionDenied || _load_permissionDenied()).default;
exports.FsScopeNotLoaded = (_fsScopeNotLoaded || _load_fsScopeNotLoaded()).default;
exports.RemoteScopeNotFound = (_remoteScopeNotFound || _load_remoteScopeNotFound()).default;
exports.SSHConnectionError = (_sshConnectionError || _load_sshConnectionError()).default;
exports.SSHInvalidResponse = (_sshInvalidResponse || _load_sshInvalidResponse()).default;