'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _index;

function _load_index() {
  return _index = require('./index');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../bit-id');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _extendableBuiltin(cls) {
  function ExtendableBuiltin() {
    var instance = Reflect.construct(cls, Array.from(arguments));
    Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
    return instance;
  }

  ExtendableBuiltin.prototype = Object.create(cls.prototype, {
    constructor: {
      value: cls,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });

  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(ExtendableBuiltin, cls);
  } else {
    ExtendableBuiltin.__proto__ = cls;
  }

  return ExtendableBuiltin;
}

var SourcesJson = function (_extendableBuiltin2) {
  _inherits(SourcesJson, _extendableBuiltin2);

  function SourcesJson(sourcesTuples, sources) {
    _classCallCheck(this, SourcesJson);

    var _this = _possibleConstructorReturn(this, (SourcesJson.__proto__ || Object.getPrototypeOf(SourcesJson)).call(this, sourcesTuples));

    _this.sources = sources;
    return _this;
  }

  _createClass(SourcesJson, [{
    key: 'getPath',
    value: function getPath() {
      return (_path || _load_path()).default.join(this.sources.getPath(), (_constants || _load_constants()).SOURCES_JSON);
    }
  }, {
    key: 'toPlainObject',
    value: function toPlainObject() {
      var obj = {};

      this.forEach(function (bitIds, bitId) {
        obj[bitId.toString()] = bitIds.serialize();
      });

      return obj;
    }
  }, {
    key: 'toJson',
    value: function toJson() {
      return JSON.stringify(this.toPlainObject());
    }
  }, {
    key: 'write',
    value: function write() {
      return (0, (_utils || _load_utils()).writeFile)(this.getPath(), this.toJson());
    }
  }], [{
    key: 'load',
    value: function load(json, sources) {
      var tuples = [];

      (0, (_utils || _load_utils()).forEach)(json, function (bitIds, bitId) {
        tuples.push([(_bitId || _load_bitId()).BitId.parse(bitId), (_bitId || _load_bitId()).BitIds.deserialize(bitIds)]);
      });

      return new SourcesJson(tuples, sources);
    }
  }]);

  return SourcesJson;
}(_extendableBuiltin(Map));

exports.default = SourcesJson;