'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path;

function _load_path() {
  return _path = _interopRequireWildcard(require('path'));
}

var _semver;

function _load_semver() {
  return _semver = _interopRequireDefault(require('semver'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _ramda2;

function _load_ramda2() {
  return _ramda2 = require('ramda');
}

var _toposortClass;

function _load_toposortClass() {
  return _toposortClass = _interopRequireDefault(require('toposort-class'));
}

var _pMapSeries;

function _load_pMapSeries() {
  return _pMapSeries = _interopRequireDefault(require('p-map-series'));
}

var _globalConfig;

function _load_globalConfig() {
  return _globalConfig = require('../global-config');
}

var _enrichContextFromGlobal;

function _load_enrichContextFromGlobal() {
  return _enrichContextFromGlobal = _interopRequireDefault(require('../hooks/utils/enrich-context-from-global'));
}

var _flattenDependencies;

function _load_flattenDependencies() {
  return _flattenDependencies = require('./flatten-dependencies');
}

var _componentObjects;

function _load_componentObjects() {
  return _componentObjects = _interopRequireDefault(require('./component-objects'));
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('./models/component'));
}

var _source;

function _load_source() {
  return _source = _interopRequireDefault(require('./models/source'));
}

var _models;

function _load_models() {
  return _models = require('./models');
}

var _remotes;

function _load_remotes() {
  return _remotes = require('../remotes');
}

var _objectRegistrar;

function _load_objectRegistrar() {
  return _objectRegistrar = _interopRequireDefault(require('./object-registrar'));
}

var _utils;

function _load_utils() {
  return _utils = require('../utils');
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _scopeJson;

function _load_scopeJson() {
  return _scopeJson = require('./scope-json');
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('./exceptions');
}

var _environment;

function _load_environment() {
  return _environment = _interopRequireDefault(require('../environment'));
}

var _exceptions2;

function _load_exceptions2() {
  return _exceptions2 = require('./network/exceptions');
}

var _repositories;

function _load_repositories() {
  return _repositories = require('./repositories');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

var _component2;

function _load_component2() {
  return _component2 = _interopRequireDefault(require('../consumer/component'));
}

var _componentVersion;

function _load_componentVersion() {
  return _componentVersion = _interopRequireDefault(require('./component-version'));
}

var _objects;

function _load_objects() {
  return _objects = require('./objects');
}

var _componentDependencies;

function _load_componentDependencies() {
  return _componentDependencies = _interopRequireDefault(require('./component-dependencies'));
}

var _versionDependencies;

function _load_versionDependencies() {
  return _versionDependencies = _interopRequireDefault(require('./version-dependencies'));
}

var _sources;

function _load_sources() {
  return _sources = _interopRequireDefault(require('./repositories/sources'));
}

var _npmClient;

function _load_npmClient() {
  return _npmClient = _interopRequireDefault(require('../npm-client'));
}

var _consumer;

function _load_consumer() {
  return _consumer = _interopRequireDefault(require('../consumer/consumer'));
}

var _indexer;

function _load_indexer() {
  return _indexer = require('../search/indexer');
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../cli/loader'));
}

var _migrationHelper;

function _load_migrationHelper() {
  return _migrationHelper = require('../migration/migration-helper');
}

var _scopeMigratorManifest;

function _load_scopeMigratorManifest() {
  return _scopeMigratorManifest = _interopRequireDefault(require('./migrations/scope-migrator-manifest'));
}

var _scopeMigrator;

function _load_scopeMigrator() {
  return _scopeMigrator = _interopRequireDefault(require('./migrations/scope-migrator'));
}

var _scopeMigrator2;

function _load_scopeMigrator2() {
  return _scopeMigrator2 = require('./migrations/scope-migrator');
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../cli/loader/loader-messages');
}

var _ciOps;

function _load_ciOps() {
  return _ciOps = _interopRequireDefault(require('./ci-ops'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

var _componentResolver;

function _load_componentResolver() {
  return _componentResolver = _interopRequireDefault(require('../component-resolver'));
}

var _componentsList;

function _load_componentsList() {
  return _componentsList = _interopRequireDefault(require('../consumer/component/components-list'));
}

var _componentRemove;

function _load_componentRemove() {
  return _componentRemove = require('./component-remove');
}

var _consumerComponent;

function _load_consumerComponent() {
  return _consumerComponent = _interopRequireDefault(require('../consumer/component/consumer-component'));
}

var _graph;

function _load_graph() {
  return _graph = _interopRequireDefault(require('./graph/graph'));
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var removeNils = (_ramda || _load_ramda()).default.reject((_ramda || _load_ramda()).default.isNil);
var pathHasScope = (0, (_utils || _load_utils()).pathHas)([(_constants || _load_constants()).OBJECTS_DIR, (_constants || _load_constants()).BIT_HIDDEN_DIR, (_path || _load_path()).join((_constants || _load_constants()).DOT_GIT_DIR, (_constants || _load_constants()).BIT_GIT_DIR)]);

var Scope = function () {
  // cache DependencyGraph instance

  // sources: SourcesRepository; // for some reason it interferes with the IDE autocomplete
  function Scope(scopeProps) {
    _classCallCheck(this, Scope);

    this.created = false;

    this.path = scopeProps.path;
    this.scopeJson = scopeProps.scopeJson;
    this.created = scopeProps.created || false;
    this.tmp = scopeProps.tmp || new (_repositories || _load_repositories()).Tmp(this);
    this.sources = scopeProps.sources || new (_sources || _load_sources()).default(this);
    this.objects = scopeProps.objects || new (_objects || _load_objects()).Repository(this, (0, (_objectRegistrar || _load_objectRegistrar()).default)());
  }

  _createClass(Scope, [{
    key: 'getDependencyGraph',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this._dependencyGraph) {
                  _context.next = 4;
                  break;
                }

                _context.next = 3;
                return (_graph || _load_graph()).default.load(this.objects);

              case 3:
                this._dependencyGraph = _context.sent;

              case 4:
                return _context.abrupt('return', this._dependencyGraph);

              case 5:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getDependencyGraph() {
        return _ref.apply(this, arguments);
      }

      return getDependencyGraph;
    }()
  }, {
    key: 'getPath',
    value: function getPath() {
      return this.path;
    }
  }, {
    key: 'getComponentsPath',
    value: function getComponentsPath() {
      return (_path || _load_path()).join(this.path, Scope.getComponentsRelativePath());
    }

    /**
     * Get the releative components path inside the scope
     * (components such as compilers / testers / extensions)
     * currently components
     */

  }, {
    key: 'getBitPathInComponentsDir',
    value: function getBitPathInComponentsDir(id) {
      return (_path || _load_path()).join(this.getComponentsPath(), id.toFullPath());
    }

    /**
     * Running migration process for scope to update the stores (bit objects) to the current version
     *
     * @param {any} verbose - print debug logs
     * @returns {Object} - wether the process run and wether it successeded
     * @memberof Consumer
     */

  }, {
    key: 'migrate',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(verbose) {
        var scopeVersion, rawObjects, resultObjects;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (_logger || _load_logger()).default.debug('running migration process for scope');
                if (verbose) console.log('running migration process for scope'); // eslint-disable-line
                // We start to use this process after version 0.10.9, so we assume the scope is in the last production version
                scopeVersion = this.scopeJson.get('version') || '0.10.9';

                if (!(_semver || _load_semver()).default.gte(scopeVersion, (_constants || _load_constants()).BIT_VERSION)) {
                  _context2.next = 6;
                  break;
                }

                (_logger || _load_logger()).default.debug('scope version is up to date');
                return _context2.abrupt('return', {
                  run: false
                });

              case 6:
                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_MIGRATION);
                _context2.next = 9;
                return this.objects.listRawObjects();

              case 9:
                rawObjects = _context2.sent;
                _context2.next = 12;
                return (0, (_scopeMigrator || _load_scopeMigrator()).default)(scopeVersion, (_scopeMigratorManifest || _load_scopeMigratorManifest()).default, rawObjects, verbose);

              case 12:
                resultObjects = _context2.sent;

                // Add the new / updated objects
                this.objects.addMany(resultObjects.newObjects);
                // Remove old objects
                _context2.next = 16;
                return this.objects.removeMany(resultObjects.refsToRemove);

              case 16:
                _context2.next = 18;
                return this.objects.persist();

              case 18:
                // Update the scope version
                this.scopeJson.set('version', (_constants || _load_constants()).BIT_VERSION);
                (_logger || _load_logger()).default.debug(`updating scope version to version ${(_constants || _load_constants()).BIT_VERSION}`);
                _context2.next = 22;
                return this.scopeJson.write(this.getPath());

              case 22:
                return _context2.abrupt('return', {
                  run: true,
                  success: true
                });

              case 23:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function migrate(_x) {
        return _ref2.apply(this, arguments);
      }

      return migrate;
    }()
  }, {
    key: 'remotes',
    value: function remotes() {
      var self = this;
      function mergeRemotes(globalRemotes) {
        var globalObj = globalRemotes.toPlainObject();
        return (_remotes || _load_remotes()).Remotes.load((0, (_ramda2 || _load_ramda2()).merge)(globalObj, self.scopeJson.remotes));
      }

      return (_globalConfig || _load_globalConfig()).GlobalRemotes.load().then(mergeRemotes);
    }
  }, {
    key: 'describe',
    value: function describe() {
      return {
        name: this.name
      };
    }
  }, {
    key: 'toConsumerComponents',
    value: function toConsumerComponents(components) {
      var _this = this;

      return Promise.all(components.filter(function (comp) {
        return !(comp instanceof (_models || _load_models()).Symlink);
      }).map(function (c) {
        return c.toConsumerComponent(c.latestExisting(_this.objects).toString(), _this.name, _this.objects);
      }));
    }
  }, {
    key: 'list',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3() {
        var showRemoteVersion = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
        var components, consumerComponents, componentsIds, latestVersionsInfo;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.objects.listComponents();

              case 2:
                components = _context3.sent;
                _context3.next = 5;
                return this.toConsumerComponents(components);

              case 5:
                consumerComponents = _context3.sent;

                if (!showRemoteVersion) {
                  _context3.next = 12;
                  break;
                }

                componentsIds = consumerComponents.map(function (component) {
                  return component.id;
                });
                _context3.next = 10;
                return this.fetchRemoteVersions(componentsIds);

              case 10:
                latestVersionsInfo = _context3.sent;

                latestVersionsInfo.forEach(function (componentId) {
                  var component = consumerComponents.find(function (c) {
                    return c.id.toStringWithoutVersion() === componentId.toStringWithoutVersion();
                  });
                  component.latest = componentId.version;
                });

              case 12:
                return _context3.abrupt('return', (_componentsList || _load_componentsList()).default.sortComponentsByName(consumerComponents));

              case 13:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function list() {
        return _ref3.apply(this, arguments);
      }

      return list;
    }()
  }, {
    key: 'listStage',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4() {
        var _this2 = this;

        var components, scopeComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.objects.listComponents(false);

              case 2:
                components = _context4.sent;
                _context4.next = 5;
                return this.toConsumerComponents(components.filter(function (c) {
                  return !c.scope || c.scope === _this2.name;
                }));

              case 5:
                scopeComponents = _context4.sent;
                return _context4.abrupt('return', (_componentsList || _load_componentsList()).default.sortComponentsByName(scopeComponents));

              case 7:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function listStage() {
        return _ref4.apply(this, arguments);
      }

      return listStage;
    }()
  }, {
    key: 'fetchRemoteVersions',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(componentIds) {
        var _this3 = this;

        var externals, remotes;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                externals = componentIds.filter(function (id) {
                  return !id.isLocal(_this3.name);
                });
                _context5.next = 3;
                return this.remotes();

              case 3:
                remotes = _context5.sent;
                return _context5.abrupt('return', remotes.latestVersions(externals, this));

              case 5:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function fetchRemoteVersions(_x3) {
        return _ref5.apply(this, arguments);
      }

      return fetchRemoteVersions;
    }()
  }, {
    key: 'latestVersions',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(componentIds) {
        var throwOnFailure = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var components;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                componentIds = componentIds.map(function (componentId) {
                  return (_bitId || _load_bitId()).BitId.parse(componentId.toStringWithoutVersion());
                });
                _context6.next = 3;
                return this.sources.getMany(componentIds);

              case 3:
                components = _context6.sent;
                return _context6.abrupt('return', components.map(function (component) {
                  var componentId = (_bitId || _load_bitId()).BitId.parse(component.id.toString());
                  if (component.component) {
                    componentId.version = component.component.latest();
                  } else {
                    if (throwOnFailure) throw new (_exceptions || _load_exceptions()).ComponentNotFound(component.id.toString());
                    componentId.version = (_constants || _load_constants()).DEFAULT_BIT_VERSION;
                  }
                  return componentId;
                }));

              case 5:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function latestVersions(_x5) {
        return _ref6.apply(this, arguments);
      }

      return latestVersions;
    }()
  }, {
    key: 'importDependencies',
    value: function importDependencies(dependencies) {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        return _this4.importMany(dependencies).then(resolve).catch(function (e) {
          (_logger || _load_logger()).default.error(`importDependencies got an error: ${JSON.stringify(e)}`);
          if (e instanceof (_exceptions2 || _load_exceptions2()).RemoteScopeNotFound || e instanceof (_exceptions2 || _load_exceptions2()).PermissionDenied) return reject(e);
          return reject(new (_exceptions || _load_exceptions()).DependencyNotFound(e.id));
        });
      });
    }
  }, {
    key: 'putMany',
    value: function () {
      var _ref8 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee10(_ref7) {
        var _this5 = this;

        var consumerComponents = _ref7.consumerComponents,
            message = _ref7.message,
            exactVersion = _ref7.exactVersion,
            releaseType = _ref7.releaseType,
            force = _ref7.force,
            consumer = _ref7.consumer,
            verbose = _ref7.verbose;
        var topSort, allDependencies, consumerComponentsIdsMap, sortedConsumerComponentsIds, getFlattenForDependency, getFlattenForComponent, componentsToBuild, testsResults, persistComponentsP, components;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                // TODO: Change the return type
                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_IMPORT_PUT_ON_SCOPE);
                topSort = new (_toposortClass || _load_toposortClass()).default();
                allDependencies = new Map();
                consumerComponentsIdsMap = new Map();
                // Concat and unique all the dependencies from all the components so we will not import
                // the same dependency more then once, it's mainly for performance purpose

                consumerComponents.forEach(function (consumerComponent) {
                  var componentIdString = consumerComponent.id.toString();
                  // Store it in a map so we can take it easily from the sorted array which contain only the id
                  consumerComponentsIdsMap.set(componentIdString, consumerComponent);
                  var dependenciesIdsStrings = consumerComponent.getAllDependencies().map(function (dependency) {
                    return dependency.id.toString();
                  });
                  topSort.add(componentIdString, dependenciesIdsStrings || []);
                });

                sortedConsumerComponentsIds = void 0;
                // Sort the consumerComponents by the dependency order so we can commit those without the dependencies first

                _context10.prev = 6;

                sortedConsumerComponentsIds = topSort.sort().reverse();
                _context10.next = 13;
                break;

              case 10:
                _context10.prev = 10;
                _context10.t0 = _context10['catch'](6);
                throw new (_exceptions || _load_exceptions()).CyclicDependencies(_context10.t0);

              case 13:
                getFlattenForDependency = function () {
                  var _ref9 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7(dependency, cache) {
                    var flattenedDependencies, versionDependencies;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            // Try to get the flatten dependencies from cache
                            flattenedDependencies = cache.get(dependency.id.toString());

                            if (!flattenedDependencies) {
                              _context7.next = 3;
                              break;
                            }

                            return _context7.abrupt('return', Promise.resolve(flattenedDependencies));

                          case 3:

                            // Calculate the flatten dependencies
                            if (consumerComponentsIdsMap.has(dependency.id.toStringWithoutVersion()) || consumerComponentsIdsMap.has(dependency.id.toString())) {
                              // when a dependency includes in the components list to tag, don't use the existing version, because the
                              // existing version will be obsolete once it's tagged. Instead, remove the version, and later on, when
                              // importDependencies is called, it'll fetch the newly tagged version.
                              dependency.id.version = undefined;
                            }
                            _context7.next = 6;
                            return _this5.importDependencies([dependency.id]);

                          case 6:
                            versionDependencies = _context7.sent;

                            // Copy the exact version from flattenedDependency to dependencies
                            if (!dependency.id.hasVersion()) {
                              dependency.id.version = (0, (_utils || _load_utils()).first)(versionDependencies).component.version;
                            }

                            _context7.next = 10;
                            return (0, (_flattenDependencies || _load_flattenDependencies()).flattenDependencyIds)(versionDependencies, _this5.objects);

                          case 10:
                            flattenedDependencies = _context7.sent;


                            // Store the flatten dependencies in cache
                            cache.set(dependency.id.toString(), flattenedDependencies);

                            return _context7.abrupt('return', flattenedDependencies);

                          case 13:
                          case 'end':
                            return _context7.stop();
                        }
                      }
                    }, _callee7, _this5);
                  }));

                  return function getFlattenForDependency(_x7, _x8) {
                    return _ref9.apply(this, arguments);
                  };
                }();

                getFlattenForComponent = function () {
                  var _ref10 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee8(consumerComponent, cache) {
                    var dev = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
                    var dependencies, flattenedDependenciesP, flattenedDependencies, predicate;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee8$(_context8) {
                      while (1) {
                        switch (_context8.prev = _context8.next) {
                          case 0:
                            dependencies = dev ? consumerComponent.devDependencies : consumerComponent.dependencies;
                            flattenedDependenciesP = dependencies.get().map(function (dependency) {
                              return getFlattenForDependency(dependency, cache);
                            });
                            _context8.next = 4;
                            return Promise.all(flattenedDependenciesP);

                          case 4:
                            flattenedDependencies = _context8.sent;

                            flattenedDependencies = (_ramda || _load_ramda()).default.flatten(flattenedDependencies);

                            predicate = function predicate(id) {
                              return id.toString();
                            }; // TODO: should be moved to BitId class


                            return _context8.abrupt('return', (_ramda || _load_ramda()).default.uniqBy(predicate)(flattenedDependencies));

                          case 8:
                          case 'end':
                            return _context8.stop();
                        }
                      }
                    }, _callee8, _this5);
                  }));

                  return function getFlattenForComponent(_x10, _x11) {
                    return _ref10.apply(this, arguments);
                  };
                }();

                (_logger || _load_logger()).default.debug('scope.putMany: sequentially build all components');
                componentsToBuild = sortedConsumerComponentsIds.map(function (id) {
                  return consumerComponentsIdsMap.get(id);
                }).filter(function (c) {
                  return c;
                });
                _context10.next = 19;
                return this.buildMultiple(componentsToBuild, consumer, verbose);

              case 19:

                (_logger || _load_logger()).default.debug('scope.putMany: sequentially test all components');
                _context10.next = 22;
                return this.testMultiple(componentsToBuild, consumer, verbose, !force);

              case 22:
                testsResults = _context10.sent;


                (_logger || _load_logger()).default.debug('scope.putMany: sequentially persist all components');
                persistComponentsP = sortedConsumerComponentsIds.map(function (consumerComponentId) {
                  return _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee9() {
                    var consumerComponent, flattenedDependencies, flattenedDevDependencies, addSharedDirAndDistEntry, dists, testResult, component, deps;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee9$(_context9) {
                      while (1) {
                        switch (_context9.prev = _context9.next) {
                          case 0:
                            consumerComponent = consumerComponentsIdsMap.get(consumerComponentId);
                            // This happens when there is a dependency which have been already committed

                            if (consumerComponent) {
                              _context9.next = 3;
                              break;
                            }

                            return _context9.abrupt('return', Promise.resolve([]));

                          case 3:
                            _context9.next = 5;
                            return getFlattenForComponent(consumerComponent, allDependencies);

                          case 5:
                            flattenedDependencies = _context9.sent;
                            _context9.next = 8;
                            return getFlattenForComponent(consumerComponent, allDependencies, true);

                          case 8:
                            flattenedDevDependencies = _context9.sent;

                            // when a component is written to the filesystem, the originallySharedDir may be stripped, if it was, the
                            // originallySharedDir is written in bit.map, and then set in consumerComponent.originallySharedDir when loaded.
                            // similarly, when the dists are written to the filesystem, the dist.entry may be stripped, if it was, the
                            // consumerComponent.dists.distEntryShouldBeStripped is set to true.
                            // because the model always has the paths of the original author, in case part of the path was stripped, add it
                            // back before saving to the model. this way, when the author updates the components, the paths will be correct.
                            addSharedDirAndDistEntry = function addSharedDirAndDistEntry(pathStr) {
                              var withSharedDir = consumerComponent.originallySharedDir ? (_path || _load_path()).join(consumerComponent.originallySharedDir, pathStr) : pathStr;
                              var withDistEntry = consumerComponent.dists.distEntryShouldBeStripped ? (_path || _load_path()).join(consumer.bitJson.distEntry, withSharedDir) : withSharedDir;
                              return (0, (_utils || _load_utils()).pathNormalizeToLinux)(withDistEntry);
                            };

                            dists = !consumerComponent.dists.isEmpty() ? consumerComponent.dists.get().map(function (dist) {
                              return {
                                name: dist.basename,
                                relativePath: addSharedDirAndDistEntry(dist.relative),
                                file: (_source || _load_source()).default.from(dist.contents),
                                test: dist.test
                              };
                            }) : null;
                            testResult = testsResults.find(function (result) {
                              return result.component.id.toString() === consumerComponentId;
                            });
                            _context9.next = 14;
                            return _this5.sources.addSource({
                              source: consumerComponent,
                              flattenedDependencies,
                              flattenedDevDependencies,
                              message,
                              exactVersion,
                              releaseType,
                              dists,
                              specsResults: testResult ? testResult.specs : undefined
                            });

                          case 14:
                            component = _context9.sent;
                            _context9.next = 17;
                            return component.toVersionDependencies((_constants || _load_constants()).LATEST, _this5, _this5.name);

                          case 17:
                            deps = _context9.sent;

                            consumerComponent.version = deps.component.version;
                            _context9.next = 21;
                            return deps.toConsumer(_this5.objects);

                          case 21:
                            return _context9.abrupt('return', consumerComponent);

                          case 22:
                          case 'end':
                            return _context9.stop();
                        }
                      }
                    }, _callee9, _this5);
                  }));
                });

                // Run the persistence one by one not in parallel!

                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_PERSISTING_PUT_ON_SCOPE);
                _context10.next = 28;
                return persistComponentsP.reduce(function (promise, func) {
                  return promise.then(function (result) {
                    return func().then(Array.prototype.concat.bind(result));
                  });
                }, Promise.resolve([]));

              case 28:
                components = _context10.sent;
                _context10.next = 31;
                return this.objects.persist();

              case 31:
                return _context10.abrupt('return', components);

              case 32:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this, [[6, 10]]);
      }));

      function putMany(_x6) {
        return _ref8.apply(this, arguments);
      }

      return putMany;
    }()

    /**
     * Build multiple components sequentially, not in parallel.
     *
     * Two reasons why not running them in parallel:
     * 1) when several components have the same environment, it'll try to install them multiple times.
     * 2) npm throws errors when running 'npm install' from several directories
     */

  }, {
    key: 'buildMultiple',
    value: function () {
      var _ref12 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee12(components, consumer, verbose) {
        var _this6 = this;

        var build;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                (_logger || _load_logger()).default.debug('scope.buildMultiple: sequentially build multiple components');
                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_RUNNING_BUILD);

                build = function () {
                  var _ref13 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee11(component) {
                    var buildResults;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee11$(_context11) {
                      while (1) {
                        switch (_context11.prev = _context11.next) {
                          case 0:
                            _context11.next = 2;
                            return component.build({ scope: _this6, consumer, verbose });

                          case 2:
                            _context11.next = 4;
                            return component.dists.writeDists(component, consumer);

                          case 4:
                            buildResults = _context11.sent;
                            return _context11.abrupt('return', { component: component.id.toString(), buildResults });

                          case 6:
                          case 'end':
                            return _context11.stop();
                        }
                      }
                    }, _callee11, _this6);
                  }));

                  return function build(_x15) {
                    return _ref13.apply(this, arguments);
                  };
                }();

                return _context12.abrupt('return', (0, (_pMapSeries || _load_pMapSeries()).default)(components, build));

              case 4:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function buildMultiple(_x12, _x13, _x14) {
        return _ref12.apply(this, arguments);
      }

      return buildMultiple;
    }()

    /**
     * Test multiple components sequentially, not in parallel.
     *
     * See the reason not to run them in parallel at @buildMultiple()
     */

  }, {
    key: 'testMultiple',
    value: function () {
      var _ref14 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee14(components, consumer, verbose, rejectOnFailure) {
        var _this7 = this;

        var test;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                (_logger || _load_logger()).default.debug('scope.testMultiple: sequentially test multiple components');
                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_RUNNING_SPECS);

                test = function () {
                  var _ref15 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee13(component) {
                    var specs;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee13$(_context13) {
                      while (1) {
                        switch (_context13.prev = _context13.next) {
                          case 0:
                            if (component.testerId) {
                              _context13.next = 2;
                              break;
                            }

                            return _context13.abrupt('return', { component, missingTester: true });

                          case 2:
                            _context13.next = 4;
                            return component.runSpecs({
                              scope: _this7,
                              rejectOnFailure,
                              consumer,
                              verbose
                            });

                          case 4:
                            specs = _context13.sent;
                            return _context13.abrupt('return', { component, specs });

                          case 6:
                          case 'end':
                            return _context13.stop();
                        }
                      }
                    }, _callee13, _this7);
                  }));

                  return function test(_x20) {
                    return _ref15.apply(this, arguments);
                  };
                }();

                return _context14.abrupt('return', (0, (_pMapSeries || _load_pMapSeries()).default)(components, test));

              case 4:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function testMultiple(_x16, _x17, _x18, _x19) {
        return _ref14.apply(this, arguments);
      }

      return testMultiple;
    }()

    /**
     * Writes a component as an object into the 'objects' directory
     */

  }, {
    key: 'writeComponentToModel',
    value: function writeComponentToModel(componentObjects) {
      var _this8 = this;

      var objects = componentObjects.toObjects(this.objects);
      (_logger || _load_logger()).default.debug(`writeComponentToModel, writing into the model, Main id: ${objects.component.id()}. It might have dependencies which are going to be written too`);
      return this.sources.merge(objects).then(function () {
        return _this8.objects.persist();
      });
    }

    /**
     * Writes components as objects into the 'objects' directory
     */

  }, {
    key: 'writeManyComponentsToModel',
    value: function () {
      var _ref16 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee15(componentsObjects) {
        var _this9 = this;

        var persist = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var manyObjects;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                manyObjects = componentsObjects.map(function (componentObjects) {
                  return componentObjects.toObjects(_this9.objects);
                });

                (_logger || _load_logger()).default.debug(`writeComponentToModel, writing into the model, ids: ${manyObjects.map(function (objects) {
                  return objects.component.id();
                }).join(', ')}. They might have dependencies which are going to be written too`);
                _context15.next = 4;
                return Promise.all(manyObjects.map(function (objects) {
                  return _this9.sources.merge(objects);
                }));

              case 4:
                return _context15.abrupt('return', persist ? this.objects.persist() : Promise.resolve());

              case 5:
              case 'end':
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function writeManyComponentsToModel(_x22) {
        return _ref16.apply(this, arguments);
      }

      return writeManyComponentsToModel;
    }()

    /**
     * When exporting components with dependencies to a bare-scope, some of the dependencies may be created locally and as
     * as result their scope-name is null. Once the bare-scope gets the components, it needs to convert these scope names
     * to the bare-scope name.
     * Since the changes it does affect the Version objects, the version REF of a component, needs to be changed as well.
     */

  }, {
    key: '_convertNonScopeToCorrectScope',
    value: function _convertNonScopeToCorrectScope(componentsObjects, remoteScope) {
      var _this10 = this;

      var changeScopeIfNeeded = function changeScopeIfNeeded(dependencyId) {
        if (!dependencyId.scope) {
          var depId = (_component || _load_component()).default.fromBitId(dependencyId);
          // todo: use 'load' for async and switch the foreach with map.
          var dependencyObject = _this10.objects.loadSync(depId.hash());
          if (dependencyObject instanceof (_models || _load_models()).Symlink) {
            dependencyId.scope = dependencyObject.realScope;
          } else {
            dependencyId.scope = remoteScope;
          }
        }
      };

      componentsObjects.objects.forEach(function (object) {
        if (object instanceof (_models || _load_models()).Version) {
          var hashBefore = object.hash().toString();
          object.getAllDependencies().forEach(function (dependency) {
            changeScopeIfNeeded(dependency.id);
          });
          object.getAllFlattenedDependencies().forEach(function (dependency) {
            changeScopeIfNeeded(dependency);
          });
          var hashAfter = object.hash().toString();
          if (hashBefore !== hashAfter) {
            (_logger || _load_logger()).default.debug(`switching ${componentsObjects.component.id()} version hash from ${hashBefore} to ${hashAfter}`);
            var _versions = componentsObjects.component.versions;
            Object.keys(_versions).forEach(function (version) {
              if (_versions[version].toString() === hashBefore) {
                _versions[version] = (_objects || _load_objects()).Ref.from(hashAfter);
              }
            });
          }
        }
      });

      componentsObjects.component.scope = remoteScope;
    }

    /**
     * @TODO there is no real difference between bare scope and a working directory scope - let's adjust terminology to avoid confusions in the future
     * saves a component into the objects directory of the remote scope, then, resolves its
     * dependencies, saves them as well. Finally runs the build process if needed on an isolated
     * environment.
     */

  }, {
    key: 'exportManyBareScope',
    value: function () {
      var _ref17 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee16(componentsObjects) {
        var _this11 = this;

        var manyObjects, manyCompVersions, versions, manyConsumerComponent, ids;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`exportManyBareScope: Going to save ${componentsObjects.length} components`);
                manyObjects = componentsObjects.map(function (componentObjects) {
                  return componentObjects.toObjects(_this11.objects);
                });
                _context16.next = 4;
                return Promise.all(manyObjects.map(function (objects) {
                  return _this11.sources.merge(objects, true, false);
                }));

              case 4:
                _context16.next = 6;
                return Promise.all(manyObjects.map(function (objects) {
                  return objects.component.toComponentVersion((_constants || _load_constants()).LATEST);
                }));

              case 6:
                manyCompVersions = _context16.sent;

                (_logger || _load_logger()).default.debug('exportManyBareScope: will try to importMany in case there are missing dependencies');
                _context16.next = 10;
                return this.importMany(manyCompVersions.map(function (compVersion) {
                  return compVersion.id;
                }), undefined, true, false);

              case 10:
                versions = _context16.sent;
                // resolve dependencies
                (_logger || _load_logger()).default.debug('exportManyBareScope: successfully ran importMany');
                _context16.next = 14;
                return this.objects.persist();

              case 14:
                _context16.next = 16;
                return Promise.all(versions.map(function (version) {
                  return version.toObjects(_this11.objects);
                }));

              case 16:
                _context16.next = 18;
                return Promise.all(manyCompVersions.map(function (compVersion) {
                  return compVersion.toConsumer(_this11.objects);
                }));

              case 18:
                manyConsumerComponent = _context16.sent;

                // await Promise.all(manyConsumerComponent.map(consumerComponent => index(consumerComponent, this.getPath())));
                ids = manyConsumerComponent.map(function (consumerComponent) {
                  return consumerComponent.id.toString();
                });
                _context16.next = 22;
                return Promise.all(manyConsumerComponent.map(function (consumerComponent) {
                  return (0, (_ciOps || _load_ciOps()).default)(consumerComponent, _this11.getPath());
                }));

              case 22:
                return _context16.abrupt('return', ids);

              case 23:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function exportManyBareScope(_x23) {
        return _ref17.apply(this, arguments);
      }

      return exportManyBareScope;
    }()
  }, {
    key: 'getExternalOnes',
    value: function getExternalOnes(ids, remotes) {
      var _this12 = this;

      var localFetch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var context = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      (_logger || _load_logger()).default.debug(`getExternalOnes, ids: ${ids.join(', ')}`);
      (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
      return this.sources.getMany(ids).then(function (defs) {
        var left = defs.filter(function (def) {
          if (!localFetch) return true;
          if (!def.component) return true;
          return false;
        });

        if (left.length === 0) {
          (_logger || _load_logger()).default.debug('getExternalOnes: no more ids left, all found locally, existing the method');
          return Promise.all(defs.map(function (def) {
            return def.component.toComponentVersion(def.id.version);
          }));
        }

        (_logger || _load_logger()).default.debug(`getExternalOnes: ${left.length} left. Fetching them from a remote`);
        return remotes.fetch(left.map(function (def) {
          return def.id;
        }), _this12, true, context).then(function (componentObjects) {
          return _this12.writeManyComponentsToModel(componentObjects);
        }).then(function () {
          return _this12.getExternalOnes(ids, remotes, true);
        });
      });
    }

    /**
     * If found locally, use them. Otherwise, fetch from remote and then, save into the model.
     */

  }, {
    key: 'getExternalMany',
    value: function getExternalMany(ids, remotes) {
      var localFetch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var _this13 = this;

      var persist = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      var context = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};

      (_logger || _load_logger()).default.debug(`getExternalMany, planning on fetching from ${localFetch ? 'local' : 'remote'} scope. Ids: ${ids.join(', ')}`);
      (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
      return this.sources.getMany(ids).then(function (defs) {
        var left = defs.filter(function (def) {
          if (!localFetch) return true;
          if (!def.component) return true;
          return false;
        });

        if (left.length === 0) {
          (_logger || _load_logger()).default.debug('getExternalMany: no more ids left, all found locally, existing the method');
          // $FlowFixMe - there should be a component because there no defs without components left.
          return Promise.all(defs.map(function (def) {
            return def.component.toVersionDependencies(def.id.version, _this13, def.id.scope);
          }));
        }

        (_logger || _load_logger()).default.debug(`getExternalMany: ${left.length} left. Fetching them from a remote`);
        return remotes.fetch(left.map(function (def) {
          return def.id;
        }), _this13, undefined, context).then(function (componentObjects) {
          (_logger || _load_logger()).default.debug('getExternalMany: writing them to the model');
          return _this13.writeManyComponentsToModel(componentObjects, persist);
        }).then(function () {
          return _this13.getExternalMany(ids, remotes);
        });
      });
    }

    /**
     * If the component is not in the local scope, fetch it from a remote and save into the local
     * scope. (objects directory).
     */

  }, {
    key: 'getExternal',
    value: function getExternal(_ref18) {
      var _this14 = this;

      var id = _ref18.id,
          remotes = _ref18.remotes,
          _ref18$localFetch = _ref18.localFetch,
          localFetch = _ref18$localFetch === undefined ? true : _ref18$localFetch,
          _ref18$context = _ref18.context,
          context = _ref18$context === undefined ? {} : _ref18$context;

      (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
      return this.sources.get(id).then(function (component) {
        if (component && localFetch) {
          return component.toVersionDependencies(id.version, _this14, id.scope);
        }

        return remotes.fetch([id], _this14, undefined, context).then(function (_ref19) {
          var _ref20 = _slicedToArray(_ref19, 1),
              componentObjects = _ref20[0];

          return _this14.writeComponentToModel(componentObjects);
        }).then(function () {
          return _this14.getExternal({ id, remotes, localFetch: true });
        });
      });
    }
  }, {
    key: 'getExternalOne',
    value: function getExternalOne(_ref21) {
      var _this15 = this;

      var id = _ref21.id,
          remotes = _ref21.remotes,
          _ref21$localFetch = _ref21.localFetch,
          localFetch = _ref21$localFetch === undefined ? true : _ref21$localFetch,
          _ref21$context = _ref21.context,
          context = _ref21$context === undefined ? {} : _ref21$context;

      return this.sources.get(id).then(function (component) {
        if (component && localFetch) return component.toComponentVersion(id.version);
        return remotes.fetch([id], _this15, true, context).then(function (_ref22) {
          var _ref23 = _slicedToArray(_ref22, 1),
              componentObjects = _ref23[0];

          return _this15.writeComponentToModel(componentObjects);
        }).then(function () {
          return _this15.getExternal({ id, remotes, localFetch: true });
        });
      });
    }
  }, {
    key: 'getObjects',
    value: function () {
      var _ref24 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee17(ids, withDevDependencies) {
        var _this16 = this;

        var versions;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                _context17.next = 2;
                return this.importMany(ids, withDevDependencies);

              case 2:
                versions = _context17.sent;
                return _context17.abrupt('return', Promise.all(versions.map(function (version) {
                  return version.toObjects(_this16.objects);
                })));

              case 4:
              case 'end':
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));

      function getObjects(_x29, _x30) {
        return _ref24.apply(this, arguments);
      }

      return getObjects;
    }()
  }, {
    key: 'getObject',
    value: function getObject(hash) {
      return new (_objects || _load_objects()).Ref(hash).load(this.objects);
    }
  }, {
    key: 'getRawObject',
    value: function getRawObject(hash) {
      return this.objects.loadRawObject(new (_objects || _load_objects()).Ref(hash));
    }

    /**
     * 1. Local objects, fetch from local. (done by this.sources.getMany method)
     * 2. Fetch flattened dependencies (done by toVersionDependencies method). If they're not locally, fetch from remote
     * and save them locally.
     * 3. External objects, fetch from a remote and save locally. (done by this.getExternalOnes method).
     */

  }, {
    key: 'importMany',
    value: function () {
      var _ref25 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee18(ids, withEnvironments) {
        var _this17 = this;

        var cache = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var persist = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

        var idsWithoutNils, _splitWhen, _splitWhen2, externals, locals, localDefs, versionDeps, remotes, externalDeps;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.importMany: ${ids.join(', ')}`);
                idsWithoutNils = removeNils(ids);

                if (!(_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) {
                  _context18.next = 4;
                  break;
                }

                return _context18.abrupt('return', Promise.resolve([]));

              case 4:
                _splitWhen = (0, (_ramda2 || _load_ramda2()).splitWhen)(function (id) {
                  return id.isLocal(_this17.name);
                }, idsWithoutNils), _splitWhen2 = _slicedToArray(_splitWhen, 2), externals = _splitWhen2[0], locals = _splitWhen2[1];
                _context18.next = 7;
                return this.sources.getMany(locals);

              case 7:
                localDefs = _context18.sent;
                _context18.next = 10;
                return Promise.all(localDefs.map(function (def) {
                  if (!def.component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(def.id.toString());
                  return def.component.toVersionDependencies(def.id.version, _this17, def.id.scope, withEnvironments);
                }));

              case 10:
                versionDeps = _context18.sent;

                (_logger || _load_logger()).default.debug('scope.importMany: successfully fetched local components and their dependencies. Going to fetch externals');
                _context18.next = 14;
                return this.remotes();

              case 14:
                remotes = _context18.sent;
                _context18.next = 17;
                return this.getExternalMany(externals, remotes, cache, persist);

              case 17:
                externalDeps = _context18.sent;
                return _context18.abrupt('return', versionDeps.concat(externalDeps));

              case 19:
              case 'end':
                return _context18.stop();
            }
          }
        }, _callee18, this);
      }));

      function importMany(_x33, _x34) {
        return _ref25.apply(this, arguments);
      }

      return importMany;
    }()
  }, {
    key: 'importManyOnes',
    value: function () {
      var _ref26 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee19(ids, cache) {
        var _this18 = this;

        var idsWithoutNils, _splitBy, _splitBy2, externals, locals, localDefs, componentVersionArr, remotes, externalDeps;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee19$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.importManyOnes. Ids: ${ids.join(', ')}`);
                idsWithoutNils = removeNils(ids);

                if (!(_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) {
                  _context19.next = 4;
                  break;
                }

                return _context19.abrupt('return', Promise.resolve([]));

              case 4:
                _splitBy = (0, (_utils || _load_utils()).splitBy)(idsWithoutNils, function (id) {
                  return id.isLocal(_this18.name);
                }), _splitBy2 = _slicedToArray(_splitBy, 2), externals = _splitBy2[0], locals = _splitBy2[1];
                _context19.next = 7;
                return this.sources.getMany(locals);

              case 7:
                localDefs = _context19.sent;
                _context19.next = 10;
                return Promise.all(localDefs.map(function (def) {
                  if (!def.component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(def.id.toString());
                  return def.component.toComponentVersion(def.id.version);
                }));

              case 10:
                componentVersionArr = _context19.sent;
                _context19.next = 13;
                return this.remotes();

              case 13:
                remotes = _context19.sent;
                _context19.next = 16;
                return this.getExternalOnes(externals, remotes, cache);

              case 16:
                externalDeps = _context19.sent;
                return _context19.abrupt('return', componentVersionArr.concat(externalDeps));

              case 18:
              case 'end':
                return _context19.stop();
            }
          }
        }, _callee19, this);
      }));

      function importManyOnes(_x35, _x36) {
        return _ref26.apply(this, arguments);
      }

      return importManyOnes;
    }()
  }, {
    key: 'manyOneObjects',
    value: function manyOneObjects(ids) {
      var _this19 = this;

      return this.importManyOnes(ids).then(function (componentVersions) {
        return Promise.all(componentVersions.map(function (version) {
          return version.toObjects(_this19.objects);
        }));
      });
    }
  }, {
    key: 'import',
    value: function _import(id) {
      var _this20 = this;

      if (!id.isLocal(this.name)) {
        return this.remotes().then(function (remotes) {
          return _this20.getExternal({ id, remotes, localFetch: true });
        });
      }

      return this.sources.get(id).then(function (component) {
        if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return component.toVersionDependencies(id.version, _this20, _this20.name);
      });
    }
  }, {
    key: 'get',
    value: function () {
      var _ref27 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee20(id) {
        var _this21 = this;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee20$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                return _context20.abrupt('return', this.import(id).then(function (versionDependencies) {
                  return versionDependencies.toConsumer(_this21.objects);
                }));

              case 1:
              case 'end':
                return _context20.stop();
            }
          }
        }, _callee20, this);
      }));

      function get(_x37) {
        return _ref27.apply(this, arguments);
      }

      return get;
    }()

    /**
     * return a component only when it's stored locally. Don't go to any remote server and don't throw an exception if the
     * component is not there.
     */

  }, {
    key: 'getFromLocalIfExist',
    value: function () {
      var _ref28 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee21(id) {
        var componentFromSources, versionDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                _context21.next = 2;
                return this.sources.get(id);

              case 2:
                componentFromSources = _context21.sent;

                if (componentFromSources) {
                  _context21.next = 5;
                  break;
                }

                return _context21.abrupt('return', null);

              case 5:
                _context21.next = 7;
                return componentFromSources.toVersionDependencies(id.version, this, this.name);

              case 7:
                versionDependencies = _context21.sent;
                return _context21.abrupt('return', versionDependencies.toConsumer(this.objects));

              case 9:
              case 'end':
                return _context21.stop();
            }
          }
        }, _callee21, this);
      }));

      function getFromLocalIfExist(_x38) {
        return _ref28.apply(this, arguments);
      }

      return getFromLocalIfExist;
    }()

    /**
     * get multiple components from a scope, if not found in the local scope, fetch from a remote
     * scope. Then, write them to the local scope.
     */

  }, {
    key: 'getMany',
    value: function getMany(ids) {
      var _this22 = this;

      var cache = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      (_logger || _load_logger()).default.debug(`scope.getMany, Ids: ${ids.join(', ')}`);
      var idsWithoutNils = removeNils(ids);
      if ((_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) return Promise.resolve([]);
      return this.importMany(idsWithoutNils, false, cache).then(function (versionDependenciesArr) {
        return Promise.all(versionDependenciesArr.map(function (versionDependencies) {
          return versionDependencies.toConsumer(_this22.objects);
        }));
      });
    }

    // todo: improve performance by finding all versions needed and fetching them in one request from the server
    // currently it goes to the server twice. First, it asks for the last version of each id, and then it goes again to
    // ask for the older versions.

  }, {
    key: 'getManyWithAllVersions',
    value: function () {
      var _ref29 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee22(ids) {
        var _this23 = this;

        var cache = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var idsWithoutNils, versionDependenciesArr, allVersionsP;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee22$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.getManyWithAllVersions, Ids: ${ids.join(', ')}`);
                idsWithoutNils = removeNils(ids);

                if (!(_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) {
                  _context22.next = 4;
                  break;
                }

                return _context22.abrupt('return', Promise.resolve([]));

              case 4:
                _context22.next = 6;
                return this.importMany(idsWithoutNils, false, cache);

              case 6:
                versionDependenciesArr = _context22.sent;
                allVersionsP = versionDependenciesArr.map(function (versionDependencies) {
                  var versions = versionDependencies.component.component.listVersions();
                  var idsWithAllVersions = versions.map(function (version) {
                    if (version === versionDependencies.component.version) return null; // imported already
                    var versionId = versionDependencies.component.id;
                    versionId.version = version;
                    return versionId;
                  });
                  return _this23.importManyOnes(idsWithAllVersions);
                });
                _context22.next = 10;
                return Promise.all(allVersionsP);

              case 10:
                return _context22.abrupt('return', Promise.all(versionDependenciesArr.map(function (versionDependencies) {
                  return versionDependencies.toConsumer(_this23.objects);
                })));

              case 11:
              case 'end':
                return _context22.stop();
            }
          }
        }, _callee22, this);
      }));

      function getManyWithAllVersions(_x41) {
        return _ref29.apply(this, arguments);
      }

      return getManyWithAllVersions;
    }()
  }, {
    key: 'removeComponent',
    value: function () {
      var _ref30 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee23(id, componentList) {
        var removeRefs = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        var symlink;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee23$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                symlink = componentList.filter(function (component) {
                  return component instanceof (_models || _load_models()).Symlink && component.id() === id.toStringWithoutScopeAndVersion();
                });
                _context23.next = 3;
                return this.sources.clean(id, removeRefs);

              case 3:
                if ((_ramda || _load_ramda()).default.isEmpty(symlink)) {
                  _context23.next = 6;
                  break;
                }

                _context23.next = 6;
                return this.objects.remove(symlink[0].hash());

              case 6:
              case 'end':
                return _context23.stop();
            }
          }
        }, _callee23, this);
      }));

      function removeComponent(_x43, _x44) {
        return _ref30.apply(this, arguments);
      }

      return removeComponent;
    }()

    /**
     * Remove component dependecies
     */

  }, {
    key: 'removeComponentsDependences',
    value: function () {
      var _ref31 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee25(dependentBits, componentList, consumerComponentToRemove, bitId) {
        var _this24 = this;

        var removeSameOrigin = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
        var removedComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee25$(_context25) {
          while (1) {
            switch (_context25.prev = _context25.next) {
              case 0:
                removedComponents = consumerComponentToRemove.flattenedDependencies.map(function () {
                  var _ref32 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee24(id) {
                    var arr, name, depArr;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee24$(_context24) {
                      while (1) {
                        switch (_context24.prev = _context24.next) {
                          case 0:
                            arr = dependentBits[id.toStringWithoutVersion()];
                            name = bitId.version === (_constants || _load_constants()).LATEST_BIT_VERSION ? bitId.toStringWithoutVersion() : bitId.toString();
                            depArr = (_ramda || _load_ramda()).default.reject(function (num) {
                              return num === name || (_bitId || _load_bitId()).BitId.parse(num).scope !== id.scope;
                            }, arr);

                            if (!((_ramda || _load_ramda()).default.isEmpty(depArr) && (id.scope !== bitId.scope || removeSameOrigin))) {
                              _context24.next = 7;
                              break;
                            }

                            _context24.next = 6;
                            return _this24.removeComponent(id, componentList, true);

                          case 6:
                            return _context24.abrupt('return', id);

                          case 7:
                          case 'end':
                            return _context24.stop();
                        }
                      }
                    }, _callee24, _this24);
                  }));

                  return function (_x50) {
                    return _ref32.apply(this, arguments);
                  };
                }());
                _context25.next = 3;
                return Promise.all(removedComponents);

              case 3:
                _context25.t0 = function (x) {
                  return !(_ramda || _load_ramda()).default.isNil(x);
                };

                return _context25.abrupt('return', _context25.sent.filter(_context25.t0));

              case 5:
              case 'end':
                return _context25.stop();
            }
          }
        }, _callee25, this);
      }));

      function removeComponentsDependences(_x46, _x47, _x48, _x49) {
        return _ref31.apply(this, arguments);
      }

      return removeComponentsDependences;
    }()

    /**
     * removeSingle - remove single component
     * @param {BitId} bitId - list of remote component ids to delete
     * @param {boolean} removeSameOrigin - remove component dependencies from same origin
     */

  }, {
    key: 'removeSingle',
    value: function () {
      var _ref33 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee26(bitId) {
        var removeSameOrigin = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var component, consumerComponentToRemove, componentList, dependentBits, removedDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee26$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`removing ${bitId.toString()}`);
                _context26.next = 3;
                return this.sources.get(bitId);

              case 3:
                component = _context26.sent.toComponentVersion();
                _context26.next = 6;
                return component.toConsumer(this.objects);

              case 6:
                consumerComponentToRemove = _context26.sent;
                _context26.next = 9;
                return this.objects.listComponents();

              case 9:
                componentList = _context26.sent;
                _context26.next = 12;
                return this.findDependentBits(consumerComponentToRemove.flattenedDependencies, bitId.version !== (_constants || _load_constants()).LATEST_BIT_VERSION);

              case 12:
                dependentBits = _context26.sent;
                _context26.next = 15;
                return this.removeComponentsDependences(dependentBits, componentList, consumerComponentToRemove, bitId, removeSameOrigin);

              case 15:
                removedDependencies = _context26.sent;
                _context26.next = 18;
                return this.removeComponent(bitId, componentList, false);

              case 18:
                if (Object.keys(component.component.versions).length <= 1) bitId.version = (_constants || _load_constants()).LATEST_BIT_VERSION;

                return _context26.abrupt('return', { bitId, removedDependencies });

              case 20:
              case 'end':
                return _context26.stop();
            }
          }
        }, _callee26, this);
      }));

      function removeSingle(_x52) {
        return _ref33.apply(this, arguments);
      }

      return removeSingle;
    }()
  }, {
    key: 'deprecateSingle',
    value: function () {
      var _ref34 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee27(bitId) {
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee27$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                _context27.next = 2;
                return this.sources.get(bitId);

              case 2:
                component = _context27.sent;

                component.deprecated = true;
                this.objects.add(component);
                _context27.next = 7;
                return this.objects.persist();

              case 7:
                return _context27.abrupt('return', bitId.toStringWithoutVersion());

              case 8:
              case 'end':
                return _context27.stop();
            }
          }
        }, _callee27, this);
      }));

      function deprecateSingle(_x53) {
        return _ref34.apply(this, arguments);
      }

      return deprecateSingle;
    }()
    /**
     * findDependentBits
     * foreach component in array find the componnet that uses that component
     */

  }, {
    key: 'findDependentBits',
    value: function () {
      var _ref35 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee30(bitIds) {
        var _this25 = this;

        var returnResultsWithVersion = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var allComponents, allComponentVersions, allScopeComponents, dependentBits;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee30$(_context30) {
          while (1) {
            switch (_context30.prev = _context30.next) {
              case 0:
                _context30.next = 2;
                return this.objects.listComponents(false);

              case 2:
                allComponents = _context30.sent;
                _context30.next = 5;
                return Promise.all(allComponents.map(function () {
                  var _ref36 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee29(component) {
                    var loadedVersions;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee29$(_context29) {
                      while (1) {
                        switch (_context29.prev = _context29.next) {
                          case 0:
                            _context29.next = 2;
                            return Promise.all(Object.keys(component.versions).map(function () {
                              var _ref37 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee28(version) {
                                var componentVersion;
                                return (_regenerator || _load_regenerator()).default.wrap(function _callee28$(_context28) {
                                  while (1) {
                                    switch (_context28.prev = _context28.next) {
                                      case 0:
                                        _context28.next = 2;
                                        return component.loadVersion(version, _this25.objects);

                                      case 2:
                                        componentVersion = _context28.sent;

                                        if (componentVersion) {
                                          _context28.next = 5;
                                          break;
                                        }

                                        return _context28.abrupt('return');

                                      case 5:
                                        componentVersion.id = (_bitId || _load_bitId()).BitId.parse(component.id());
                                        return _context28.abrupt('return', componentVersion);

                                      case 7:
                                      case 'end':
                                        return _context28.stop();
                                    }
                                  }
                                }, _callee28, _this25);
                              }));

                              return function (_x57) {
                                return _ref37.apply(this, arguments);
                              };
                            }()));

                          case 2:
                            loadedVersions = _context29.sent;
                            return _context29.abrupt('return', loadedVersions.filter(function (x) {
                              return x;
                            }));

                          case 4:
                          case 'end':
                            return _context29.stop();
                        }
                      }
                    }, _callee29, _this25);
                  }));

                  return function (_x56) {
                    return _ref36.apply(this, arguments);
                  };
                }()));

              case 5:
                allComponentVersions = _context30.sent;
                allScopeComponents = (_ramda || _load_ramda()).default.flatten(allComponentVersions);
                dependentBits = {};

                bitIds.forEach(function (bitId) {
                  var dependencies = [];
                  allScopeComponents.forEach(function (scopeComponents) {
                    scopeComponents.flattenedDependencies.forEach(function (flattenedDependence) {
                      if (flattenedDependence.toStringWithoutVersion() === bitId.toStringWithoutVersion()) {
                        returnResultsWithVersion ? dependencies.push(scopeComponents.id.toString()) : dependencies.push(scopeComponents.id.toStringWithoutVersion());
                      }
                    });
                  });

                  if (!(_ramda || _load_ramda()).default.isEmpty(dependencies)) dependentBits[bitId.toStringWithoutVersion()] = (_ramda || _load_ramda()).default.uniq(dependencies);
                });
                return _context30.abrupt('return', Promise.resolve(dependentBits));

              case 10:
              case 'end':
                return _context30.stop();
            }
          }
        }, _callee30, this);
      }));

      function findDependentBits(_x55) {
        return _ref35.apply(this, arguments);
      }

      return findDependentBits;
    }()

    /**
     * split bit array to found and missing components (incase user misspelled id)
     */

  }, {
    key: 'filterFoundAndMissingComponents',
    value: function () {
      var _ref38 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee32(bitIds) {
        var _this26 = this;

        var missingComponents, foundComponents, resultP;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee32$(_context32) {
          while (1) {
            switch (_context32.prev = _context32.next) {
              case 0:
                missingComponents = [];
                foundComponents = [];
                resultP = bitIds.map(function () {
                  var _ref39 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee31(id) {
                    var component;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee31$(_context31) {
                      while (1) {
                        switch (_context31.prev = _context31.next) {
                          case 0:
                            _context31.next = 2;
                            return _this26.sources.get(id);

                          case 2:
                            component = _context31.sent;

                            if (!component) missingComponents.push(id);else foundComponents.push(id);

                          case 4:
                          case 'end':
                            return _context31.stop();
                        }
                      }
                    }, _callee31, _this26);
                  }));

                  return function (_x59) {
                    return _ref39.apply(this, arguments);
                  };
                }());
                _context32.next = 5;
                return Promise.all(resultP);

              case 5:
                return _context32.abrupt('return', Promise.resolve({ missingComponents, foundComponents }));

              case 6:
              case 'end':
                return _context32.stop();
            }
          }
        }, _callee32, this);
      }));

      function filterFoundAndMissingComponents(_x58) {
        return _ref38.apply(this, arguments);
      }

      return filterFoundAndMissingComponents;
    }()

    /**
     * Remove components from scope
     * @force Boolean  - remove component from scope even if other components use it
     */

  }, {
    key: 'removeMany',
    value: function () {
      var _ref40 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee34(bitIds, force) {
        var _this27 = this;

        var removeSameOrigin = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

        var _ref41, missingComponents, foundComponents, dependentBits, removedComponents, ids, removedDependencies;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee34$(_context34) {
          while (1) {
            switch (_context34.prev = _context34.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`removing ${bitIds} with force flag: ${force}`);
                _context34.next = 3;
                return this.filterFoundAndMissingComponents(bitIds);

              case 3:
                _ref41 = _context34.sent;
                missingComponents = _ref41.missingComponents;
                foundComponents = _ref41.foundComponents;
                _context34.next = 8;
                return this.findDependentBits(foundComponents);

              case 8:
                dependentBits = _context34.sent;

                if (!((_ramda || _load_ramda()).default.isEmpty(dependentBits) || force)) {
                  _context34.next = 16;
                  break;
                }

                _context34.next = 12;
                return Promise.all(foundComponents.map(function () {
                  var _ref42 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee33(bitId) {
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee33$(_context33) {
                      while (1) {
                        switch (_context33.prev = _context33.next) {
                          case 0:
                            return _context33.abrupt('return', _this27.removeSingle(bitId, removeSameOrigin));

                          case 1:
                          case 'end':
                            return _context33.stop();
                        }
                      }
                    }, _callee33, _this27);
                  }));

                  return function (_x63) {
                    return _ref42.apply(this, arguments);
                  };
                }()));

              case 12:
                removedComponents = _context34.sent;
                ids = removedComponents.map(function (x) {
                  return x.bitId;
                });
                removedDependencies = (_ramda || _load_ramda()).default.flatten(removedComponents.map(function (x) {
                  return x.removedDependencies;
                }));
                return _context34.abrupt('return', new (_componentRemove || _load_componentRemove()).RemovedObjects({ removedComponentIds: ids, missingComponents, removedDependencies }));

              case 16:
                return _context34.abrupt('return', new (_componentRemove || _load_componentRemove()).RemovedObjects({ missingComponents, dependentBits }));

              case 17:
              case 'end':
                return _context34.stop();
            }
          }
        }, _callee34, this);
      }));

      function removeMany(_x61, _x62) {
        return _ref40.apply(this, arguments);
      }

      return removeMany;
    }()
    /**
     * deprecate components from scope
     */

  }, {
    key: 'deprecateMany',
    value: function () {
      var _ref43 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee36(bitIds) {
        var _this28 = this;

        var _ref44, missingComponents, foundComponents, deprecateComponents, deprecatedComponents, missingComponentsStrings;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee36$(_context36) {
          while (1) {
            switch (_context36.prev = _context36.next) {
              case 0:
                _context36.next = 2;
                return this.filterFoundAndMissingComponents(bitIds);

              case 2:
                _ref44 = _context36.sent;
                missingComponents = _ref44.missingComponents;
                foundComponents = _ref44.foundComponents;

                deprecateComponents = function deprecateComponents() {
                  return foundComponents.map(function () {
                    var _ref45 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee35(bitId) {
                      return (_regenerator || _load_regenerator()).default.wrap(function _callee35$(_context35) {
                        while (1) {
                          switch (_context35.prev = _context35.next) {
                            case 0:
                              return _context35.abrupt('return', _this28.deprecateSingle(bitId));

                            case 1:
                            case 'end':
                              return _context35.stop();
                          }
                        }
                      }, _callee35, _this28);
                    }));

                    return function (_x65) {
                      return _ref45.apply(this, arguments);
                    };
                  }());
                };

                _context36.next = 8;
                return Promise.all(deprecateComponents());

              case 8:
                deprecatedComponents = _context36.sent;
                missingComponentsStrings = missingComponents.map(function (id) {
                  return id.toStringWithoutVersion();
                });
                return _context36.abrupt('return', { bitIds: deprecatedComponents, missingComponents: missingComponentsStrings });

              case 11:
              case 'end':
                return _context36.stop();
            }
          }
        }, _callee36, this);
      }));

      function deprecateMany(_x64) {
        return _ref43.apply(this, arguments);
      }

      return deprecateMany;
    }()
  }, {
    key: 'reset',
    value: function reset(_ref46) {
      var _this29 = this;

      var bitId = _ref46.bitId,
          consumer = _ref46.consumer;

      if (!bitId.isLocal(this.name)) {
        return Promise.reject('you can not reset a remote component');
      }
      return this.sources.get(bitId).then(function (component) {
        if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(bitId.toString());
        var allVersions = component.listVersions();
        if (allVersions.length > 1) {
          var lastVersion = component.latest();
          bitId.version = lastVersion.toString();
          return consumer.removeFromComponents(bitId, true).then(function () {
            // TODO: this won't work any more because the version is now string (semver)
            bitId.version = (lastVersion - 1).toString();
            return _this29.get(bitId).then(function (consumerComponent) {
              var ref = component.versions[lastVersion];
              return _this29.objects.remove(ref).then(function () {
                // todo: remove also all deps of that ref
                delete component.versions[lastVersion];
                _this29.objects.add(component);
                return _this29.objects.persist();
              }).then(function () {
                return consumerComponent;
              });
            });
          });
        }
        return _this29.get(bitId).then(function (consumerComponent) {
          return consumer.removeFromComponents(bitId).then(function () {
            return _this29.clean(bitId).then(function () {
              return consumerComponent;
            });
          });
        });
      });
    }
  }, {
    key: 'loadRemoteComponent',
    value: function loadRemoteComponent(id) {
      var _this30 = this;

      return this.getOne(id).then(function (component) {
        if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return component.toConsumer(_this30.objects);
      });
    }
  }, {
    key: 'loadComponent',
    value: function loadComponent(id) {
      var localOnly = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      (_logger || _load_logger()).default.debug(`scope.loadComponent, id: ${id}`);
      if (localOnly && !id.isLocal(this.name)) {
        throw new Error('cannot load bit from remote scope, please import first');
      }
      return this.loadRemoteComponent(id);
    }

    /**
     * load components from the model and return them as ComponentVersion array.
     * if a component is not available locally, it'll just ignore it without throwing any error.
     */

  }, {
    key: 'loadLocalComponents',
    value: function () {
      var _ref47 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee37(ids) {
        var componentsObjects, components;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee37$(_context37) {
          while (1) {
            switch (_context37.prev = _context37.next) {
              case 0:
                _context37.next = 2;
                return this.sources.getMany(ids);

              case 2:
                componentsObjects = _context37.sent;
                components = componentsObjects.map(function (componentObject) {
                  var component = componentObject.component;
                  if (!component) return null;
                  var version = componentObject.id.hasVersion() ? componentObject.id.version : component.latest();
                  return component.toComponentVersion(version);
                });
                return _context37.abrupt('return', removeNils(components));

              case 5:
              case 'end':
                return _context37.stop();
            }
          }
        }, _callee37, this);
      }));

      function loadLocalComponents(_x67) {
        return _ref47.apply(this, arguments);
      }

      return loadLocalComponents;
    }()
  }, {
    key: 'loadComponentLogs',
    value: function loadComponentLogs(id) {
      var _this31 = this;

      return this.sources.get(id).then(function (componentModel) {
        if (!componentModel) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return componentModel.collectLogs(_this31.objects);
      });
    }
  }, {
    key: 'loadAllVersions',
    value: function loadAllVersions(id) {
      var _this32 = this;

      return this.sources.get(id).then(function (componentModel) {
        if (!componentModel) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return componentModel.collectVersions(_this32.objects);
      });
    }
  }, {
    key: 'getOne',
    value: function () {
      var _ref48 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee38(id) {
        var _this33 = this;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee38$(_context38) {
          while (1) {
            switch (_context38.prev = _context38.next) {
              case 0:
                if (id.isLocal(this.name)) {
                  _context38.next = 2;
                  break;
                }

                return _context38.abrupt('return', this.remotes().then(function (remotes) {
                  return _this33.getExternalOne({ id, remotes, localFetch: true });
                }));

              case 2:
                return _context38.abrupt('return', this.sources.get(id).then(function (component) {
                  if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
                  return component.toComponentVersion(id.version);
                }));

              case 3:
              case 'end':
                return _context38.stop();
            }
          }
        }, _callee38, this);
      }));

      function getOne(_x68) {
        return _ref48.apply(this, arguments);
      }

      return getOne;
    }()

    /**
     * Creates a symlink object with the local-scope which links to the real-object of the remote-scope
     * This way, local components that have dependencies to the exported component won't break.
     */

  }, {
    key: 'createSymlink',
    value: function createSymlink(id, remote) {
      var symlink = new (_models || _load_models()).Symlink({
        scope: id.scope,
        name: id.name,
        box: id.box,
        realScope: remote
      });
      return this.objects.add(symlink);
    }
  }, {
    key: 'exportMany',
    value: function () {
      var _ref49 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee40(ids, remoteName) {
        var _this34 = this;

        var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var eject = arguments[3];
        var remotes, remote, componentIds, componentObjectsP, componentObjects, componentsAndObjects, manyObjectsP, manyObjects, exportedIds, idsWithRemoteScope;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee40$(_context40) {
          while (1) {
            switch (_context40.prev = _context40.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`exportMany, ids: ${ids.join(', ')}`);
                _context40.next = 3;
                return this.remotes();

              case 3:
                remotes = _context40.sent;

                if (!(eject && !remotes.isHub(remoteName))) {
                  _context40.next = 6;
                  break;
                }

                return _context40.abrupt('return', Promise.reject('--eject flag is relevant only when the remote is a hub'));

              case 6:
                _context40.next = 8;
                return remotes.resolve(remoteName, this);

              case 8:
                remote = _context40.sent;
                componentIds = ids.map(function (id) {
                  return (_bitId || _load_bitId()).BitId.parse(id);
                });
                componentObjectsP = componentIds.map(function (id) {
                  return _this34.sources.getObjects(id);
                });
                _context40.next = 13;
                return Promise.all(componentObjectsP);

              case 13:
                componentObjects = _context40.sent;
                componentsAndObjects = [];

                (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
                manyObjectsP = componentObjects.map(function () {
                  var _ref50 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee39(componentObject) {
                    var componentAndObject, componentBuffer, objectsBuffer;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee39$(_context39) {
                      while (1) {
                        switch (_context39.prev = _context39.next) {
                          case 0:
                            componentAndObject = componentObject.toObjects(_this34.objects);

                            componentAndObject.component.clearStateData();
                            _this34._convertNonScopeToCorrectScope(componentAndObject, remoteName);
                            componentsAndObjects.push(componentAndObject);
                            _context39.next = 6;
                            return componentAndObject.component.compress();

                          case 6:
                            componentBuffer = _context39.sent;
                            _context39.next = 9;
                            return Promise.all(componentAndObject.objects.map(function (obj) {
                              return obj.compress();
                            }));

                          case 9:
                            objectsBuffer = _context39.sent;
                            return _context39.abrupt('return', new (_componentObjects || _load_componentObjects()).default(componentBuffer, objectsBuffer));

                          case 11:
                          case 'end':
                            return _context39.stop();
                        }
                      }
                    }, _callee39, _this34);
                  }));

                  return function (_x72) {
                    return _ref50.apply(this, arguments);
                  };
                }());
                _context40.next = 19;
                return Promise.all(manyObjectsP);

              case 19:
                manyObjects = _context40.sent;
                exportedIds = void 0;
                _context40.prev = 21;
                _context40.next = 24;
                return remote.pushMany(manyObjects, context);

              case 24:
                exportedIds = _context40.sent;

                (_logger || _load_logger()).default.debug('exportMany: successfully pushed all ids to the bare-scope, going to save them back to local scope');
                _context40.next = 32;
                break;

              case 28:
                _context40.prev = 28;
                _context40.t0 = _context40['catch'](21);

                (_logger || _load_logger()).default.warn('exportMany: failed pushing ids to the bare-scope');
                return _context40.abrupt('return', Promise.reject(_context40.t0));

              case 32:
                _context40.next = 34;
                return Promise.all(componentIds.map(function (id) {
                  return _this34.clean(id);
                }));

              case 34:
                componentIds.map(function (id) {
                  return _this34.createSymlink(id, remoteName);
                });
                idsWithRemoteScope = exportedIds.map(function (id) {
                  return (_bitId || _load_bitId()).BitId.parse(id);
                });
                _context40.next = 38;
                return Promise.all(componentsAndObjects.map(function (componentObject) {
                  return _this34.sources.merge(componentObject);
                }));

              case 38:
                _context40.next = 40;
                return this.objects.persist();

              case 40:
                return _context40.abrupt('return', idsWithRemoteScope);

              case 41:
              case 'end':
                return _context40.stop();
            }
          }
        }, _callee40, this, [[21, 28]]);
      }));

      function exportMany(_x70, _x71) {
        return _ref49.apply(this, arguments);
      }

      return exportMany;
    }()
  }, {
    key: 'ensureDir',
    value: function ensureDir() {
      var _this35 = this;

      (_fsExtra || _load_fsExtra()).default.ensureDirSync(this.getComponentsPath());
      return this.tmp.ensureDir().then(function () {
        return _this35.scopeJson.write(_this35.getPath());
      }).then(function () {
        return _this35.objects.ensureDir();
      }).then(function () {
        return _this35;
      });
    }
  }, {
    key: 'clean',
    value: function clean(bitId) {
      return this.sources.clean(bitId);
    }

    /**
     * sync method that loads the environment/(path to environment component)
     */

  }, {
    key: 'loadEnvironment',
    value: function loadEnvironment(bitId, opts) {
      (_logger || _load_logger()).default.debug(`scope.loadEnvironment, id: ${bitId}`);
      if (!bitId) throw new (_exceptions || _load_exceptions()).ResolutionException();
      var notFound = function notFound() {
        (_logger || _load_logger()).default.debug(`Unable to find an env component ${bitId.toString()}`);
        return false;
      };

      var envPath = void 0;
      try {
        envPath = (0, (_componentResolver || _load_componentResolver()).default)(bitId.toString(), null, this.getPath());
      } catch (err) {
        return notFound();
      }
      if (!(_environment || _load_environment()).default.isEnvironmentInstalled(envPath)) return notFound();

      if (opts && opts.pathOnly) {
        return envPath;
      }

      try {
        (_logger || _load_logger()).default.debug(`Requiring an environment file at ${envPath}`);
        return require(envPath);
      } catch (e) {
        throw new (_exceptions || _load_exceptions()).ResolutionException(e);
      }
    }

    // TODO: Change name since it also used to install extension

  }, {
    key: 'installEnvironment',
    value: function () {
      var _ref52 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee42(_ref51) {
        var _this36 = this;

        var ids = _ref51.ids,
            verbose = _ref51.verbose;
        var componentsDir, isolateOpts, idsWithoutNils, predicate, uniqIds, nonExistingEnvsIds, importEnv;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee42$(_context42) {
          while (1) {
            switch (_context42.prev = _context42.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.installEnvironment, ids: ${ids.join(', ')}`);
                componentsDir = this.getComponentsPath();
                isolateOpts = {
                  writeBitDependencies: false,
                  installPackages: true,
                  noPackageJson: false,
                  dist: true,
                  conf: true,
                  override: false,
                  verbose
                };
                idsWithoutNils = removeNils(ids);

                predicate = function predicate(id) {
                  return id.toString();
                }; // TODO: should be moved to BitId class


                uniqIds = (_ramda || _load_ramda()).default.uniqBy(predicate)(idsWithoutNils);
                nonExistingEnvsIds = uniqIds.filter(function (id) {
                  return !_this36.loadEnvironment(id, { pathOnly: true });
                });

                importEnv = function () {
                  var _ref53 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee41(id) {
                    var concreteId, concreteIds, dir, env;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee41$(_context41) {
                      while (1) {
                        switch (_context41.prev = _context41.next) {
                          case 0:
                            concreteId = id;

                            if (!id.getVersion().latest) {
                              _context41.next = 6;
                              break;
                            }

                            _context41.next = 4;
                            return _this36.fetchRemoteVersions([id]);

                          case 4:
                            concreteIds = _context41.sent;

                            concreteId = concreteIds[0];

                          case 6:
                            dir = (_path || _load_path()).join(componentsDir, Scope.getComponentRelativePath(concreteId));
                            env = new (_environment || _load_environment()).default(_this36, dir);
                            _context41.next = 10;
                            return env.create();

                          case 10:
                            return _context41.abrupt('return', env.isolateComponent(id, isolateOpts));

                          case 11:
                          case 'end':
                            return _context41.stop();
                        }
                      }
                    }, _callee41, _this36);
                  }));

                  return function importEnv(_x74) {
                    return _ref53.apply(this, arguments);
                  };
                }();

                return _context42.abrupt('return', (0, (_pMapSeries || _load_pMapSeries()).default)(nonExistingEnvsIds, importEnv));

              case 9:
              case 'end':
                return _context42.stop();
            }
          }
        }, _callee42, this);
      }));

      function installEnvironment(_x73) {
        return _ref52.apply(this, arguments);
      }

      return installEnvironment;
    }()
  }, {
    key: 'bumpDependenciesVersions',
    value: function () {
      var _ref54 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee44(componentsToUpdate, committedComponents, persist) {
        var _this37 = this;

        var componentsObjects, componentsToUpdateP, updatedComponentsAll, updatedComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee44$(_context44) {
          while (1) {
            switch (_context44.prev = _context44.next) {
              case 0:
                _context44.next = 2;
                return this.sources.getMany(componentsToUpdate);

              case 2:
                componentsObjects = _context44.sent;
                componentsToUpdateP = componentsObjects.map(function () {
                  var _ref55 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee43(componentObjects) {
                    var component, latestVersion, pendingUpdate, _message;

                    return (_regenerator || _load_regenerator()).default.wrap(function _callee43$(_context43) {
                      while (1) {
                        switch (_context43.prev = _context43.next) {
                          case 0:
                            component = componentObjects.component;

                            if (component) {
                              _context43.next = 3;
                              break;
                            }

                            return _context43.abrupt('return', null);

                          case 3:
                            _context43.next = 5;
                            return component.loadVersion(component.latest(), _this37.objects);

                          case 5:
                            latestVersion = _context43.sent;
                            pendingUpdate = false;

                            latestVersion.getAllDependencies().forEach(function (dependency) {
                              var committedComponentId = committedComponents.find(function (committedComponent) {
                                return committedComponent.toStringWithoutVersion() === dependency.id.toStringWithoutVersion();
                              });

                              if (!committedComponentId) return;
                              if (persist && (_semver || _load_semver()).default.gt(committedComponentId.version, dependency.id.version)) {
                                pendingUpdate = true;
                                dependency.id.version = committedComponentId.version;
                                var flattenDependencyToUpdate = latestVersion.flattenedDependencies.find(function (flattenDependency) {
                                  return flattenDependency.toStringWithoutVersion() === dependency.id.toStringWithoutVersion();
                                });
                                flattenDependencyToUpdate.version = committedComponentId.version;
                              } else if (!persist && (_semver || _load_semver()).default.gte(committedComponentId.version, dependency.id.version)) {
                                // if !persist, we only check whether a modified component may cause auto-tagging
                                // since it's only modified on the file-system, its version might be the same as the version stored in its
                                // dependents. That's why "semver.gte" is used instead of "server.gt".
                                pendingUpdate = true;
                              }
                            });

                            if (!pendingUpdate) {
                              _context43.next = 13;
                              break;
                            }

                            if (persist) {
                              _context43.next = 11;
                              break;
                            }

                            return _context43.abrupt('return', componentObjects.component);

                          case 11:
                            _message = 'bump dependencies versions';
                            return _context43.abrupt('return', _this37.sources.putAdditionalVersion(componentObjects.component, latestVersion, _message));

                          case 13:
                            return _context43.abrupt('return', null);

                          case 14:
                          case 'end':
                            return _context43.stop();
                        }
                      }
                    }, _callee43, _this37);
                  }));

                  return function (_x78) {
                    return _ref55.apply(this, arguments);
                  };
                }());
                _context44.next = 6;
                return Promise.all(componentsToUpdateP);

              case 6:
                updatedComponentsAll = _context44.sent;
                updatedComponents = removeNils(updatedComponentsAll);

                if (!(!(_ramda || _load_ramda()).default.isEmpty(updatedComponents) && persist)) {
                  _context44.next = 11;
                  break;
                }

                _context44.next = 11;
                return this.objects.persist();

              case 11:
                return _context44.abrupt('return', updatedComponents);

              case 12:
              case 'end':
                return _context44.stop();
            }
          }
        }, _callee44, this);
      }));

      function bumpDependenciesVersions(_x75, _x76, _x77) {
        return _ref54.apply(this, arguments);
      }

      return bumpDependenciesVersions;
    }()

    /**
     * find the components in componentsPool which one of their dependencies include in potentialDependencies
     */

  }, {
    key: 'findDirectDependentComponents',
    value: function () {
      var _ref56 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee46(componentsPool, potentialDependencies) {
        var _this38 = this;

        var componentsVersions, potentialDependenciesWithoutVersions, dependentsP, dependents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee46$(_context46) {
          while (1) {
            switch (_context46.prev = _context46.next) {
              case 0:
                _context46.next = 2;
                return this.loadLocalComponents(componentsPool);

              case 2:
                componentsVersions = _context46.sent;
                potentialDependenciesWithoutVersions = potentialDependencies.map(function (id) {
                  return id.toStringWithoutVersion();
                });
                dependentsP = componentsVersions.map(function () {
                  var _ref57 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee45(componentVersion) {
                    var component, found;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee45$(_context45) {
                      while (1) {
                        switch (_context45.prev = _context45.next) {
                          case 0:
                            _context45.next = 2;
                            return componentVersion.getVersion(_this38.objects);

                          case 2:
                            component = _context45.sent;
                            found = component.getAllDependencies().find(function (dependency) {
                              return potentialDependenciesWithoutVersions.includes(dependency.id.toStringWithoutVersion());
                            });
                            return _context45.abrupt('return', found ? componentVersion.toConsumer(_this38.objects) : null);

                          case 5:
                          case 'end':
                            return _context45.stop();
                        }
                      }
                    }, _callee45, _this38);
                  }));

                  return function (_x81) {
                    return _ref57.apply(this, arguments);
                  };
                }());
                _context46.next = 7;
                return Promise.all(dependentsP);

              case 7:
                dependents = _context46.sent;
                return _context46.abrupt('return', removeNils(dependents));

              case 9:
              case 'end':
                return _context46.stop();
            }
          }
        }, _callee46, this);
      }));

      function findDirectDependentComponents(_x79, _x80) {
        return _ref56.apply(this, arguments);
      }

      return findDirectDependentComponents;
    }()
  }, {
    key: 'runComponentSpecs',
    value: function () {
      var _ref59 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee47(_ref58) {
        var bitId = _ref58.bitId,
            consumer = _ref58.consumer,
            save = _ref58.save,
            verbose = _ref58.verbose,
            isolated = _ref58.isolated,
            directory = _ref58.directory,
            keep = _ref58.keep,
            _ref58$isCI = _ref58.isCI,
            isCI = _ref58$isCI === undefined ? false : _ref58$isCI;
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee47$(_context47) {
          while (1) {
            switch (_context47.prev = _context47.next) {
              case 0:
                if (bitId.isLocal(this.name)) {
                  _context47.next = 2;
                  break;
                }

                throw new Error('cannot run specs on remote component');

              case 2:
                _context47.next = 4;
                return this.loadComponent(bitId);

              case 4:
                component = _context47.sent;
                return _context47.abrupt('return', component.runSpecs({
                  scope: this,
                  consumer,
                  save,
                  verbose,
                  isolated,
                  directory,
                  keep,
                  isCI
                }));

              case 6:
              case 'end':
                return _context47.stop();
            }
          }
        }, _callee47, this);
      }));

      function runComponentSpecs(_x82) {
        return _ref59.apply(this, arguments);
      }

      return runComponentSpecs;
    }()
  }, {
    key: 'build',
    value: function () {
      var _ref61 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee48(_ref60) {
        var bitId = _ref60.bitId,
            save = _ref60.save,
            consumer = _ref60.consumer,
            verbose = _ref60.verbose,
            directory = _ref60.directory,
            keep = _ref60.keep,
            isCI = _ref60.isCI;
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee48$(_context48) {
          while (1) {
            switch (_context48.prev = _context48.next) {
              case 0:
                if (bitId.isLocal(this.name)) {
                  _context48.next = 2;
                  break;
                }

                throw new Error('cannot run build on remote component');

              case 2:
                _context48.next = 4;
                return this.loadComponent(bitId);

              case 4:
                component = _context48.sent;
                return _context48.abrupt('return', component.build({ scope: this, save, consumer, verbose, directory, keep, isCI }));

              case 6:
              case 'end':
                return _context48.stop();
            }
          }
        }, _callee48, this);
      }));

      function build(_x83) {
        return _ref61.apply(this, arguments);
      }

      return build;
    }()

    /**
     * If not specified version, remove all local versions.
     */

  }, {
    key: 'removeLocalVersion',
    value: function () {
      var _ref62 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee49(id, version) {
        var _this39 = this;

        var force = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        var component, localVersions, versionsToRemove, dependencyGraph;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee49$(_context49) {
          while (1) {
            switch (_context49.prev = _context49.next) {
              case 0:
                _context49.next = 2;
                return this.sources.get(id);

              case 2:
                component = _context49.sent;
                localVersions = component.getLocalVersions();

                if (localVersions.length) {
                  _context49.next = 6;
                  break;
                }

                return _context49.abrupt('return', Promise.reject(`unable to untag ${id}, the component is not staged`));

              case 6:
                if (!(version && !component.hasVersion(version))) {
                  _context49.next = 8;
                  break;
                }

                return _context49.abrupt('return', Promise.reject(`unable to untag ${id}, the version ${version} does not exist`));

              case 8:
                if (!(version && !localVersions.includes(version))) {
                  _context49.next = 10;
                  break;
                }

                return _context49.abrupt('return', Promise.reject(`unable to untag ${id}, the version ${version} was exported already`));

              case 10:
                versionsToRemove = version ? [version] : localVersions;

                if (force) {
                  _context49.next = 16;
                  break;
                }

                _context49.next = 14;
                return this.getDependencyGraph();

              case 14:
                dependencyGraph = _context49.sent;

                versionsToRemove.forEach(function (versionToRemove) {
                  var idWithVersion = id.clone();
                  idWithVersion.version = versionToRemove;
                  var dependents = dependencyGraph.getDependentsPerId(idWithVersion);
                  if (dependents.length) {
                    throw new Error(`unable to untag ${id}, the version ${versionToRemove} has the following dependent(s) ${dependents.join(', ')}`);
                  }
                });

              case 16:
                _context49.next = 18;
                return Promise.all(versionsToRemove.map(function (ver) {
                  return _this39.sources.removeVersion(component, ver, false);
                }));

              case 18:
                _context49.next = 20;
                return this.objects.persist();

              case 20:
                if (component.versionArray.length) {
                  _context49.next = 23;
                  break;
                }

                _context49.next = 23;
                return component.remove(this.objects);

              case 23:
                return _context49.abrupt('return', { id, versions: versionsToRemove });

              case 24:
              case 'end':
                return _context49.stop();
            }
          }
        }, _callee49, this);
      }));

      function removeLocalVersion(_x85, _x86) {
        return _ref62.apply(this, arguments);
      }

      return removeLocalVersion;
    }()
  }, {
    key: 'removeLocalVersionsForAllComponents',
    value: function () {
      var _ref63 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee50(version) {
        var _this40 = this;

        var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var components, candidateComponents, versionOutput, dependencyGraph, candidateComponentsIds, candidateComponentsIdsStr;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee50$(_context50) {
          while (1) {
            switch (_context50.prev = _context50.next) {
              case 0:
                _context50.next = 2;
                return this.objects.listComponents(false);

              case 2:
                components = _context50.sent;
                candidateComponents = components.filter(function (component) {
                  var localVersions = component.getLocalVersions();
                  if (!localVersions.length) return false;
                  return version ? localVersions.includes(version) : true;
                });

                if (candidateComponents.length) {
                  _context50.next = 7;
                  break;
                }

                versionOutput = version ? `${version} ` : '';
                return _context50.abrupt('return', Promise.reject(`No components found with local version ${versionOutput}to untag`));

              case 7:
                if (!(!force && version)) {
                  _context50.next = 14;
                  break;
                }

                _context50.next = 10;
                return this.getDependencyGraph();

              case 10:
                dependencyGraph = _context50.sent;
                candidateComponentsIds = candidateComponents.map(function (component) {
                  var bitId = component.toBitId();
                  bitId.version = version;
                  return bitId;
                });
                candidateComponentsIdsStr = candidateComponentsIds.map(function (id) {
                  return id.toString();
                });


                candidateComponentsIds.forEach(function (bitId) {
                  var dependents = dependencyGraph.getDependentsPerId(bitId);
                  var dependentsNotCandidates = dependents.filter(function (dependent) {
                    return !candidateComponentsIdsStr.includes(dependent);
                  });
                  if (dependentsNotCandidates.length) {
                    throw new Error(`unable to untag ${bitId}, the version ${version} has the following dependent(s) ${dependents.join(', ')}`);
                  }
                });

              case 14:

                (_logger || _load_logger()).default.debug(`found ${candidateComponents.length} components to untag`);
                return _context50.abrupt('return', Promise.all(candidateComponents.map(function (component) {
                  return _this40.removeLocalVersion(component.toBitId(), version, true);
                })));

              case 16:
              case 'end':
                return _context50.stop();
            }
          }
        }, _callee50, this);
      }));

      function removeLocalVersionsForAllComponents(_x88) {
        return _ref63.apply(this, arguments);
      }

      return removeLocalVersionsForAllComponents;
    }()

    /**
     * import a component end to end. Including importing the dependencies and installing the npm
     * packages.
     *
     * @param {string} bitId - the component id to isolate
     * @param {IsolateOptions} opts
     * @return {Promise.<string>} - the path to the isolated component
     */

  }, {
    key: 'isolateComponent',
    value: function () {
      var _ref64 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee51(bitId, opts) {
        var parsedId, component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee51$(_context51) {
          while (1) {
            switch (_context51.prev = _context51.next) {
              case 0:
                parsedId = (_bitId || _load_bitId()).BitId.parse(bitId);
                _context51.next = 3;
                return this.loadComponent(parsedId);

              case 3:
                component = _context51.sent;
                return _context51.abrupt('return', component.isolate(this, opts));

              case 5:
              case 'end':
                return _context51.stop();
            }
          }
        }, _callee51, this);
      }));

      function isolateComponent(_x89, _x90) {
        return _ref64.apply(this, arguments);
      }

      return isolateComponent;
    }()
  }, {
    key: 'groupName',
    get: function get() {
      if (!this.scopeJson.groupName) return null;
      return this.scopeJson.groupName;
    }
  }, {
    key: 'name',
    get: function get() {
      return this.scopeJson.name;
    }
  }], [{
    key: 'getComponentsRelativePath',
    value: function getComponentsRelativePath() {
      return (_constants || _load_constants()).BITS_DIRNAME;
    }

    /**
     * Get a relative (to scope) path to a specific component such as compiler / tester / extension
     * @param {BitId} id
     */

  }, {
    key: 'getComponentRelativePath',
    value: function getComponentRelativePath(id) {
      return (_path || _load_path()).join(id.box, id.name, id.scope, id.version);
    }
  }, {
    key: 'ensure',
    value: function ensure() {
      var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();
      var name = arguments[1];
      var groupName = arguments[2];

      if (pathHasScope(path)) return this.load(path);
      if (!name) name = (0, (_utils || _load_utils()).currentDirName)();
      var scopeJson = new (_scopeJson || _load_scopeJson()).ScopeJson({ name, groupName, version: (_constants || _load_constants()).BIT_VERSION });
      return Promise.resolve(new Scope({ path, created: true, scopeJson }));
    }
  }, {
    key: 'load',
    value: function load(absPath) {
      var scopePath = (0, (_utils || _load_utils()).propogateUntil)(absPath, pathHasScope);
      if (!scopePath) throw new (_exceptions || _load_exceptions()).ScopeNotFound();
      if ((_fsExtra || _load_fsExtra()).default.existsSync((_path || _load_path()).join(scopePath, (_constants || _load_constants()).BIT_HIDDEN_DIR))) {
        scopePath = (_path || _load_path()).join(scopePath, (_constants || _load_constants()).BIT_HIDDEN_DIR);
      }
      var path = scopePath;

      return (0, (_utils || _load_utils()).readFile)((0, (_scopeJson || _load_scopeJson()).getPath)(scopePath)).then(function (rawScopeJson) {
        var scopeJson = (_scopeJson || _load_scopeJson()).ScopeJson.loadFromJson(rawScopeJson.toString());
        return new Scope({ path, scopeJson });
      });
    }
  }]);

  return Scope;
}();

exports.default = Scope;
//# sourceMappingURL=scope.js.map