'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SourcesMap = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.getPath = getPath;

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

var _utils;

function _load_utils() {
  return _utils = require('../utils');
}

var _scope;

function _load_scope() {
  return _scope = _interopRequireDefault(require('./scope'));
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../consumer/component'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _extendableBuiltin(cls) {
  function ExtendableBuiltin() {
    var instance = Reflect.construct(cls, Array.from(arguments));
    Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
    return instance;
  }

  ExtendableBuiltin.prototype = Object.create(cls.prototype, {
    constructor: {
      value: cls,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });

  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(ExtendableBuiltin, cls);
  } else {
    ExtendableBuiltin.__proto__ = cls;
  }

  return ExtendableBuiltin;
}

function getPath(scopePath) {
  return (_path || _load_path()).default.join(scopePath, (_constants || _load_constants()).SOURCES_MAP);
}

var SourcesMap = exports.SourcesMap = function (_extendableBuiltin2) {
  _inherits(SourcesMap, _extendableBuiltin2);

  function SourcesMap(scope) {
    var dependencyTuples = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

    _classCallCheck(this, SourcesMap);

    var _this = _possibleConstructorReturn(this, (SourcesMap.__proto__ || Object.getPrototypeOf(SourcesMap)).call(this, dependencyTuples));

    _this.scope = scope;
    return _this;
  }

  _createClass(SourcesMap, [{
    key: 'get',
    value: function get(bitId) {
      return _get(SourcesMap.prototype.__proto__ || Object.getPrototypeOf(SourcesMap.prototype), 'get', this).call(this, bitId.toStringWithoutScope());
    }

    // $FlowFixMe

  }, {
    key: 'delete',
    value: function _delete(bitId) {
      _get(SourcesMap.prototype.__proto__ || Object.getPrototypeOf(SourcesMap.prototype), 'delete', this).call(this, bitId.toStringWithoutScope());
      return this;
    }
  }, {
    key: 'toObject',
    value: function toObject() {
      var obj = {};
      this.forEach(function (bitIds, bitId) {
        obj[bitId.toStringWithoutScope()] = bitIds.map(function (dependency) {
          return dependency.toString();
        });
      });
      return obj;
    }
  }, {
    key: 'getPath',
    value: function getPath() {
      return (_path || _load_path()).default.join(this.scope.getPath(), (_constants || _load_constants()).SOURCES_MAP);
    }
  }, {
    key: 'write',
    value: function write() {
      return (0, (_utils || _load_utils()).writeFile)(this.getPath(), JSON.stringify(this.toObject()));
    }
  }], [{
    key: 'load',
    value: function load(json, scope) {
      var matrix = [];
      (0, (_utils || _load_utils()).forEach)(json, function (val, key) {
        matrix.push([key, val.map(function (bitDep) {
          return (_bitId || _load_bitId()).BitId.parse(bitDep);
        })]);
      });

      return new SourcesMap(scope, matrix);
    }
  }]);

  return SourcesMap;
}(_extendableBuiltin(Map));