"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = flatten;


/**
 * flatten arrays to a single dimension.
 * @name flatten
 * @param {[[*]]} arrays
 * @returns [*] a flatten array
 * @example
 * ```js
 *  flatten([[1], [2], [3]]) // => [1, 2, 3]
 * ```
 */
function flatten(arrays) {
  var concat = [].concat;
  return concat.apply([], arrays);
}