'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = findFile;

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _parents;

function _load_parents() {
  return _parents = _interopRequireDefault(require('parents'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Taken from this package (with some minor changes):
 * https://www.npmjs.com/package/find-package
 * https://github.com/jalba/find-package
 *
 */
function searchFileRecursively(dir, fileToFind) {
  var parentsArr = (0, (_parents || _load_parents()).default)(dir);
  var i = void 0;
  for (i = 0; i < parentsArr.length; i++) {
    var config = `${parentsArr[i]}/${fileToFind}`;
    try {
      if ((_fsExtra || _load_fsExtra()).default.lstatSync(config).isFile()) {
        return config;
      }
    } catch (e) {}
  }
  return null;
}

/**
 * Taken from this package (with some minor changes):
 * https://www.npmjs.com/package/find-package
 * https://github.com/jalba/find-package
 *
 */
function findFile(dir, fileToFind) {
  var pathToFile = searchFileRecursively(dir, fileToFind);
  return pathToFile;
}