'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = outputFile;

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function outputFile(_ref) {
  var filePath = _ref.filePath,
      content = _ref.content,
      _ref$writeAutoGenerat = _ref.writeAutoGeneratedMessage,
      writeAutoGeneratedMessage = _ref$writeAutoGenerat === undefined ? true : _ref$writeAutoGenerat,
      _ref$override = _ref.override,
      override = _ref$override === undefined ? true : _ref$override;

  return new Promise(function (resolve, reject) {
    if (!override && (_fsExtra || _load_fsExtra()).default.existsSync(filePath)) {
      var fileContent = (_fsExtra || _load_fsExtra()).default.readFileSync(filePath).toString();
      if (!fileContent.includes((_constants || _load_constants()).AUTO_GENERATED_STAMP)) return resolve(filePath);
    }
    var data = writeAutoGeneratedMessage ? (_constants || _load_constants()).AUTO_GENERATED_MSG + content : content;
    (_fsExtra || _load_fsExtra()).default.outputFile(filePath, data, function (err) {
      if (err) return reject(err);
      return resolve(filePath);
    });
  });
}