'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = removeFile;

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function removeFile(path) {
  var propogateDirs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  return new Promise(function (resolve, reject) {
    (_fsExtra || _load_fsExtra()).default.unlink(path, function (err, res) {
      if (err) return reject(err);
      if (propogateDirs) {
        var _pathlib$parse = (_path || _load_path()).default.parse(path),
            dir = _pathlib$parse.dir;

        (_fsExtra || _load_fsExtra()).default.readdir(dir, function (e, files) {
          if (e) return reject(err);
          if (files.length !== 0) return resolve(res);
          return (_fsExtra || _load_fsExtra()).default.remove(dir, function (error) {
            if (err) return reject(error);
            resolve(res);
          });
        });
      } else {
        return resolve(res);
      }
    });
  });
}