'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = currentDirName;

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * get the current working dir name.
 * @name currentDirName
 * @returns {string} current working dir name
 * @example
 * ```js
 *  currentDirName() // => 'bit'
 * ```
 */
function currentDirName() {
  var currentDir = process.cwd();
  return (_path || _load_path()).default.basename(currentDir);
}