'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = retrieveIgnoreList;

var _parseGitignore;

function _load_parseGitignore() {
  return _parseGitignore = _interopRequireDefault(require('parse-gitignore'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _index;

function _load_index() {
  return _index = require('../index');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getGitIgnoreFile(dir) {
  var gitIgnoreFile = (0, (_index || _load_index()).findFile)(dir, (_constants || _load_constants()).GIT_IGNORE);
  return gitIgnoreFile ? (0, (_parseGitignore || _load_parseGitignore()).default)(gitIgnoreFile) : [];
}

function retrieveIgnoreList(cwd) {
  var ignoreList = getGitIgnoreFile(cwd).concat((_constants || _load_constants()).IGNORE_LIST);
  return ignoreList;
}