'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = values;

var _foreach;

function _load_foreach() {
  return _foreach = _interopRequireDefault(require('./foreach'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * get all object values.
 * @name values
 * @param {object} object
 * @returns {[]} object's values
 * @example
 * ```js
 *  values({ a: 1, b: 2, c: 3 }) // => [1, 2, 3]
 * ```
 */
function values(object) {
  var objValues = [];
  // $FlowFixMe
  (0, (_foreach || _load_foreach()).default)(object, function (val) {
    return objValues.push(val);
  });
  return objValues;
}