'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pathJoinLinux = pathJoinLinux;
exports.pathNormalizeToLinux = pathNormalizeToLinux;
exports.pathRelativeLinux = pathRelativeLinux;
exports.pathResolveToLinux = pathResolveToLinux;

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _normalizePath;

function _load_normalizePath() {
  return _normalizePath = _interopRequireDefault(require('normalize-path'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// OS based format. On Windows it's Windows format, on Linux it's Linux format.

// Linux format path (even when running on Windows)

function pathJoinLinux() {
  return (0, (_normalizePath || _load_normalizePath()).default)((_path || _load_path()).default.join.apply((_path || _load_path()).default, arguments));
}
function pathNormalizeToLinux(pathToNormalize) {
  return pathToNormalize ? (0, (_normalizePath || _load_normalizePath()).default)(pathToNormalize) : pathToNormalize;
}
function pathRelativeLinux(from, to) {
  return (0, (_normalizePath || _load_normalizePath()).default)((_path || _load_path()).default.relative(from, to));
}
function pathResolveToLinux(arr) {
  return (0, (_normalizePath || _load_normalizePath()).default)((_path || _load_path()).default.resolve(arr.join(',')));
}