'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = cleanBang;

var _cleanChar;

function _load_cleanChar() {
  return _cleanChar = _interopRequireDefault(require('./clean-char'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * remove first bang (!) from `str`
 * @name cleanBang
 * @param {string} str string to manipulate
 * @returns {string} string without first found bang
 * @example
 * ```js
 *  cleanBang('!bang') // =>  'bang'
 * ```
 */
function cleanBang(str) {
  return (0, (_cleanChar || _load_cleanChar()).default)(str, '!');
}