'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fromBase64;


/**
 * decode a base64 string
 * @name fromBase64
 * @param {string} base64 base64 string to decode
 * @returns {string} decoded string
 * @example
 * ```js
 *  fromBase64('aGVsbG8gd29ybGQ=') // => 'hello world'
 * ```
 */
function fromBase64(base64) {
  return new Buffer(base64, 'base64').toString();
}