import init from './lib/init';
import isolate from './lib/isolate';
import remove from './lib/remove';
import deprecate from './lib/deprecate';
import listScope from './lib/list-scope';
import { commitAction, commitAllAction } from './lib/commit';
import status from './lib/status';
import { build, buildAll } from './lib/build';
import reset from './lib/reset';
import importAction from './lib/import';
import installAction from './lib/install';
import exportAction from './lib/export';
import getConsumerComponent from './lib/get-consumer-component';
import getScopeComponent from './lib/get-scope-component';
import test from './lib/test';
import getComponentLogs from './lib/get-component-logs';
import { add as remoteAdd, list as remoteList, remove as remoteRm } from './lib/remote';
import config from './lib/global-config';
import getDriver from './lib/get-driver';
import { watchAll } from './lib/watch';
import add from './lib/add';
import untrack from './lib/untrack';
import { unTagAction, unTagAllAction } from './lib/untag';
import move from './lib/move';
import link from './lib/link';
import migrate from './lib/migrate';

export {
  init,
  isolate,
  config,
  exportAction,
  remove,
  deprecate,
  buildAll,
  listScope,
  commitAction,
  commitAllAction,
  status,
  build,
  reset,
  importAction,
  installAction,
  getConsumerComponent,
  getScopeComponent,
  getComponentLogs,
  test,
  remoteAdd,
  remoteList,
  remoteRm,
  getDriver,
  watchAll,
  add,
  untrack,
  unTagAction,
  unTagAllAction,
  move,
  link,
  migrate
};
