/** @flow */
import fs from 'fs';
import { AUTO_GENERATED_STAMP } from '../constants';
import type { PathOsBased } from './path';
/**
 * check if file was auto generated by bit
 *
 * @param {string} filePath - consumer path
 * @returns {boolean}
 */
export default function existsSync(filePath: PathOsBased): Boolean {
  const fileContent = fs.readFileSync(filePath).toString();
  return fileContent.includes(AUTO_GENERATED_STAMP);
}
